package com.SgwMiniSetup.common;

import java.awt.Graphics;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
 
/**
 * This is an extended version of a JLabel which draws its icon image using
 * the ImageDrawer utility.
 *
 * @author www.codejava.net
 *
 */
public class ScaledImageButton extends JButton {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public ScaledImageButton(Icon icon) {
		super(icon);
	}
	
    protected void paintComponent(Graphics g) {
        ImageIcon icon = (ImageIcon) getIcon();
        if (this.getModel().isPressed()) {
        	icon = (ImageIcon) getPressedIcon();
        } else if (this.getModel().isRollover()) {
        	icon = (ImageIcon) getRolloverIcon();
        } else if (this.getModel().isSelected()) {
        	icon = (ImageIcon) getSelectedIcon();
        }
        if (icon != null) {
            ImageDrawer.drawScaledImage(icon.getImage(), this, g);
        }
    }
}