package com.SgwMiniSetup.sample;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.table.DefaultTableCellRenderer;

/**
 * 
 * JTableで各セルを描画 (表示) するためのクラス。
 *  
 */
public class SearchResultTableCellRenderer extends DefaultTableCellRenderer {
    
    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static final Color RAW_BACK_COLOR_0 = Color.WHITE;
    private static final Color RAW_BACK_COLOR_1 = Color.YELLOW;
    private static final Color RAW_BACK_COLOR_2 = new Color(60, 105, 195);
    private static final Color RAW_FORE_COLOR_0 = Color.BLACK;
    private static final Color RAW_FORE_COLOR_1 = Color.WHITE;
    
    private JTable myTable;
	
    
//	/**
//	 * 
//	 * コンストラクタ
//	 * 
//	 */
//	public SearchResultTableCellRenderer() {
//        super();
//		//this.setHorizontalAlignment(JLabel.CENTER);		// 中央揃えにする
//	}
	
	/**
	 * 
	 * テーブルのセルレンダラを取得します。（オーバーライド）
	 * 
	 */
	public Component getTableCellRendererComponent (
			JTable table,
			Object value,
			boolean isSelected,
			boolean hasFocus,
			int row,
			int column) {

        //テーブルモデルのチェックボックスが編集不可の場合、行の背景色の変更
		SortDecorator sortModel = (SortDecorator) table.getModel();
		SearchResultTableModel model = (SearchResultTableModel) sortModel.getTableModel();
		//if (!model.getCellEnabled(row , 2)) {
		if (!isSelected) {
	        if ((((Boolean) sortModel.getValueAt(row, 2)).booleanValue())){
	            setBackground(RAW_BACK_COLOR_1);
	            setForeground(RAW_FORE_COLOR_0);
	        } else {
	        	setBackground(RAW_BACK_COLOR_0);
	        	setForeground(RAW_FORE_COLOR_0);
	        }
		} else {
			setBackground(RAW_BACK_COLOR_2);
			setForeground(RAW_FORE_COLOR_1);
		}
		
        myTable = table;
		if (value instanceof Boolean) {
            JCheckBox chkBox = new JCheckBox();
            chkBox.setSelected(((Boolean) value).booleanValue());
            chkBox.addChangeListener(new ChangeListener() {
            	public void stateChanged(ChangeEvent e) {
            		if (myTable != null) {
            			myTable.repaint();
            		}
            	}
            });

            //テーブルモデルのチェックボックスが編集不可の場合、チェックボックス背景色の変更
            if (!isSelected) {
	            //if (!model.getCellEnabled(row , column)){
	            if (((Boolean) value).booleanValue()){
	            	chkBox.setBackground(RAW_BACK_COLOR_1);
	            }else{
	            	chkBox.setBackground(RAW_BACK_COLOR_0);
	            }
            } else {
            	chkBox.setBackground(RAW_BACK_COLOR_2);
            }
            
            return chkBox;
            
        } else if (value instanceof Integer) {
            setValue(value);
        } else {
            setValue((String) value);
        }
        
		return (this);
	}
} // end ValidationResultTableCellRenderer

