package com.SgwMiniSetup.sample;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSeparator;
import javax.swing.SwingConstants;
import javax.swing.border.Border;

import com.SgwMiniSetup.common.CommonFunc;
import com.SgwSetting.common.CommonParam;
import com.SgwSetting.smartgateway.SearchSgwIpAddress;

/**
 * スマートゲートウェイ 簡単セットアップGUI(PC版) - スマートゲートウェイの検索ダイアログ(成功)
 *
 * @author Copyright (c) 2013 Enegate Co, ltd.
 * @version 1.00
 */
public class SearchSuccessDialog extends JDialog implements ActionListener {
	/**
	 * アプリの定数
	 */
	private static final long serialVersionUID = 1L;

	// ========================================================================================================
	// 各パネルの設定値
	// ========================================================================================================
	private JFrame frame; // 親フレーム情報
	private String sgw_ip; // スマートゲートウェイのIP

	private final static String DIALOG_SEARCH_SUCCESS_TITLE = "検索結果"; // タイトル
	private final static String DIALOG_SEARCH_RESULT_DELIMITER = "　/　"; // タイトル
	private final static int DIALOG_SEARCH_SUCCESS_WIDTH = 440; // 幅
	private final static int DIALOG_SEARCH_SUCCESS_HEIGHT = 200; // 高さ

	private final static Color DIALOG_SEARCH_SUCCESS_BG_COLOR = new Color(0, 0, 0); // 背景色(黒系:#000000)
	private final static Color DIALOG_SEARCH_SUCCESS_BORDER_COLOR = new Color(255, 255, 255); // 枠線色(白系:#FFFFFF)
	private final static Color DIALOG_SEARCH_SUCCESS_FONT_COLOR = new Color(255, 255, 255); // 文字色(白系:#FFFFFF)

	// 枠線の太さ
	private final static int DIALOG_SEARCH_SUCCESS_BORDER_WEIGHT_INSIDE = 0; // 内側
	private final static int DIALOG_SEARCH_SUCCESS_BORDER_WEIGHT_OUTSIDE = 2; // 外側

	// 文字の種別
	private final static String DIALOG_SEARCH_SUCCESS_FONT_STYLE_TITLE = Font.SANS_SERIF; // タイトル
	private final static String DIALOG_SEARCH_SUCCESS_FONT_STYLE_MSG1 = Font.SANS_SERIF; // 本文1
	private final static String DIALOG_SEARCH_SUCCESS_FONT_STYLE_MSG2 = Font.SANS_SERIF; // 本文2

	// 文字の太さ
	private final static int DIALOG_SEARCH_SUCCESS_FONT_WEIGHT_TITLE = Font.BOLD; // タイトル
	private final static int DIALOG_SEARCH_SUCCESS_FONT_WEIGHT_MSG1 = Font.BOLD; // 本文1
	private final static int DIALOG_SEARCH_SUCCESS_FONT_WEIGHT_MSG2 = Font.BOLD; // 本文2

	// 文字のサイズ
	private final static int DIALOG_SEARCH_SUCCESS_FONT_SIZE_TITLE = 18; // タイトル
	private final static int DIALOG_SEARCH_SUCCESS_FONT_SIZE_MSG1 = 14; // 本文1
	private final static int DIALOG_SEARCH_SUCCESS_FONT_SIZE_MSG2 = 12; // 本文2

	// ========================================================================================================
	// コンポーネント配置(単位：ピクセル)
	// ========================================================================================================
	// パネル
	private final static int POS_DIALOG_SEARCH_SUCCESS_PANEL_X = 5; // X座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_PANEL_Y = 5; // Y座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_PANEL_WIDTH = 430; // 幅
	private final static int POS_DIALOG_SEARCH_SUCCESS_PANEL_HEIGHT = 190; // 高さ

	// タイトルのアイコン画像
	private final static int POS_DIALOG_SEARCH_SUCCESS_ICON_X = 10; // X座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_ICON_Y = 10; // Y座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_ICON_WIDTH = 32; // 幅
	private final static int POS_DIALOG_SEARCH_SUCCESS_ICON_HEIGHT = 32; // 高さ

	// タイトル
	private final static int POS_DIALOG_SEARCH_SUCCESS_TITLE_X = 50; // X座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_TITLE_Y = 10; // Y座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_TITLE_WIDTH = 200; // 幅
	private final static int POS_DIALOG_SEARCH_SUCCESS_TITLE_HEIGHT = 32; // 高さ

	// 区切り線
	private final static int POS_DIALOG_SEARCH_SUCCESS_SEPARATOR_X = 5; // X座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_SEPARATOR_Y = 50; // Y座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_SEPARATOR_WIDTH = 420; // 幅
	private final static int POS_DIALOG_SEARCH_SUCCESS_SEPARATOR_HEIGHT = 15; // 高さ

	// メッセージ1
	private final static int POS_DIALOG_SEARCH_SUCCESS_MSG1_X = 36; // X座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_MSG1_Y = 65; // Y座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_MSG1_WIDTH = 430; // 幅
	private final static int POS_DIALOG_SEARCH_SUCCESS_MSG1_HEIGHT = 20; // 高さ
	//private final static int POS_DIALOG_SEARCH_SUCCESS_MSG1_ALIGN = JLabel.CENTER; // 位置
	private final static String DIALOG_SEARCH_SUCCESS_MSG1 = "スマートゲートウェイが見つかりました"; // 文言

	// メッセージ2
	private final static int POS_DIALOG_SEARCH_SUCCESS_MSG2_X = 30; // X座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_MSG2_Y = 95; // Y座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_MSG2_WIDTH = 430; // 幅
	private final static int POS_DIALOG_SEARCH_SUCCESS_MSG2_HEIGHT = 20; // 高さ
	private final static int POS_DIALOG_SEARCH_SUCCESS_MSG2_ALIGN = JLabel.CENTER; // 位置
//	private final static String DIALOG_SEARCH_SUCCESS_MSG2 = "　IPアドレス："; // 文言
//	private final static String DIALOG_SEARCH_SUCCESS_ID_MSG2 = "　製造番号："; // 文言
	private final static String ZENKAKU_SPACE = "　"; // 文言

	// 確認ボタン
	private final static int POS_DIALOG_SEARCH_SUCCESS_BTN_CONFIRM_X = 170; // X座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_BTN_CONFIRM_Y = 130; // Y座標
	private final static int POS_DIALOG_SEARCH_SUCCESS_BTN_CONFIRM_WIDTH = 94; // 幅
	private final static int POS_DIALOG_SEARCH_SUCCESS_BTN_CONFIRM_HEIGHT = 49; // 高さ

	// ========================================================================================================
	// 画像リソース
	// ========================================================================================================
	private final static String IMG_ICON_RESULT_SUCCESS = "res/img/icon_result_success.png"; // 成功アイコン
	private final static String IMG_BUTTON_CONFIRM_ON = "res/img/btn_confirm_on.png"; // 確認ボタン
	private final static String IMG_BUTTON_CONFIRM_OFF = "res/img/btn_confirm_off.png"; // 確認ボタン

	// ========================================================================================================
	//  SGWの検索結果情報(IPと製造番号)を格納したファイル
	// ========================================================================================================
	//private final static String FILE_SEARCH_SGW_PATH = "res/file/search_sgw.txt";
	private final static String FILE_SEARCH_SGW_PATH = SgwMiniSetup.FILE_SEARCH_SGW_PATH;

	// ========================================================================================================
	// SGW複数検出対応
	// ========================================================================================================

	// 検出したSGW情報(IP,製造番号)を格納したMapのサイズ
	int mapSize = 0;

	// 検出したSGW毎に表示するラジオボタン
	List<JRadioButton> radioBtnList = new ArrayList<JRadioButton>();

	// 選択されたSGW情報
	String selectedSgwInfo = "";

	/**
	 * コンストラクタ
	 *
	 * @param JFrame
	 *            frame
	 * @param CardLayout
	 *            layout
	 * @param JPanel
	 *            panelBase
	 * @param String
	 *            success_panel_name
	 * @param String
	 *            error_panel_name
	 */

	SearchSuccessDialog(JFrame frame, Map<String, String> smartGatewayInfoMap) {

		// ========================================================================================================
		// 初期化
		// ========================================================================================================
		// 親フレーム継承
		super(frame);

		// ========================================================================================================
		// SGW複数検出対応
		// ========================================================================================================
		mapSize = smartGatewayInfoMap.size();

		/* Y軸調整 */
		int additionalY_axis = 0;
		if (mapSize >= 2) {
			//SGW検出件数が2件以上の場合、Y座標に15ピクセル（掛ける件数分）を加算。
			additionalY_axis = (mapSize - 1) * 15;
		}

		// ========================================================================================================
		// 各ダイアログ共通の処理
		// ========================================================================================================
		setTitle(DIALOG_SEARCH_SUCCESS_TITLE);
		setSize(DIALOG_SEARCH_SUCCESS_WIDTH, DIALOG_SEARCH_SUCCESS_HEIGHT + additionalY_axis); // 幅、高さ
		getContentPane().setBackground(DIALOG_SEARCH_SUCCESS_BG_COLOR); // 背景色
		setLayout(null); // レイアウト無し
		setResizable(false); // フレームのサイズを固定
		setUndecorated(true); // タイトルバー無し
		setLocationRelativeTo(frame); // 親フレームの画面中央に表示
		setModal(true); // モーダル化

		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		// ========================================================================================================
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// X座標、Y座標、幅、高さをセット
		panel.setBounds(POS_DIALOG_SEARCH_SUCCESS_PANEL_X, POS_DIALOG_SEARCH_SUCCESS_PANEL_Y,
				POS_DIALOG_SEARCH_SUCCESS_PANEL_WIDTH, POS_DIALOG_SEARCH_SUCCESS_PANEL_HEIGHT + additionalY_axis);

		// 背景色
		panel.setBackground(DIALOG_SEARCH_SUCCESS_BG_COLOR);

		// 外側の枠線の太さ、内側の枠線の太さをセット
		Border outside = BorderFactory.createMatteBorder(
				DIALOG_SEARCH_SUCCESS_BORDER_WEIGHT_OUTSIDE, DIALOG_SEARCH_SUCCESS_BORDER_WEIGHT_OUTSIDE,
				DIALOG_SEARCH_SUCCESS_BORDER_WEIGHT_OUTSIDE, DIALOG_SEARCH_SUCCESS_BORDER_WEIGHT_OUTSIDE,
				DIALOG_SEARCH_SUCCESS_BORDER_COLOR);
		Border inside = BorderFactory.createEmptyBorder(
				DIALOG_SEARCH_SUCCESS_BORDER_WEIGHT_INSIDE, DIALOG_SEARCH_SUCCESS_BORDER_WEIGHT_INSIDE,
				DIALOG_SEARCH_SUCCESS_BORDER_WEIGHT_INSIDE, DIALOG_SEARCH_SUCCESS_BORDER_WEIGHT_INSIDE);
		panel.setBorder(BorderFactory.createCompoundBorder(outside, inside));

		getContentPane().add(panel);

		// ========================================================================================================
		// コンポーネント作成
		// ========================================================================================================
		// 検索結果アイコン画像
		ImageIcon icon = new ImageIcon(this.getClass().getClassLoader()
				.getResource(IMG_ICON_RESULT_SUCCESS));
		JLabel label_icon = new JLabel(icon);
		label_icon.setBounds(POS_DIALOG_SEARCH_SUCCESS_ICON_X, POS_DIALOG_SEARCH_SUCCESS_ICON_Y,
				POS_DIALOG_SEARCH_SUCCESS_ICON_WIDTH, POS_DIALOG_SEARCH_SUCCESS_ICON_HEIGHT);
		panel.add(label_icon);

		// タイトル
		JLabel label_title = new JLabel(DIALOG_SEARCH_SUCCESS_TITLE);
		label_title.setBounds(POS_DIALOG_SEARCH_SUCCESS_TITLE_X, POS_DIALOG_SEARCH_SUCCESS_TITLE_Y,
				POS_DIALOG_SEARCH_SUCCESS_TITLE_WIDTH, POS_DIALOG_SEARCH_SUCCESS_TITLE_HEIGHT);
		label_title.setFont(new Font(DIALOG_SEARCH_SUCCESS_FONT_STYLE_TITLE,
				DIALOG_SEARCH_SUCCESS_FONT_WEIGHT_TITLE, DIALOG_SEARCH_SUCCESS_FONT_SIZE_TITLE));
		label_title.setForeground(DIALOG_SEARCH_SUCCESS_FONT_COLOR);
		panel.add(label_title);

		// 区切り線
		JSeparator separator = new JSeparator(SwingConstants.HORIZONTAL);
		separator.setBounds(POS_DIALOG_SEARCH_SUCCESS_SEPARATOR_X, POS_DIALOG_SEARCH_SUCCESS_SEPARATOR_Y,
				POS_DIALOG_SEARCH_SUCCESS_SEPARATOR_WIDTH, POS_DIALOG_SEARCH_SUCCESS_SEPARATOR_HEIGHT);
		panel.add(separator);

		// メッセージ1
		JLabel label_explanation1 = new JLabel(DIALOG_SEARCH_SUCCESS_MSG1);
		label_explanation1.setBounds(POS_DIALOG_SEARCH_SUCCESS_MSG1_X, POS_DIALOG_SEARCH_SUCCESS_MSG1_Y,
				POS_DIALOG_SEARCH_SUCCESS_MSG1_WIDTH, POS_DIALOG_SEARCH_SUCCESS_MSG1_HEIGHT);
		label_explanation1.setFont(new Font(
				DIALOG_SEARCH_SUCCESS_FONT_STYLE_MSG1, DIALOG_SEARCH_SUCCESS_FONT_WEIGHT_MSG1,
				DIALOG_SEARCH_SUCCESS_FONT_SIZE_MSG1));
		label_explanation1.setForeground(DIALOG_SEARCH_SUCCESS_FONT_COLOR);

		panel.add(label_explanation1);

		/*スマートゲートウェイ情報*/
		Iterator<Entry<String, String>> entries = smartGatewayInfoMap.entrySet().iterator();
		List<String> smartGatewayInformationList = new ArrayList<String>();

		/*スマートゲートウェイ情報をリストに詰め直す*/
		while (entries.hasNext()) {
			Map.Entry<String, String> entry = (Map.Entry<String, String>) entries.next();
			smartGatewayInformationList.add(entry.toString());
		}

		// メッセージ2
		if (mapSize > 0) {

			/* ラジオボタングループ*/
			ButtonGroup btnGroup = new ButtonGroup();

			int replacedListSize = smartGatewayInformationList.size();

			/*詰め直したスマートゲートウェイ情報リストから必要な形式に加工する*/
			for (int i = 0; i < replacedListSize; i++) {

				/*IPアドレス・製造番号分割*/
				String oneOfSgwInformation = smartGatewayInformationList.get(i).toString();
				String sgwIP = "（不明）";
				String sgwID = "（不明）";
				try {
					String smartGetwayInfoArray[] = oneOfSgwInformation.split("=", 0);
					sgwIP = smartGetwayInfoArray[0];
					sgwID = smartGetwayInfoArray[1];
				} catch (Exception e) {

				}

				/*IPアドレス最大文字列長(15)と取得したIPの差を取得*/
				int reguralength = 15;
				reguralength = reguralength - sgwIP.length();

				String space = DIALOG_SEARCH_RESULT_DELIMITER;

				/* ラジオボタン作成 */
				if (i == 0) {
					radioBtnList.add(new JRadioButton(CommonParam.IP_ADDRESS_LBL + "[" + sgwIP + "]" + space + CommonParam.SERIAL_NUMBER_LBL + "[" + sgwID + "]" + ZENKAKU_SPACE, true));

				} else {
					radioBtnList.add(new JRadioButton(CommonParam.IP_ADDRESS_LBL + "[" + sgwIP + "]" + space + CommonParam.SERIAL_NUMBER_LBL + "[" + sgwID + "]" + ZENKAKU_SPACE));
				}

				/* 背景を透明に設定 */
				radioBtnList.get(i).setOpaque(false);

				/* 表示位置 */
				radioBtnList.get(i).setBounds(POS_DIALOG_SEARCH_SUCCESS_MSG2_X, POS_DIALOG_SEARCH_SUCCESS_MSG2_Y + 15 * (i),
						400, POS_DIALOG_SEARCH_SUCCESS_MSG2_HEIGHT);

				/* 文字の種別・太さ・サイズ */
				radioBtnList.get(i).setFont(
						new Font(DIALOG_SEARCH_SUCCESS_FONT_STYLE_MSG2, DIALOG_SEARCH_SUCCESS_FONT_WEIGHT_MSG2, DIALOG_SEARCH_SUCCESS_FONT_SIZE_MSG2));

				/* 文字色：白系 */
				radioBtnList.get(i).setForeground(DIALOG_SEARCH_SUCCESS_FONT_COLOR);

				/* グループ化 */
				btnGroup.add(radioBtnList.get(i));

				/* ラジオボタン追加 */
				panel.add(radioBtnList.get(i));
			}
		}

		// 確認ボタン
		ImageIcon icon_confirm = new ImageIcon(this.getClass().getClassLoader()
				.getResource(IMG_BUTTON_CONFIRM_OFF));
		ImageIcon rollover_confirm = new ImageIcon(this.getClass()
				.getClassLoader().getResource(IMG_BUTTON_CONFIRM_ON));
		JButton btn_confirm = new JButton(icon_confirm);
		btn_confirm.setRolloverIcon(rollover_confirm);
		btn_confirm.setPressedIcon(rollover_confirm);

		/* SGWの複数検索に対応 */
		btn_confirm.setBounds(POS_DIALOG_SEARCH_SUCCESS_BTN_CONFIRM_X, POS_DIALOG_SEARCH_SUCCESS_BTN_CONFIRM_Y + additionalY_axis,
				POS_DIALOG_SEARCH_SUCCESS_BTN_CONFIRM_WIDTH, POS_DIALOG_SEARCH_SUCCESS_BTN_CONFIRM_HEIGHT);
		btn_confirm.setBorderPainted(false);
		btn_confirm.setContentAreaFilled(false);
		btn_confirm.addActionListener(this);
		btn_confirm.setActionCommand("OK");
		panel.add(btn_confirm);
	}

	/**
	 * アクションのイベント設定
	 *
	 * @param ActionEvent
	 *            e イベント情報
	 */
	public void actionPerformed(ActionEvent e) {
		// コマンド名を取得
		String cmd = e.getActionCommand();

		// 確認ボタンを押したら閉じる
		if (cmd.equals("OK")) {

			/*選択状態のスマートゲートウェイのIP*/
			String selectedSgwIp = "";
			String selectedSgwSerialNo = "";

			for (int j = 0; j < mapSize; j++) {
				if (radioBtnList.get(j).isSelected()) {

					/*選択されたスマートゲートウェイ情報を保持*/
					selectedSgwInfo = radioBtnList.get(j).getText();
					System.out.println("選択したラジオボタン" + selectedSgwInfo);

					/*不要記号情報等を削除*/
					//selectedSgwIp = selectedSgwInfo.replaceAll(CommonParam.IP_ADDRESS_LBL + "\\[", "");
					String tempSelectedSgwIp = selectedSgwInfo.replaceAll(CommonParam.IP_ADDRESS_LBL + "\\[", "");

					/*IP部分のみを保持*/
					int index = tempSelectedSgwIp.indexOf("]");
					selectedSgwIp = tempSelectedSgwIp.substring(0, index);

					tempSelectedSgwIp = tempSelectedSgwIp.substring(index + 1, tempSelectedSgwIp.length());
					int start_index = tempSelectedSgwIp.indexOf("[");
					int end_index = tempSelectedSgwIp.indexOf("]");
					selectedSgwSerialNo = tempSelectedSgwIp.substring(start_index + 1, end_index);
				}
			}

			/*スマートゲートウェイのエンコードを更新*/
			String encode = SearchSgwIpAddress.smartGatewayEncodeMap.get(selectedSgwIp);
			CommonParam.smartGatewayEncode = encode;
			
			/*スマートゲートウェイのタイプを更新*/
			String type = SearchSgwIpAddress.smartGatewayTypeMap.get(selectedSgwIp);
			if (type != null && type.length() > 0) {
				try {
					CommonParam.smartGatewayType = Integer.parseInt(type);
				} catch (Exception ex) { }
			}

			/*スマートゲートウェイ情報をファイルに保存*/
			try {
				//CommonFunc.writeFile(FILE_SEARCH_SGW_PATH, selectedSgwInfo);
				//CommonFunc.writeFile(FILE_SEARCH_SGW_PATH, selectedSgwInfo + "," + encode);
				String saveString = selectedSgwInfo + "," + encode;
				// 検索結果も保存する
				Iterator<Entry<String, String>> entries = SearchSgwIpAddress.smartGatewayInfoMap.entrySet().iterator();
				while (entries.hasNext()) {
					Map.Entry<String, String> entry = (Map.Entry<String, String>) entries.next();
					String tmpSgwIP = (String) entry.getKey();
					String tmpSgwID = (String) entry.getValue();
					String tmpSgwEncode = SearchSgwIpAddress.smartGatewayEncodeMap.get(tmpSgwIP);
					String tmpSgwType = SearchSgwIpAddress.smartGatewayTypeMap.get(tmpSgwIP);

					//saveString = saveString + com.SgwMiniSetup.common.CommonParam.FILE_DELIMITER
					//				+ tmpSgwIP + "," + tmpSgwID + "," + tmpSgwEncode;
					saveString = saveString + com.SgwMiniSetup.common.CommonParam.FILE_DELIMITER
							+ tmpSgwIP + "," + tmpSgwID + "," + tmpSgwEncode + "," + tmpSgwType;
				}
				CommonFunc.writeFile(FILE_SEARCH_SGW_PATH, saveString);

			} catch (URISyntaxException e1) {
				e1.printStackTrace();
			}

			/*スマートゲートウェイのIPを更新*/
			CommonParam.smartGatewayIp = selectedSgwIp;
			CommonParam.smartGatewaySerialNo = selectedSgwSerialNo;

			/*検索完了フラグを未完了に戻す*/
			CommonParam.searchEndFlg = false;
			CommonParam.findSgwForSearching = false;

			setVisible(false);
		}
	}
}
