package com.SgwMiniSetup.sample;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.Border;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import com.SgwMiniSetup.common.CommonFunc;
import com.SgwMiniSetup.common.CommonParam;
import com.SgwMiniSetup.thread.GetServerHostThread;
import com.SgwMiniSetup.thread.GetSgwSerialNoThread;
import com.SgwMiniSetup.thread.SetDateThread;
import com.SgwMiniSetup.thread.SetServerHostThread;
import com.SgwSetting.http.HTMLAnalyzer;
import com.SgwSetting.http.SgwHttpClient;
import com.SgwSetting.smartgateway.SearchSgwIpAddress;

import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

/**
 * スマートゲートウェイ 簡単セットアップGUI(PC版) - サーバ一括登録ダイアログ
 *
 * @author Copyright (c) 2013 Enegate Co, ltd.
 * @version 1.00
 */
public class ServerHostSettingDialog extends JDialog implements ActionListener {
	/**
	 * アプリの定数
	 */
	private static final long serialVersionUID = 1L;

	// ========================================================================================================
	// 各パネルの設定値
	// ========================================================================================================
	private JFrame frame; // 親フレーム情報

	private final static String DIALOG_REMOTE_CONTROL_TITLE = "サーバ一括登録設定"; // タイトル
	private final static int DIALOG_REMOTE_CONTROL_WIDTH = 600; // 幅
	private final static int DIALOG_REMOTE_CONTROL_HEIGHT = 430; // 高さ

	private final static Color DIALOG_REMOTE_CONTROL_BG_COLOR = new Color(0, 0, 0); // 背景色(黒系:#000000)
	private final static Color DIALOG_REMOTE_CONTROL_BORDER_COLOR = new Color(255, 255, 255); // 枠線色(白系:#FFFFFF)
	private final static Color DIALOG_REMOTE_CONTROL_FONT_COLOR = new Color(255, 255, 255); // 文字色(白系:#FFFFFF)

	// 枠線の太さ
	private final static int DIALOG_REMOTE_CONTROL_BORDER_WEIGHT_INSIDE = 0; // 内側
	private final static int DIALOG_REMOTE_CONTROL_BORDER_WEIGHT_OUTSIDE = 2; // 外側

	// 文字の種別
	private final static String DIALOG_REMOTE_CONTROL_FONT_STYLE_TITLE = Font.SANS_SERIF; // タイトル
	private final static String DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG1 = Font.SANS_SERIF; // 本文1
	private final static String DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG2 = Font.SANS_SERIF; // 本文2

	// 文字の太さ
	private final static int DIALOG_REMOTE_CONTROL_FONT_WEIGHT_TITLE = Font.BOLD; // タイトル
	private final static int DIALOG_REMOTE_CONTROL_FONT_WEIGHT_MSG1 = Font.BOLD; // 本文1
	private final static int DIALOG_REMOTE_CONTROL_FONT_WEIGHT_MSG2 = Font.BOLD; // 本文2

	// 文字のサイズ
	private final static int DIALOG_REMOTE_CONTROL_FONT_SIZE_TITLE = 18; // タイトル
	private final static int DIALOG_REMOTE_CONTROL_FONT_SIZE_MSG1 = 14; // 本文1
	private final static int DIALOG_REMOTE_CONTROL_FONT_SIZE_MSG2 = 12; // 本文2

	// ========================================================================================================
	// コンポーネント配置(単位：ピクセル)
	// ========================================================================================================
	// パネル
	private final static int POS_DIALOG_REMOTE_CONTROL_PANEL_X = 5; // X座標
	private final static int POS_DIALOG_REMOTE_CONTROL_PANEL_Y = 5; // Y座標
	private final static int POS_DIALOG_REMOTE_CONTROL_PANEL_WIDTH = 590; // 幅
	private final static int POS_DIALOG_REMOTE_CONTROL_PANEL_HEIGHT = 420; // 高さ
	
	// 宅外操作設定フラグ
	public final static int REMOTE_CONTROL_DISABLED = 0; 	// 宅外操作設定が無効にする
	public final static int REMOTE_CONTROL_ENABLED = 1; 		// 宅外操作設定が有効にする
	public static int remote_control_setting_flag = REMOTE_CONTROL_DISABLED; 

	// SGW検索結果一覧テーブル
	private JTextField txt_server_host;
	private SearchResultTable searchResultTable;
	private JCheckBox jCB_selectAllItem;
	private JCheckBox jCB_remoteControlItem;

	private List<Object[]> searchSgwItemList;
	private boolean is_jump_redy = true;
	private String currentIpAddress = "";
	private String selectedIpAddress = "";
	
	// スマートゲートウェイ設定画面表示
	private WebVeiwOnJFrame webVeiwOnJFrame = null;
	private JCheckBox jcb_auto_save = null;

	/**
	 * コンストラクタ
	 *
	 * @param JFrame frame
	 */
	public ServerHostSettingDialog(JFrame frame) {

		// ========================================================================================================
		// 初期化
		// ========================================================================================================
		// 親フレーム継承
		super(frame);
		this.frame = frame;

		// ========================================================================================================
		// 各ダイアログ共通の処理
		// ========================================================================================================
		setTitle(DIALOG_REMOTE_CONTROL_TITLE);
		setSize(DIALOG_REMOTE_CONTROL_WIDTH, DIALOG_REMOTE_CONTROL_HEIGHT); // 幅、高さ
		getContentPane().setBackground(DIALOG_REMOTE_CONTROL_BG_COLOR); // 背景色
		setLayout(null); // レイアウト無し
		setResizable(false); // フレームのサイズを固定
		setUndecorated(true); // タイトルバー無し
		setLocationRelativeTo(frame); // 親フレームの画面中央に表示
		setModal(true); // モーダル化

		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		// ========================================================================================================
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// X座標、Y座標、幅、高さをセット
		panel.setBounds(POS_DIALOG_REMOTE_CONTROL_PANEL_X, POS_DIALOG_REMOTE_CONTROL_PANEL_Y,
				POS_DIALOG_REMOTE_CONTROL_PANEL_WIDTH, POS_DIALOG_REMOTE_CONTROL_PANEL_HEIGHT);

		// 背景色
		panel.setBackground(DIALOG_REMOTE_CONTROL_BG_COLOR);

		// 外側の枠線の太さ、内側の枠線の太さをセット
		Border outside = BorderFactory.createMatteBorder(
				DIALOG_REMOTE_CONTROL_BORDER_WEIGHT_OUTSIDE, DIALOG_REMOTE_CONTROL_BORDER_WEIGHT_OUTSIDE,
				DIALOG_REMOTE_CONTROL_BORDER_WEIGHT_OUTSIDE, DIALOG_REMOTE_CONTROL_BORDER_WEIGHT_OUTSIDE,
				DIALOG_REMOTE_CONTROL_BORDER_COLOR);
		Border inside = BorderFactory.createEmptyBorder(
				DIALOG_REMOTE_CONTROL_BORDER_WEIGHT_INSIDE, DIALOG_REMOTE_CONTROL_BORDER_WEIGHT_INSIDE,
				DIALOG_REMOTE_CONTROL_BORDER_WEIGHT_INSIDE, DIALOG_REMOTE_CONTROL_BORDER_WEIGHT_INSIDE);
		panel.setBorder(BorderFactory.createCompoundBorder(outside, inside));

		getContentPane().add(panel);

		// ========================================================================================================
		// コンポーネント作成
		// ========================================================================================================

		// タイトル
		JLabel label_title = new JLabel(DIALOG_REMOTE_CONTROL_TITLE);
		label_title.setBounds(30, 10, 200, 32);
		label_title.setFont(new Font(DIALOG_REMOTE_CONTROL_FONT_STYLE_TITLE,
				DIALOG_REMOTE_CONTROL_FONT_WEIGHT_TITLE, DIALOG_REMOTE_CONTROL_FONT_SIZE_TITLE));
		label_title.setForeground(DIALOG_REMOTE_CONTROL_FONT_COLOR);
		panel.add(label_title);

		// 区切り線
		JSeparator separator = new JSeparator(SwingConstants.HORIZONTAL);
		separator.setBounds(5, 50, 580, 15);
		panel.add(separator);

		// サーバホスト名
		JLabel label_server_host = new JLabel("サーバホスト名: ");
		label_server_host.setBounds(50, 65, 150, 32);
		label_server_host.setFont(new Font(
				DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG1, DIALOG_REMOTE_CONTROL_FONT_WEIGHT_MSG1,
				DIALOG_REMOTE_CONTROL_FONT_SIZE_MSG1));
		label_server_host.setForeground(DIALOG_REMOTE_CONTROL_FONT_COLOR);
		panel.add(label_server_host);
		// サーバホスト名（テキストボックス）
		txt_server_host = new JTextField(CommonParam.serverHostName);
		txt_server_host.setBounds(180, 65, 300, 30);
		txt_server_host.setFont(new Font(
				DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG1, Font.PLAIN,
				DIALOG_REMOTE_CONTROL_FONT_SIZE_MSG1));
		panel.add(txt_server_host);
//		// ログ保存ボタン
//		JButton btn_save_log = new JButton("ログ保存");
//		btn_save_log.setBounds(495, 65, 80, 30);
//		btn_save_log.setFont(new Font(DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG1, 1, 10));
//		btn_save_log.addActionListener(this);
//		btn_save_log.setActionCommand("SaveLog");
//		panel.add(btn_save_log);
		jcb_auto_save = new JCheckBox("ログ保存");
		jcb_auto_save.setBounds(495, 65, 90, 30);
		jcb_auto_save.setFont(new Font(DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG1, 1, 12));
		jcb_auto_save.setBackground(Color.BLACK);
		jcb_auto_save.setForeground(Color.WHITE);
		jcb_auto_save.addActionListener(this);
		jcb_auto_save.setActionCommand("AutoSaveLog");
		jcb_auto_save.setSelected(true);
		jcb_auto_save.setEnabled(true);
		panel.add(jcb_auto_save);

		// 時刻一括設定ボタン
		JButton btn_set_time = new JButton("(1) 時刻一括設定");
		btn_set_time.setBounds(15, 370, 180, 35);
		btn_set_time.setFont(new Font(DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG1, 1, 14));
		btn_set_time.addActionListener(this);
		btn_set_time.setActionCommand("SetTime");
		panel.add(btn_set_time);

		// サーバ名一括設定ボタン
		JButton btn_regist_server = new JButton("(2) サーバ名一括登録");
		btn_regist_server.setBounds(205, 370, 180, 35);
		btn_regist_server.setFont(new Font(DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG1, 1, 14));
		btn_regist_server.addActionListener(this);
		btn_regist_server.setActionCommand("RegistServer");
		panel.add(btn_regist_server);

		// サーバ名登録確認ボタン
		JButton btn_check_server = new JButton("(3) サーバ名登録確認");
		btn_check_server.setBounds(395, 370, 180, 35);
		btn_check_server.setFont(new Font(DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG1, 1, 14));
		btn_check_server.addActionListener(this);
		btn_check_server.setActionCommand("CheckServer");
		panel.add(btn_check_server);

		// 閉じるボタン
		JButton btn_cancel = new JButton("閉じる");
		btn_cancel.setBounds(490, 10, 90, 32);
		btn_cancel.setFont(new Font(DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG1, 1, 14));
		btn_cancel.addActionListener(this);
		btn_cancel.setActionCommand("Close");
		panel.add(btn_cancel);

		// 接続SGW一覧テーブル
		searchResultTable = new SearchResultTable();
		searchResultTable.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                if(e.getValueIsAdjusting()) {
                    is_jump_redy = true;
                } else if(is_jump_redy){
                    int rowIndex = searchResultTable.getSelectedRow();
                    if (searchResultTable.getModel().getRowCount() >= rowIndex) {
                        if(rowIndex >= 0) { //jdk1.5以上で出るバグ回避
                            // 選択結果を格納します。
                            Object value = searchResultTable.getModel().getValueAt(rowIndex, 1);
                            if (value != null) {
                            	//System.out.println(value.toString());
                            	selectedIpAddress = value.toString();
                            }
                        }
                    }
                }
            }
        });
		searchResultTable.addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                if (e.getClickCount() > 1
                		&& selectedIpAddress != null && selectedIpAddress.length() > 0) {
                	// メンテナンス画面のURL
                	String url = "http://" + selectedIpAddress + "/mainte_admin_set.cgi";
                	// ブラウザ起動
                	SgwMiniSetup.launchWebBrowser(url);
                	//launchInnerWebBrowser(url);
                }
            }
        });
		JPanel tableLayoutPane = new JPanel();
		tableLayoutPane.setBounds(15, 105, 560, 230);
        tableLayoutPane.setLayout(new BoxLayout(tableLayoutPane, BoxLayout.X_AXIS));
        tableLayoutPane.add(Box.createHorizontalStrut(0));
		tableLayoutPane.add(new JScrollPane(searchResultTable));
		tableLayoutPane.add(Box.createHorizontalStrut(0));
		panel.add(tableLayoutPane);

		// 「すべてを選択」チェックボックス
		jCB_selectAllItem = new JCheckBox(": すべてを選択");
		jCB_selectAllItem.setBounds(30, 338, 150, 28);
		jCB_selectAllItem.setFont(new Font(
				DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG1, DIALOG_REMOTE_CONTROL_FONT_WEIGHT_MSG1,
				DIALOG_REMOTE_CONTROL_FONT_SIZE_MSG1));
		jCB_selectAllItem.setForeground(DIALOG_REMOTE_CONTROL_FONT_COLOR);
		jCB_selectAllItem.setBackground(DIALOG_REMOTE_CONTROL_BG_COLOR);
		jCB_selectAllItem.addActionListener(this);
		jCB_selectAllItem.setActionCommand("SelectAllItem");
		panel.add(jCB_selectAllItem);
		
		// 「宅外操作を設定する」チェックボックス
		jCB_remoteControlItem = new JCheckBox(": 宅外家電操作設定を許可する");
		jCB_remoteControlItem.setBounds(360, 338, 220, 28);
		jCB_remoteControlItem.setFont(new Font(
				DIALOG_REMOTE_CONTROL_FONT_STYLE_MSG2, DIALOG_REMOTE_CONTROL_FONT_WEIGHT_MSG2,
				DIALOG_REMOTE_CONTROL_FONT_SIZE_MSG2));
		jCB_remoteControlItem.setForeground(DIALOG_REMOTE_CONTROL_FONT_COLOR);
		jCB_remoteControlItem.setBackground(DIALOG_REMOTE_CONTROL_BG_COLOR);
		jCB_remoteControlItem.addActionListener(this);
		jCB_remoteControlItem.setActionCommand("RemoteControlItem");
		if (remote_control_setting_flag == REMOTE_CONTROL_ENABLED) {
			jCB_remoteControlItem.setSelected(true);
		} else {
			jCB_remoteControlItem.setSelected(false);
		}
		panel.add(jCB_remoteControlItem);

		// テーブルを初期化する
		initSgwItemTable();
	}
	
	private void launchInnerWebBrowser(String requestURL) {
		// WebViewを新規生成
		webVeiwOnJFrame = new WebVeiwOnJFrame(requestURL, "スマートゲートウェイ　見える化画面", false, this.getX(), this.getY(), 800, 600, true);
		webVeiwOnJFrame.launchWebView();
	}

	/**
	 * アクションのイベント設定
	 *
	 * @param ActionEvent e イベント情報
	 */
	public void actionPerformed(ActionEvent ae) {
		// コマンド名を取得
		String cmd = ae.getActionCommand();

		// 「(1) 時刻一括設定」ボタンを押した場合
		if (cmd.equals("SetTime") && checkSelectedItem()) {
			//setDateForSelectedItems();
			try {
				// 時刻設定
				SettingExecutionDialog dialog_0 = new SettingExecutionDialog(this,
													SettingExecutionDialog.SET_TIME,
													"スマートゲートウェイの時刻設定を設定しています");
				dialog_0.setVisible(true);
			} catch (Exception e) {
				e.printStackTrace();
			}

			this.jCB_selectAllItem.setSelected(false);	//リストを非選択状態にする
			this.searchResultTable.setEnabledTable(false);
		}
		// 「(2) サーバ名一括登録」ボタンを押した場合
		else if (cmd.equals("RegistServer") && checkSelectedItem()) {
			//registServerHostForSelectedItems();
			try {
				// サーバ名登録
				SettingExecutionDialog dialog_1 = new SettingExecutionDialog(this,
													SettingExecutionDialog.REGIST_SERVER,
													"スマートゲートウェイのサーバ名を登録しています");
				dialog_1.setVisible(true);
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			try {
				// 製造番号確認
				SettingExecutionDialog dialog_2 = new SettingExecutionDialog(this,
													SettingExecutionDialog.CHECK_SGW_SN,
													"スマートゲートウェイの製造番号を確認しています");
				dialog_2.setVisible(true);

			} catch (Exception e) {
				e.printStackTrace();
			}
			
			if (jCB_remoteControlItem.isSelected()) {
				try {
					// 宅外家電操作設定確認
					SettingExecutionDialog dialog_3 = new SettingExecutionDialog(this,
														SettingExecutionDialog.SET_REMOTE_CONTROL,
														"宅外家電操作を設定しています");
					dialog_3.setVisible(true);

				} catch (Exception e) {
					e.printStackTrace();
				}
			}

			this.jCB_selectAllItem.setSelected(false);	//リストを非選択状態にする
			this.searchResultTable.setEnabledTable(false);
		}
		// 「(3) サーバ名登録確認」ボタンを押した場合
		else if (cmd.equals("CheckServer") && checkSelectedItem()) {
			//getServerHostForSelectedItems();
			boolean hasError = false;
			try {
				// サーバ名確認
				SettingExecutionDialog dialog_1 = new SettingExecutionDialog(this,
													SettingExecutionDialog.CHECK_SERVER,
													"スマートゲートウェイのサーバ名を確認しています");
				dialog_1.setVisible(true);
			} catch (Exception e) {
				e.printStackTrace();
				hasError = true;
			}
			try {
				// 製造番号確認
				SettingExecutionDialog dialog_2 = new SettingExecutionDialog(this,
													SettingExecutionDialog.CHECK_SGW_SN,
													"スマートゲートウェイの製造番号を確認しています");
				dialog_2.setVisible(true);

			} catch (Exception e) {
				e.printStackTrace();
				hasError = true;
			}
			try {
				// 宅外操作設定確認
				SettingExecutionDialog dialog_2 = new SettingExecutionDialog(this,
													SettingExecutionDialog.CHECK_REMOTE_CONTROL,
													"宅外家電操作設定を確認しています");
				dialog_2.setVisible(true);

			} catch (Exception e) {
				e.printStackTrace();
				hasError = true;
			}

			this.jCB_selectAllItem.setSelected(false);	//リストを非選択状態にする
			this.searchResultTable.setEnabledTable(false);
			
			// ログファイルに保存
			if (hasError) {
				JOptionPane.showMessageDialog(this, "サーバ名が確認できませんでした．", "確認失敗", JOptionPane.WARNING_MESSAGE);
			} else {
				if (jcb_auto_save.isSelected()) {
					// ログファイルに保存する
					saveLogFile();
				} else {
					// 注意メッセージ
					JOptionPane.showMessageDialog(this, "※「自動保存」がチェックされていない為、ログ保存しませんでした．", "注意", JOptionPane.WARNING_MESSAGE);
				}
			}
		}
		//  「すべてを選択」チェックボックス
		else if (cmd.equals("SelectAllItem")) {
			boolean isSelected = jCB_selectAllItem.isSelected();
			this.searchResultTable.setEnabledTable(isSelected);
		}
		//  「宅外操作設定を有効にする」チェックボックス
		else if (cmd.equals("RemoteControlItem")) {
			boolean isSelected = jCB_remoteControlItem.isSelected();
			if (isSelected) {
				remote_control_setting_flag = REMOTE_CONTROL_ENABLED;
			} else {
				remote_control_setting_flag = REMOTE_CONTROL_DISABLED;
			}
		}
		// 「ログ保存」ボタンを押した場合
		else if (cmd.equals("SaveLog")) {
			// 保存確認後、実行する
			confirmToSaveLogFile();
		}
		// 「閉じる」ボタンを押した場合
		else if (cmd.equals("Close")) {
			// 非表示にする
			setVisible(false);
		}
	}
	
	private void confirmToSaveLogFile() {
		String mes = "ログファイルに保存しますか？";
		String selectvalues[] = { "はい", "いいえ", "ログファイルを開く.." };
		//int ret = JOptionPane.showConfirmDialog(this, mes, "確認", JOptionPane.OK_CANCEL_OPTION);
		int ret = JOptionPane.showOptionDialog(this, mes, "確認", 
							JOptionPane.YES_NO_OPTION,
							JOptionPane.QUESTION_MESSAGE,
							null, 
							selectvalues, 
							selectvalues[0]);
		if (ret == JOptionPane.YES_OPTION) {
			// ログファイルに保存する
			saveLogFile();
		} 
		// ログファイルを開く
		else if (ret == 2) {
			File file = CommonFunc.getLogFile();
			// デフォルトのテキストエディタで開く(MacOS, Linux)
			if (CommonFunc.isMacOS() || CommonFunc.isLinuxOS()) {
				CommonFunc.launchTextEditorWithDesktop(file);
			} 
			// ログファイルをnodepadで開く
			else {
				CommonFunc.launchNotePad(file);
			}
		}
	}
	
	/**
	 * チェック項目を確認する
	 */
	private boolean checkSelectedItem() {
		DefaultTableModel model = ((SortDecorator) searchResultTable.getModel()).getTableModel();
		int rawCount = model.getRowCount();
		int checked = 0;
		try {
			List<String> strArray = new ArrayList<String>();
			for (int i = 0; i < rawCount; i++) {
				boolean tmpCheck = (Boolean) model.getValueAt(i, 2);
				if (tmpCheck) {
					checked++;		
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		if (checked <= 0) {
			JOptionPane.showMessageDialog(this, "処理項目が選択されていません．", "注意", JOptionPane.WARNING_MESSAGE);
			return false;
		}
		return true;
	}
	
	/**
	 * ログファイルに保存する
	 */
	private void saveLogFile() {
		File logFile = saveLogFileFromTable();
		if (logFile != null && logFile.isFile()) {
			String mes = "確認結果がログファイルに保存されました．\n\n" + "ログファイルを開きますか？";
			int ret = JOptionPane.showConfirmDialog(this, mes, "成功", JOptionPane.YES_NO_OPTION);
			if (ret == JOptionPane.YES_OPTION) {
				// デフォルトのテキストエディタで開く(MacOS, Linux)
				if (CommonFunc.isMacOS() || CommonFunc.isLinuxOS()) {
					CommonFunc.launchTextEditorWithDesktop(logFile);
				} 
				// ログファイルをnodepadで開く
				else {
					CommonFunc.launchNotePad(logFile);
				}
			}
//			String mes = "確認結果がログファイルに保存されました．";
//			JOptionPane.showMessageDialog(this, mes, "保存成功", JOptionPane.INFORMATION_MESSAGE);
			
		} else {
			//JOptionPane.showMessageDialog(this, "ログ保存しませんでした", "保存しませんでした", JOptionPane.WARNING_MESSAGE);
			String mes = "ログ保存できませんでした．";
			String selectvalues[] = { "閉じる", "ログファイルを開く.." };
			int ret = JOptionPane.showOptionDialog(this, mes, "保存失敗", 
								JOptionPane.YES_NO_OPTION,
								JOptionPane.WARNING_MESSAGE,
								null, 
								selectvalues, 
								selectvalues[0]);
			// ログ・ファイルを開く
			if (ret != JOptionPane.YES_OPTION) {
				File file = CommonFunc.getLogFile();
				// デフォルトのテキストエディタで開く(MacOS, Linux)
				if (CommonFunc.isMacOS() || CommonFunc.isLinuxOS()) {
					CommonFunc.launchTextEditorWithDesktop(logFile);
				} 
				// ログファイルをnodepadで開く
				else {
					CommonFunc.launchNotePad(file);
				}
			}
		}
	}
	
	/**
	 * テーブルからログ出力する
	 */
	private File saveLogFileFromTable() {
		DefaultTableModel model = ((SortDecorator) searchResultTable.getModel()).getTableModel();
		int rawCount = model.getRowCount();

		try {
			List<String> strArray = new ArrayList<String>();
			for (int i = 0; i < rawCount; i++) {
				boolean tmpCheck = (Boolean) model.getValueAt(i, 2);
				String tmpSgwID = (String) model.getValueAt(i, 3);
				String tmpResult = (String) model.getValueAt(i, 6);
				String tmpRemote = (String) model.getValueAt(i, 7);
				String tmpUpdate = (String) model.getValueAt(i, 9);
				
				//if (tmpCheck) {	// チェックの有無に関係なくログに保存する
				if (checkResult(tmpResult)) {
					//if (jCB_remoteControlItem.isSelected()) {
						strArray.add(tmpSgwID + "," + tmpResult + "," + tmpRemote + "," + tmpUpdate);	
					//} else {
					//	strArray.add(tmpSgwID + "," + tmpResult + "," + tmpUpdate);	
					//}
				}
			}
			// ログファイルに書き込む
			if (strArray.size() > 0) {
				return CommonFunc.writeLogFile(strArray);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	/**
	 * 取得結果を判定する
	 *
	 * @return
	 */
	private boolean checkResult(String result){
		if (result != null && result.indexOf("○") >= 0) {
			return true;
		}
		return false;
	}

	/**
	 * テーブルを初期化する
	 *
	 * @return
	 */
	private void initSgwItemTable() {
		searchSgwItemList = new ArrayList<Object[]>();
		DefaultTableModel model = ((SortDecorator) searchResultTable.getModel()).getTableModel();

		int count = 0;
		Iterator<Entry<String, String>> entries = SearchSgwIpAddress.smartGatewayInfoMap.entrySet().iterator();
		while (entries.hasNext()) {
			Map.Entry<String, String> entry = (Map.Entry<String, String>) entries.next();
			String tmpSgwIP = (String) entry.getKey();
			String tmpSgwID = (String) entry.getValue();
			if (tmpSgwID == null || tmpSgwID.length() == 0) {
				tmpSgwID = "（不明）";
			}
			String tmpSgwEncode = SearchSgwIpAddress.smartGatewayEncodeMap.get(tmpSgwIP);

			count++;
			Object[] result = new Object[10];
            result[0] = new Integer(count);
            result[1] = tmpSgwIP;	// シリアルNo
            result[2] = false;	// チェックボックスはfalse
            result[3] = tmpSgwID;	// シリアルNo
            result[4] = "-";	// 時計設定
            result[5] = "-";	// サーバ名登録
            result[6] = "-";	// サーバ名確認
            result[7] = "-";	// 宅外操作設定
            result[8] = tmpSgwEncode;	// （エンコード）
            result[9] = "-";	// （更新時刻）

            searchSgwItemList.add(result);
            model.addRow(result);
		}

		// セルレンダラの更新
        DefaultTableColumnModel clmModel = (DefaultTableColumnModel) searchResultTable.getColumnModel();
        for (int i = 0; i < clmModel.getColumnCount(); i++) {
            TableColumn column = clmModel.getColumn(i);
            column.setCellRenderer(new SearchResultTableCellRenderer());
        }
		this.searchResultTable.repaint();
	}

	/**
	 * 選択されたSGWの時計設定要求を送信する
	 *
	 * @return
	 */
	protected void setDateForSelectedItems() {
		try {
			DefaultTableModel model = ((SortDecorator) searchResultTable.getModel()).getTableModel();
			int rawCount = model.getRowCount();

			for (int i = 0; i < rawCount; i++) {
				String tmpSgwIP = (String) model.getValueAt(i, 1);
				boolean tmpCheck = (Boolean) model.getValueAt(i, 2);
				String tmpSgwID = (String) model.getValueAt(i, 3);
				if (tmpCheck
						&& tmpSgwIP != null && tmpSgwIP.length() > 0) {

					// 時刻の設定
					SetDateThread thSetDate = new SetDateThread(tmpSgwIP);
					thSetDate.start();

					try {
						Thread.sleep(2000);	// 2秒待つ
					} catch (Exception e) { }

					// テーブルを更新
					boolean result = thSetDate.getResult();
					if (result) {
						model.setValueAt("○", i, 4);
					} else {
						model.setValueAt("×", i, 4);
					}

					// 再描画
					searchResultTable.updateUI();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {

		}
	}

	/**
	 * 選択されたSGWのサーバ設定要求を送信する
	 *
	 * @return
	 */
	protected void registServerHostForSelectedItems() {
		try {
			String hostServerName = txt_server_host.getText();
			DefaultTableModel model = ((SortDecorator) searchResultTable.getModel()).getTableModel();
			int rawCount = model.getRowCount();

			for (int i = 0; i < rawCount; i++) {
				String tmpSgwIP = (String) model.getValueAt(i, 1);
				boolean tmpCheck = (Boolean) model.getValueAt(i, 2);
				String tmpSgwID = (String) model.getValueAt(i, 3);
				if (tmpCheck
						&& tmpSgwIP != null && tmpSgwIP.length() > 0
						&& hostServerName != null && hostServerName.length() > 0) {

					// サーバホスト名の設定
					SetServerHostThread thSetServerHost = new SetServerHostThread(tmpSgwIP, hostServerName);
					thSetServerHost.start();

					try {
						Thread.sleep(2000);	// 2秒待つ
					} catch (Exception e) { }

					// テーブルを更新
					boolean result = thSetServerHost.getResult();
					if (result) {
						model.setValueAt("○", i, 5);
					} else {
						model.setValueAt("×", i, 5);
					}

					// 再描画
					searchResultTable.updateUI();
				}
			}

		} catch (Exception e) {
			e.printStackTrace();
		} finally {

		}
	}

	/**
	 * 選択されたSGWのサーバ設定要求を送信する
	 *
	 * @return
	 */
	protected void getServerHostForSelectedItems() {
		String hostServerName = txt_server_host.getText();
		DefaultTableModel model = ((SortDecorator) searchResultTable.getModel()).getTableModel();
		int rawCount = model.getRowCount();

		for (int i = 0; i < rawCount; i++) {
			try {	
				String tmpSgwIP = (String) model.getValueAt(i, 1);
				boolean tmpCheck = (Boolean) model.getValueAt(i, 2);
				String tmpSgwID = (String) model.getValueAt(i, 3);
				String tmpEncode = (String) model.getValueAt(i, 8);

				if (tmpCheck
						&& tmpSgwIP != null && tmpSgwIP.length() > 0) {

					// サーバホスト名の取得
					GetServerHostThread thGetServerHost = new GetServerHostThread(tmpSgwIP, tmpEncode);
					thGetServerHost.start();

					try {
						Thread.sleep(2000);	// 2秒待つ
					} catch (Exception e) { }

					// テーブルを更新
					String result = thGetServerHost.getResult();
					if (result != null) {
						String mark = "▲: ";
						if (hostServerName != null && result.equals(hostServerName)) {
							mark = "○: ";
						}
						model.setValueAt(mark + result, i, 6);
					} else {
						model.setValueAt("×", i, 6);
					}
					
					// 現在時刻を登録
					String strNow = CommonFunc.getFormatedDate();
					model.setValueAt(strNow, i, 9);

					// 再描画
					searchResultTable.updateUI();
				}
			} catch (Exception e) {
				e.printStackTrace();
			} finally {

			}
		}
	}

	/**
	 * 選択されたSGWの製造番号取得要求を送信する
	 *
	 * @return
	 */
	protected void getSgeSerialNoForSelectedItems() {	
		String hostServerName = txt_server_host.getText();
		DefaultTableModel model = ((SortDecorator) searchResultTable.getModel()).getTableModel();
		int rawCount = model.getRowCount();

		for (int i = 0; i < rawCount; i++) {
			try {
				String tmpSgwIP = (String) model.getValueAt(i, 1);
				boolean tmpCheck = (Boolean) model.getValueAt(i, 2);
				String tmpSgwID = (String) model.getValueAt(i, 3);
				String tmpEncode = (String) model.getValueAt(i, 8);

				if (tmpCheck
						&& tmpSgwIP != null && tmpSgwIP.length() > 0
						&& hostServerName != null && hostServerName.length() > 0) {

					// SGW製造番号の取得
					GetSgwSerialNoThread thGetSgwSnThread = new GetSgwSerialNoThread(tmpSgwIP, tmpEncode);
					thGetSgwSnThread.start();

					try {
						Thread.sleep(2000);	// 2秒待つ
					} catch (Exception e) { }

					// テーブルを更新
					String result = thGetSgwSnThread.getResult();
					if (result != null) {
						model.setValueAt(result, i, 3);
					} else {
						model.setValueAt("（不明）", i, 3);
					}

					// 再描画
					searchResultTable.updateUI();
				}

			} catch (Exception e) {
				e.printStackTrace();
			} finally {

			}
		}
	}
	
	/**
	 * 宅外家電操作可否設定を取得する
	 *
	 * @return なし
	 */
	protected void getRemoteControlSetting() {	
		String hostServerName = txt_server_host.getText();
		DefaultTableModel model = ((SortDecorator) searchResultTable.getModel()).getTableModel();
		int rawCount = model.getRowCount();
		
		for (int i = 0; i < rawCount; i++) {
			String result = "-";
			
			try {
				String tmpSgwIP = (String) model.getValueAt(i, 1);
				boolean tmpCheck = (Boolean) model.getValueAt(i, 2);
				
				if (tmpCheck
						&& tmpSgwIP != null && tmpSgwIP.length() > 0) {
					String rootURL = "http://" + tmpSgwIP;
					String loginURL = rootURL + "/login.cgi";
					String requestURL = rootURL + "/admin_set.cgi";
					String responseText = SgwMiniSetup.getResponseWithLogin(loginURL, "root", "root", requestURL);
					String startTag = "<input type=\"radio\" name=\"ENL_REMOTE\"";
					String endTag = "</label>";
					int positon = 0;
					result = HTMLAnalyzer.getRadioTagOptionValue(responseText, positon, startTag, endTag);
				}	
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
	
			}
			
			if (result != null) {
				String result_label = "許可しない"; 
				if (result.equals("1")) {
					result_label = "許可する"; 
				}
				model.setValueAt(result_label, i, 7);
				System.out.println("... 宅外家電操作設定を取得しました [成功]　-> " + result);
			} else {
				model.setValueAt("×", i, 7);
				System.out.println("... 宅外家電操作設定を取得できませんでした [失敗]");
			}
			// 再描画
			searchResultTable.updateUI();
		}
	}
	
	/**
	 * 宅外操作可否設定情報をスマートゲートウェイに送信する
	 *
	 *　@param index
	 * @return なし
	 */
	protected void setRemoteCotrolSetting(int index) {
		String hostServerName = txt_server_host.getText();
		DefaultTableModel model = ((SortDecorator) searchResultTable.getModel()).getTableModel();
		int rawCount = model.getRowCount();
		String[] items = { "許可しない", "許可する" };
		
		for (int i = 0; i < rawCount; i++) {
			try {
				String tmpSgwIP = (String) model.getValueAt(i, 1);
				boolean tmpCheck = (Boolean) model.getValueAt(i, 2);
				
				if (tmpCheck
						&& tmpSgwIP != null && tmpSgwIP.length() > 0) {
					String requestDeviceControlURL = "http://" + tmpSgwIP + "/remote_setting_result.cgi";
					
					// 宅外操作可否設定情報をスマートゲートウェイに送信する
					boolean res = requestRemoteCotrolSetting(requestDeviceControlURL, index);
					
					if (res) {
						model.setValueAt("○", i, 7);
						System.out.println("... 宅外家電操作設定を設定しました [成功]　-> " + items[index]);
					} else {
						model.setValueAt("×", i, 7);
						System.out.println("... 宅外家電操作設定を設定できませんでした [失敗]　-> " + items[index]);
					}
					// 再描画
					searchResultTable.updateUI();
				}
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
	
			}
		}
	}
	
	/**
	 * 宅外操作可否設定情報をスマートゲートウェイに送信する
	 *
	 *　@param index
	 * @return なし
	 */
	private boolean requestRemoteCotrolSetting(String requestDeviceControlURL, int index) {

		if (com.SgwSetting.common.CommonParam.useOkHttpClient) {
			/* クライアントの生成 */
			OkHttpClient okhttpClient;
			if ((SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4) 
					&& SgwMiniSetup.loginedOkHttpClient != null) {
				okhttpClient = SgwMiniSetup.loginedOkHttpClient;
			} else {
				//okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
				okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(com.SgwSetting.common.CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
			
			try {
				/* 認証用アドレス・パラメータ */
				RequestBody formBody = new FormBody.Builder()
		                .add("ENL_REMOTE", URLEncoder.encode(Integer.toString(index), "UTF-8"))
		                .build();
		 
				/* リクエスト処理 */
				Request request = new Request.Builder()
		                .url(requestDeviceControlURL)
		                .post(formBody)
		                .build();
	
				// 同期処理
				Response response = okhttpClient.newCall(request).execute();
				if (response.isSuccessful()) {
					return true;
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		} else {
			// クライアントの生成
			DefaultHttpClient client;
			if ((SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4) 
					&& SgwMiniSetup.loginedClient != null) {
				client = SgwMiniSetup.loginedClient;
			} else {
				//client = SgwHttpClient.createHttpClientWithProxy();
				client = SgwHttpClient.createHttpClientWithProxy(com.SgwSetting.common.CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
	
			try {
				// フォームパラメータの作成
				List<NameValuePair> formparams = new ArrayList<NameValuePair>();
				formparams.add(new BasicNameValuePair("ENL_REMOTE", Integer.toString(index)));
				//formparams.add(new BasicNameValuePair("CHANGE_BTN", "変更"));
				UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
	
				// HttpPostの生成
				HttpPost httppost = new HttpPost(requestDeviceControlURL);
	
				// HttpPostにパラメータをセットする。
				httppost.setEntity(entity);
	
				// HttpPOST実行
				HttpResponse res = client.execute(httppost);
	
				if (res.getEntity() != null
						&& res.getStatusLine().getStatusCode() == 200) {
					return true;
				}
	
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				// コネクションを切断する
				client.getConnectionManager().shutdown();
				SgwMiniSetup.loginedClient = null;
			}
		}

		return false;
	}
}
