package com.SgwMiniSetup.sample;

import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;

/**
 * スマートゲートウェイ 簡単セットアップGUI(PC版) - 通常ダイアログ出力
 *
 * @author Copyright (c) 2013 Enegate Co, ltd.
 * @version 1.00
 */
public class ShowDialog {
	/**
	 * エラーダイアログ出力
	 *
	 * @param Throwable t スローされた例外エラー
	 */
	public static void showErrorDialog(final Throwable t) {
		try {
			t.printStackTrace();
			// EDT以外で呼ばれる事も想定し、EDTで実行する
			SwingUtilities.invokeLater(new Runnable() {
				public void run() {
					JOptionPane.showMessageDialog(null, t.toString(), "ERROR", JOptionPane.ERROR_MESSAGE);
				}
			});
		} catch (Throwable e) {
			// ダイアログ表示時はエラーは全て握りつぶす
		}
	}


	/**
	 * 情報ダイアログ出力
	 *
	 * @param String title   タイトル
	 * @param String message 本文
	 */
	public static void showInfoDialog(String title, String message) {
		JOptionPane.showMessageDialog(null, message, title, JOptionPane.INFORMATION_MESSAGE);
	}


	/**
	 * 警告ダイアログ出力
	 *
	 * @param String title   タイトル
	 * @param String message 本文
	 */
	public static void showWarningDialog(String title, String message) {
		JOptionPane.showMessageDialog(null, message, title, JOptionPane.WARNING_MESSAGE);
	}

}
