package com.SgwMiniSetup.sample;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.SwingConstants;
import javax.swing.border.Border;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import com.SgwSetting.common.CommonParam;
import com.SgwSetting.http.HTMLAnalyzer;
import com.SgwSetting.http.SgwHttpClient;

import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

/**
 * スマートゲートウェイ 簡単セットアップGUI(PC版) - Webコンテンツ設定ダイアログ
 *
 * @author Copyright (c) 2016 Enegate Co, ltd.
 * @version 1.xx
 */
public class WebContentsSettingDialog extends JDialog implements ActionListener {

	public String rootURL = "http://" + CommonParam.smartGatewayIp;

	private String itemName = "";

	/**
	 * アプリの定数
	 */
	private static final long serialVersionUID = 1L;

	// ========================================================================================================
	// 各パネルの設定値
	// ========================================================================================================
	private JFrame frame; // 親フレーム情報

	private final static String DIALOG_SETTINGS_MENU_TITLE = "Webコンテンツ設定"; // タイトル
	private final static int DIALOG_SETTINGS_MENU_WIDTH = 520; // 幅
	private final static int DIALOG_SETTINGS_MENU_HEIGHT = 350; // 高さ

	//ボタン
	private final static int DIALOG_SETTINGS_MENU_BTN_X = 100; // X座標
	private final static int DIALOG_SETTINGS_MENU_BTN_WIDTH = 320; // 幅
	private final static int DIALOG_SETTINGS_MENU_BTN_HEIGHT = 48; // 高さ

	private final static Color DIALOG_SETTINGS_MENU_BG_COLOR = new Color(0, 0, 0); // 背景色(黒系:#000000)
	private final static Color DIALOG_SETTINGS_MENU_BORDER_COLOR = new Color(255, 255, 255); // 枠線色(白系:#FFFFFF)
	//private final static Color DIALOG_SETTINGS_MENU_FONT_COLOR = new Color(255, 255, 255); // 文字色(白系:#FFFFFF)
	private final static Color DIALOG_SETTINGS_MENU_FONT_COLOR = new Color(255, 255, 255); // 文字色(白系:#FFFFFF)

	// 枠線の太さ
	private final static int DIALOG_SETTINGS_MENU_BORDER_WEIGHT_INSIDE = 0; // 内側
	private final static int DIALOG_SETTINGS_MENU_BORDER_WEIGHT_OUTSIDE = 2; // 外側

	// 文字の種別
	private final static String DIALOG_SETTINGS_MENU_FONT_STYLE_TITLE = Font.SANS_SERIF; // タイトル
	private final static String DIALOG_SETTINGS_MENU_FONT_STYLE_BTN = Font.SANS_SERIF; // 本文1

	// 文字の太さ
	private final static int DIALOG_SETTINGS_MENU_FONT_WEIGHT_TITLE = Font.BOLD; // タイトル

	// 文字のサイズ
	private final static int DIALOG_SETTINGS_MENU_FONT_SIZE_TITLE = 20; // タイトル
	private final static int DIALOG_SETTINGS_MENU_FONT_SIZE_BTN = 24; // ボタン

	// 文字の色
	private final static Color FONT_COLOR_BTN = new Color(0, 0, 102); //ボタン(青系:#000066)

	// ========================================================================================================
	// コンポーネント配置(単位：ピクセル)
	// ========================================================================================================
	// パネル
	private final static int POS_DIALOG_SETTINGS_MENU_PANEL_X = 5; // X座標
	private final static int POS_DIALOG_SETTINGS_MENU_PANEL_Y = 5; // Y座標
	private final static int POS_DIALOG_SETTINGS_MENU_PANEL_WIDTH = 510; // 幅
	private final static int POS_DIALOG_SETTINGS_MENU_PANEL_HEIGHT = 340; // 高さ

	//private static DefaultHttpClient loginedClient = null;

	/**
	 * コンストラクタ
	 *
	 * @param JFrame
	 *            frame
	 * @param CardLayout
	 *            layout
	 * @param JPanel
	 *            panelBase
	 * @param String
	 *            success_panel_name
	 * @param String
	 *            error_panel_name
	 */
	public WebContentsSettingDialog(JFrame frame) {

		// ========================================================================================================
		// 初期化
		// ========================================================================================================
		// 親フレーム継承
		super(frame);
		this.frame = frame;

		// ========================================================================================================
		// 各ダイアログ共通の処理
		// ========================================================================================================
		setTitle(DIALOG_SETTINGS_MENU_TITLE);
		setSize(DIALOG_SETTINGS_MENU_WIDTH, DIALOG_SETTINGS_MENU_HEIGHT); // 幅、高さ
		getContentPane().setBackground(DIALOG_SETTINGS_MENU_BG_COLOR); // 背景色
		setLayout(null); // レイアウト無し
		setResizable(false); // フレームのサイズを固定
		setUndecorated(true); // タイトルバー無し
		setLocationRelativeTo(frame); // 親フレームの画面中央に表示
		//setModal(true); // モーダル化
		setModal(false); // 非モーダル化

		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		// ========================================================================================================
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// X座標、Y座標、幅、高さをセット
		panel.setBounds(POS_DIALOG_SETTINGS_MENU_PANEL_X, POS_DIALOG_SETTINGS_MENU_PANEL_Y,
				POS_DIALOG_SETTINGS_MENU_PANEL_WIDTH, POS_DIALOG_SETTINGS_MENU_PANEL_HEIGHT);

		// 背景色
		panel.setBackground(DIALOG_SETTINGS_MENU_BG_COLOR);

		// 外側の枠線の太さ、内側の枠線の太さをセット
		Border outside = BorderFactory.createMatteBorder(
				DIALOG_SETTINGS_MENU_BORDER_WEIGHT_OUTSIDE, DIALOG_SETTINGS_MENU_BORDER_WEIGHT_OUTSIDE,
				DIALOG_SETTINGS_MENU_BORDER_WEIGHT_OUTSIDE, DIALOG_SETTINGS_MENU_BORDER_WEIGHT_OUTSIDE,
				DIALOG_SETTINGS_MENU_BORDER_COLOR);
		Border inside = BorderFactory.createEmptyBorder(
				DIALOG_SETTINGS_MENU_BORDER_WEIGHT_INSIDE, DIALOG_SETTINGS_MENU_BORDER_WEIGHT_INSIDE,
				DIALOG_SETTINGS_MENU_BORDER_WEIGHT_INSIDE, DIALOG_SETTINGS_MENU_BORDER_WEIGHT_INSIDE);
		panel.setBorder(BorderFactory.createCompoundBorder(outside, inside));

		getContentPane().add(panel);

		// ========================================================================================================
		// コンポーネント作成
		// ========================================================================================================

		// タイトル
		JLabel label_title = new JLabel(DIALOG_SETTINGS_MENU_TITLE);
		label_title.setBounds(30, 10, 200, 32);
		label_title.setFont(new Font(DIALOG_SETTINGS_MENU_FONT_STYLE_TITLE,
				DIALOG_SETTINGS_MENU_FONT_WEIGHT_TITLE, DIALOG_SETTINGS_MENU_FONT_SIZE_TITLE));
		label_title.setForeground(DIALOG_SETTINGS_MENU_FONT_COLOR);
		panel.add(label_title);

		// 区切り線
		JSeparator separator = new JSeparator(SwingConstants.HORIZONTAL);
		separator.setBounds(5, 50, 580, 15);
		panel.add(separator);

		// 太陽光発電設定
		JButton btn_solar_power = new JButton("太陽光発電設定");
		//btn_solar_power.setBounds(175, 80, 220, 40);
		btn_solar_power.setBounds(DIALOG_SETTINGS_MENU_BTN_X, 75, DIALOG_SETTINGS_MENU_BTN_WIDTH, DIALOG_SETTINGS_MENU_BTN_HEIGHT);
		btn_solar_power.setFont(new Font(DIALOG_SETTINGS_MENU_FONT_STYLE_BTN, 1, DIALOG_SETTINGS_MENU_FONT_SIZE_BTN));
		btn_solar_power.setForeground(FONT_COLOR_BTN);
		btn_solar_power.addActionListener(this);
		btn_solar_power.setActionCommand("btn_solar_power");
		panel.add(btn_solar_power);

		// 電気料金換算設定
		JButton btn_elec_rate_conversion = new JButton("電気料金換算設定");
		btn_elec_rate_conversion.setBounds(DIALOG_SETTINGS_MENU_BTN_X, 135, DIALOG_SETTINGS_MENU_BTN_WIDTH, DIALOG_SETTINGS_MENU_BTN_HEIGHT);
		btn_elec_rate_conversion.setFont(new Font(DIALOG_SETTINGS_MENU_FONT_STYLE_BTN, 1, DIALOG_SETTINGS_MENU_FONT_SIZE_BTN));
		btn_elec_rate_conversion.setForeground(FONT_COLOR_BTN);
		btn_elec_rate_conversion.addActionListener(this);
		btn_elec_rate_conversion.setActionCommand("btn_elec_rate_conversion");
		panel.add(btn_elec_rate_conversion);

		// Co2排出係数設定
		JButton btn_co2_conversion = new JButton("CO2排出係数設定");
		btn_co2_conversion.setBounds(DIALOG_SETTINGS_MENU_BTN_X, 200, DIALOG_SETTINGS_MENU_BTN_WIDTH, DIALOG_SETTINGS_MENU_BTN_HEIGHT);
		btn_co2_conversion.setFont(new Font(DIALOG_SETTINGS_MENU_FONT_STYLE_BTN, 1, DIALOG_SETTINGS_MENU_FONT_SIZE_BTN));
		btn_co2_conversion.setForeground(FONT_COLOR_BTN);
		btn_co2_conversion.addActionListener(this);
		btn_co2_conversion.setActionCommand("btn_co2_conversion");
		panel.add(btn_co2_conversion);

		// パルス換算係数設定
		JButton btn_pulse_conversion = new JButton("パルス換算係数設定");
		btn_pulse_conversion.setBounds(DIALOG_SETTINGS_MENU_BTN_X, 265, DIALOG_SETTINGS_MENU_BTN_WIDTH, DIALOG_SETTINGS_MENU_BTN_HEIGHT);
		btn_pulse_conversion.setFont(new Font(DIALOG_SETTINGS_MENU_FONT_STYLE_BTN, 1, DIALOG_SETTINGS_MENU_FONT_SIZE_BTN));
		btn_pulse_conversion.setForeground(FONT_COLOR_BTN);
		btn_pulse_conversion.addActionListener(this);
		btn_pulse_conversion.setActionCommand("btn_pulse_conversion");
		panel.add(btn_pulse_conversion);

		// 閉じるボタン
		JButton btn_cancel = new JButton("閉じる");
		btn_cancel.setBounds(400, 10, 90, 32);
		btn_cancel.setFont(new Font(DIALOG_SETTINGS_MENU_FONT_STYLE_BTN, 1, 16));
		btn_cancel.addActionListener(this);
		btn_cancel.setActionCommand("Close");
		panel.add(btn_cancel);
	}

	/**
	 * アクションのイベント設定
	 *
	 * @param ActionEvent
	 *            e イベント情報
	 */
	public void actionPerformed(ActionEvent e) {
		// コマンド名を取得
		String cmd = e.getActionCommand();

		// 「はい」ボタンを押した場合
		if (cmd.equals("Yes")) {
			// 非表示にする
			setVisible(false);
		}
		// 「いいえ」ボタンを押した場合
		else if (cmd.equals("Close")) {
			// 非表示にする
			setVisible(false);
		}
		// 太陽光発電設定
		else if (cmd.equals("btn_solar_power")) {
			setVisible(false); // 一旦、非表示にする
			setSolarPowerSetting();

			// 設定後、メニューを再表示
			setVisible(true);
		}

		// 電気料金換算設定
		else if (cmd.equals("btn_elec_rate_conversion")) {
			setVisible(false); // 一旦、非表示にする
			setElecRateSetting();

			// 設定後、メニューを再表示
			setVisible(true);
		}
		// Co2排出係数設定
		else if (cmd.equals("btn_co2_conversion")) {
			setVisible(false);
			setCo2ConversionSetting();

			// 設定後、メニューを再表示
			setVisible(true);
		}

		// パルス換算係数設定
		else if (cmd.equals("btn_pulse_conversion")) {
			setVisible(false); // 一旦、非表示にする

			setPulseConversionSetting();

			// 設定後、メニューを再表示
			setVisible(true);
		}
	}

	//■■太陽光発電設定 ■■
	/* 太陽光発電設定 */
	private void setSolarPowerSetting() {
		String loginURL = this.rootURL + "/login.cgi";
		String requestURL = this.rootURL + "/admin_set.cgi";

		String responseText = SgwMiniSetup.getResponseWithLogin(loginURL, "root", "root", requestURL);

		// 太陽光発電設定
		String startTag = "<input type=\"radio\" name=\"SOLAR_SETTING\"";
		String endTag = "</label>";
		int positon = 0;

		String pvSelected = HTMLAnalyzer.getRadioTagOptionValue(responseText, positon, startTag, endTag);
		System.out.println(pvSelected);

		SolarPowerSettingDialog dialog = new SolarPowerSettingDialog(this.frame, pvSelected);
		dialog.setVisible(true);

		int res = dialog.getSolarPowerSetting();

		//  "なし" or "あり"
		if (res == 0 || res == 1) {
			String[] items = { "なし", "あり" };
			// 太陽光発電設定の変更要求を送信
			boolean isSucceeded = requestSolarPowerSetting(res, itemName);

			String chkTitle = "送信成功";
			String chkMessage = "太陽光発電設定を変更しました。\n\n    ※設定変更要求:　[　" + items[res] + "　]\n\n";
			int icon = JOptionPane.INFORMATION_MESSAGE;
			if (!isSucceeded) {
				chkTitle = "送信失敗";
				chkMessage = "太陽光発電設定が変更できませんでした。\n\n    ※設定変更要求:　[　" + items[res] + "　]\n\n";
				icon = JOptionPane.WARNING_MESSAGE;
			}
			JOptionPane.showMessageDialog(this, chkMessage, chkTitle, icon);
		}
	}

	private boolean requestSolarPowerSetting(int index, String item) {
		String requestDeviceControlURL = this.rootURL + "/solar_setting_result.cgi";
		
		if (CommonParam.useOkHttpClient) {
			/* クライアントの生成 */
			OkHttpClient okhttpClient;
			if ((SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4) 
					&& SgwMiniSetup.loginedOkHttpClient != null) {
				okhttpClient = SgwMiniSetup.loginedOkHttpClient;
			} else {
				//okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
				okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
			
			try {
				/* 認証用アドレス・パラメータ */
				RequestBody formBody = new FormBody.Builder()
		                .add("SOLAR_SETTING", URLEncoder.encode(Integer.toString(index), "UTF-8"))
		                .build();
		 
				/* リクエスト処理 */
				Request request = new Request.Builder()
		                .url(requestDeviceControlURL)
		                .post(formBody)
		                .build();
	
				// 同期処理
				Response response = okhttpClient.newCall(request).execute();
				if (response.isSuccessful()) {
					return true;
				}
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				// コネクションを切断する
				SgwMiniSetup.loginedOkHttpClient = null;
			}
		} else {
			// クライアントの生成
			//DefaultHttpClient client = SgwHttpClient.createHttpClientWithProxy();
			DefaultHttpClient client = SgwHttpClient.createHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			
			if ((SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4) 
					&& SgwMiniSetup.loginedClient != null) {
				client = SgwMiniSetup.loginedClient;
			}
	
			try {
				item = itemName;
				// フォームパラメータの作成
				List<NameValuePair> formparams = new ArrayList<NameValuePair>();
	
				// 太陽光発電設定
				formparams.add(new BasicNameValuePair("SOLAR_SETTING", Integer.toString(index)));
	
				UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
	
				// HttpPostの生成
				HttpPost httppost = new HttpPost(requestDeviceControlURL);
	
				// HttpPostにパラメータをセットする。
				httppost.setEntity(entity);
	
				// HttpPOST実行
				HttpResponse res = client.execute(httppost);
	
				if (res.getEntity() != null
						&& res.getStatusLine().getStatusCode() == 200) {
					return true;
				}
	
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				// コネクションを切断する
				client.getConnectionManager().shutdown();
				SgwMiniSetup.loginedClient = null;
			}
		}

		return false;
	}

	//■■電気料金換算設定 ■■
	private void setElecRateSetting() {
		String loginURL = this.rootURL + "/login.cgi";
		String requestURL = this.rootURL + "/admin_set.cgi";
		String responseText = SgwMiniSetup.getResponseWithLogin(loginURL, "root", "root", requestURL);

		//電気料金換算設定
		String startTag = "<input type=\"text\" name=\"CHANGE_YEN\"";

		int positon = 0;

		String elecRateVal = HTMLAnalyzer.getTagAttributeValue(responseText, positon, startTag);
		System.out.println(elecRateVal);

		ElecRateConversionSetting dialog = new ElecRateConversionSetting(this.frame, elecRateVal);
		dialog.setVisible(true);

		int res = dialog.getElecRateConversionSetting();
		if (0 <= res && 99 >= res) {

			// 電気料金換算設定の変更要求を送信
			boolean isSucceeded = requestElecRateSetting(res);
			String chkTitle = "送信成功";
			String chkMessage = "電気料金換算設定を変更しました。\n\n    ※設定変更要求:　[　" + res + "　]\n\n";
			int icon = JOptionPane.INFORMATION_MESSAGE;
			if (!isSucceeded) {
				chkTitle = "送信失敗";
				chkMessage = "電気料金換算設定が変更できませんでした。\n\n    ※設定変更要求:　[　" + res + "　]\n\n";
				icon = JOptionPane.WARNING_MESSAGE;
			}
			JOptionPane.showMessageDialog(this, chkMessage, chkTitle, icon);
		}
	}

	private boolean requestElecRateSetting(int value) {
		String requestDeviceControlURL = this.rootURL + "/yen_conversion_set_result.cgi";
		
		if (CommonParam.useOkHttpClient) {
			/* クライアントの生成 */
			OkHttpClient okhttpClient;
			if ((SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4) 
					&& SgwMiniSetup.loginedOkHttpClient != null) {
				okhttpClient = SgwMiniSetup.loginedOkHttpClient;
			} else {
				//okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
				okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
			
			try {
				/* 認証用アドレス・パラメータ */
				RequestBody formBody = new FormBody.Builder()
		                .add("CHANGE_YEN", URLEncoder.encode(Integer.toString(value), "UTF-8"))
		                .build();
		 
				/* リクエスト処理 */
				Request request = new Request.Builder()
		                .url(requestDeviceControlURL)
		                .post(formBody)
		                .build();
	
				// 同期処理
				Response response = okhttpClient.newCall(request).execute();
				if (response.isSuccessful()) {
					return true;
				}
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				// コネクションを切断する
				SgwMiniSetup.loginedOkHttpClient = null;
			}
		} else {
			// クライアントの生成
			DefaultHttpClient client;
			if ((SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4)
					&& SgwMiniSetup.loginedClient != null) {
				client = SgwMiniSetup.loginedClient;
			} else {
				//client = SgwHttpClient.createHttpClientWithProxy();
				client = SgwHttpClient.createHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
	
			try {
				// フォームパラメータの作成
				List<NameValuePair> formparams = new ArrayList<NameValuePair>();
				formparams.add(new BasicNameValuePair("CHANGE_YEN", Integer.toString(value)));
	
				UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
	
				// HttpPostの生成
				HttpPost httppost = new HttpPost(requestDeviceControlURL);
	
				// HttpPostにパラメータをセットする。
				httppost.setEntity(entity);
	
				// HttpPOST実行
				HttpResponse res = client.execute(httppost);
	
				if (res.getEntity() != null
						&& res.getStatusLine().getStatusCode() == 200) {
					return true;
				}
	
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				// コネクションを切断する
				client.getConnectionManager().shutdown();
				SgwMiniSetup.loginedClient = null;
			}
		}

		return false;
	}

	//■■ CO2排出係数設定 ■■
	private void setCo2ConversionSetting() {
		String loginURL = this.rootURL + "/login.cgi";
		String requestURL = this.rootURL + "/admin_set.cgi";
		String responseText = SgwMiniSetup.getResponseWithLogin(loginURL, "root", "root", requestURL);

		//CO2排出係数設定
		String startTag = "<input type=\"text\" name=\"CHANGE_CO2\"";
		int positon = 0;

		String co2ConvertVal = HTMLAnalyzer.getTagAttributeValue(responseText, positon, startTag);
		System.out.println(co2ConvertVal);

		Co2ConversionSettingDialog dialog = new Co2ConversionSettingDialog(this.frame, co2ConvertVal);
		dialog.setVisible(true);

		int res = dialog.getCo2ConversionSetting();
		if (0 <= res && 999 >= res) {
			// CO2排出係数設定の変更要求を送信
			boolean isSucceeded = requestCo2ConversionSetting(res);
			String chkTitle = "送信成功";
			String chkMessage = "CO2排出係数設定を変更しました。\n\n    ※設定変更要求:　[　0." + res + "　]\n\n";
			int icon = JOptionPane.INFORMATION_MESSAGE;
			if (!isSucceeded) {
				chkTitle = "送信失敗";
				chkMessage = "CO2排出係数設定が変更できませんでした。\n\n    ※設定変更要求:　[　0." + res + "　]\n\n";
				icon = JOptionPane.WARNING_MESSAGE;
			}
			JOptionPane.showMessageDialog(this, chkMessage, chkTitle, icon);
		}
	}

	private boolean requestCo2ConversionSetting(int value) {
		String requestDeviceControlURL = this.rootURL + "/co2_conversion_set_result.cgi";
		
		if (CommonParam.useOkHttpClient) {
			/* クライアントの生成 */
			OkHttpClient okhttpClient;
			if ((SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4) 
					&& SgwMiniSetup.loginedOkHttpClient != null) {
				okhttpClient = SgwMiniSetup.loginedOkHttpClient;
			} else {
				//okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
				okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
			
			try {
				/* 認証用アドレス・パラメータ */
				RequestBody formBody = new FormBody.Builder()
		                .add("CHANGE_CO2", URLEncoder.encode(Integer.toString(value), "UTF-8"))
		                .build();
		 
				/* リクエスト処理 */
				Request request = new Request.Builder()
		                .url(requestDeviceControlURL)
		                .post(formBody)
		                .build();
	
				// 同期処理
				Response response = okhttpClient.newCall(request).execute();
				if (response.isSuccessful()) {
					return true;
				}
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				// コネクションを切断する
				SgwMiniSetup.loginedOkHttpClient = null;
			}
		} else {
			// クライアントの生成
			DefaultHttpClient client;
			if ((SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4) 
					&& SgwMiniSetup.loginedClient != null) {
				client = SgwMiniSetup.loginedClient;
			} else {
				//client = SgwHttpClient.createHttpClientWithProxy();
				client = SgwHttpClient.createHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
	
			try {
				// フォームパラメータの作成
				List<NameValuePair> formparams = new ArrayList<NameValuePair>();
				formparams.add(new BasicNameValuePair("CHANGE_CO2", Integer.toString(value)));
	
				UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
	
				// HttpPostの生成
				HttpPost httppost = new HttpPost(requestDeviceControlURL);
	
				// HttpPostにパラメータをセットする。
				httppost.setEntity(entity);
	
				// HttpPOST実行
				HttpResponse res = client.execute(httppost);
	
				if (res.getEntity() != null
						&& res.getStatusLine().getStatusCode() == 200) {
					return true;
				}
	
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				// コネクションを切断する
				client.getConnectionManager().shutdown();
				SgwMiniSetup.loginedClient = null;
			}
		}

		return false;
	}

	//■■パルス換算係数設定■■
	private void setPulseConversionSetting() {
		String loginURL = this.rootURL + "/login.cgi";
		String requestURL = this.rootURL + "/admin_set.cgi";
		String responseText = SgwMiniSetup.getResponseWithLogin(loginURL, "root", "root", requestURL);

		//パルス換算係数設定
		//【ガス】
		String startTag = "<input type=\"text\" name=\"CHANGE_GUS\"";
		int positon = 0;

		String gasVal = HTMLAnalyzer.getTagAttributeValue(responseText, positon, startTag);
		System.out.println(gasVal);

		positon = responseText.indexOf(startTag) + startTag.length(); // 検索開始位置を移動させる

		//【水道】
		String startTag2 = "<input type=\"text\" name=\"CHANGE_WATER\"";

		String waterVal = HTMLAnalyzer.getTagAttributeValue(responseText, positon, startTag2);
		System.out.println(waterVal);

		PulseConversionSettingDialog dialog = new PulseConversionSettingDialog(this.frame, gasVal, waterVal);
		dialog.setVisible(true);

		int res = dialog.getGasConversionSetting();
		int res2 = dialog.getWaterConversionSetting();
		if ((0 <= res && res <= 9999) && (0 <= res2 && res2 <= 9999)) {
			// パルス換算係数設定【ガス】の変更要求を送信
			boolean isSucceeded = requestPulseConversionSetting(res, res2);

			String chkTitle = "送信成功";
			String chkMessage = "パルス換算係数設定を変更しました。\n\n    ※ガス設定変更要求:　[　" + res + "　]\n    ※水道設定変更要求:　[　" + res2 + "　]\n\n";
			int icon = JOptionPane.INFORMATION_MESSAGE;
			if (!isSucceeded) {
				chkTitle = "送信失敗";
				chkMessage = "パルス換算係数設定を変更が変更できませんでした。\n\n    ※設定変更要求:　[　" + res + "　]\n\n";
				icon = JOptionPane.WARNING_MESSAGE;
			}
			JOptionPane.showMessageDialog(this, chkMessage, chkTitle, icon);
		}
	}

	private boolean requestPulseConversionSetting(int gasValue, int waterValue) {
		String requestDeviceControlURL = this.rootURL + "/pulse_conversion_set_result.cgi";
		
		if (CommonParam.useOkHttpClient) {
			/* クライアントの生成 */
			OkHttpClient okhttpClient;
			if ((SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4) 
					&& SgwMiniSetup.loginedOkHttpClient != null) {
				okhttpClient = SgwMiniSetup.loginedOkHttpClient;
			} else {
				//okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
				okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
			
			try {
				/* 認証用アドレス・パラメータ */
				RequestBody formBody = new FormBody.Builder()
		                .add("CHANGE_GUS", URLEncoder.encode(Integer.toString(gasValue), "UTF-8"))
		                .add("CHANGE_WATER", URLEncoder.encode(Integer.toString(waterValue), "UTF-8"))
		                .build();
		 
				/* リクエスト処理 */
				Request request = new Request.Builder()
		                .url(requestDeviceControlURL)
		                .post(formBody)
		                .build();
	
				// 同期処理
				Response response = okhttpClient.newCall(request).execute();
				if (response.isSuccessful()) {
					return true;
				}
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				// コネクションを切断する
				SgwMiniSetup.loginedOkHttpClient = null;
			}
		} else {
			// クライアントの生成
			DefaultHttpClient client;
			if ((SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4)
					&& SgwMiniSetup.loginedClient != null) {
				client = SgwMiniSetup.loginedClient;
			} else {
				//client = SgwHttpClient.createHttpClientWithProxy();
				client = SgwHttpClient.createHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
	
			try {
				// フォームパラメータの作成
				List<NameValuePair> formparams = new ArrayList<NameValuePair>();
				formparams.add(new BasicNameValuePair("CHANGE_GUS", Integer.toString(gasValue)));
				formparams.add(new BasicNameValuePair("CHANGE_WATER", Integer.toString(waterValue)));
	
				UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
	
				// HttpPostの生成
				HttpPost httppost = new HttpPost(requestDeviceControlURL);
	
				// HttpPostにパラメータをセットする。
				httppost.setEntity(entity);
	
				// HttpPOST実行
				HttpResponse res = client.execute(httppost);
	
				if (res.getEntity() != null
						&& res.getStatusLine().getStatusCode() == 200) {
					return true;
				}
	
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				// コネクションを切断する
				client.getConnectionManager().shutdown();
				SgwMiniSetup.loginedClient = null;
			}
		}
		
		return false;
	}

}
