package com.SgwMiniSetup.thread;

import com.SgwMiniSetup.sample.SgwMiniSetup;
import com.SgwSetting.common.CommonParam;
import com.SgwSetting.http.HTMLAnalyzer;

/**
 *
 * 通信テストの送信を行うためのスレッドクラス
 *
 */
public class CheckAuthorizationThread extends Thread {

	public static final int COM_TEST_TIMEOUT = 5000;//通信テストタイムアウト時間　5秒

	private boolean resultCheckAuthorization; 		//通信テストの結果
	private String ipAddress; 			//IPアドレス
	
	private SgwMiniSetup mainFrame;

	// コンストラクタ
	public CheckAuthorizationThread(SgwMiniSetup frame, String address) {
		mainFrame = frame;
		ipAddress = address;
		resultCheckAuthorization = false;//通信テストの結果
	}

	public void run() {

		String checkAddress = ipAddress;
		checkAddress = checkAddress.replace("http://", "");
		checkAddress = checkAddress.replace("/index.cgi", "");
		
		String rootURL = "http://" + checkAddress;

		CommonParam.checkingAuthorization = true;
		
		try {
			//計器認証設定
			String loginURL = rootURL + "/login.cgi";
			String requestURL = rootURL + "/smart_set.cgi";
			String responseText = SgwMiniSetup.getResponseWithLogin(loginURL, "root", "root", requestURL);

			/* 認証IDのHTMLのタグ */
			String startTag1 = "<input type=\"text\" name=\"B_AUTH_ID";
			/* パスワードのHTMLのタグ */
			String startTag2 = "<input type=\"text\" name=\"B_AUTH_PW";

			int positon = 0;

			String authId = "";
			for (int i = 0; i < 8; i++) {
				String id = HTMLAnalyzer.getTagAttributeValue(responseText, positon, startTag1);
				if (id != null && id.length() > 0) {
					authId = authId + id;
				} else {
					break;
				}
				positon = responseText.indexOf(startTag1, positon) + startTag1.length();
			}
			
			// 認証コード（ID）の保存
			if (authId.length() == 32) {
				CommonParam.authorizationId = authId;
				CommonParam.hasSmartMeterValue = true;
			} else {
				CommonParam.authorizationId  = "";
				CommonParam.hasSmartMeterValue = false;
			}
			
			String authPw = "";
			for (int j = 0; j < 3; j++) {
				String pw = HTMLAnalyzer.getTagAttributeValue(responseText, positon, startTag2);
				if (pw != null && pw.length() > 0) {
					authPw = authPw + pw;
				} else {
					break;
				}
				positon = responseText.indexOf(startTag2, positon) + startTag2.length();
			}
			// 認証コード（パスワード）の保存
			if (authId.length() == 12) {
				CommonParam.authorizationPassword = authPw;
			} else {
				CommonParam.authorizationPassword = "";
			}
			
		} catch (Exception e) {
			e.printStackTrace();
			//throw e;
		} finally {
			CommonParam.checkingAuthorization = false;
		}
		
		// ボタンの表示状態の更新
		//mainFrame.updateButtonStatus();
		mainFrame.setButtonVisiblity(true);
	}

	public boolean getResult() {
		return resultCheckAuthorization;
	}
}
