package com.SgwSetting.network;
import java.util.*;

/**
 * This class provides a convenient method to retrieve resources for
 * the data package.
 */
public class ResourceStrings {

    /**
     * The handle to the resource bundle for the module.
     */
    private static ResourceBundle bundle = null;

    /**
     * Return a string from the resource bundle.
     * @param key the key to the resource bundle string.
     * @return the resource bundle string.
     */
    public static String getString(String key) {
	String msg = null;
	try {
	    if (bundle == null) {
		bundle = ResourceBundle.getBundle(
		    "com.sun.dhcpmgr.data.ResourceBundle",
		    Locale.getDefault());
	    }
	    msg = bundle.getString(key);
	} catch (Throwable e) {
	    msg = new String(key);
	}
	return msg;

    } // getString

} // ResourceStrings