package com.SgwSetting.smartgateway;
import java.net.ConnectException;
import java.net.HttpURLConnection;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.conn.ConnectTimeoutException;
import org.apache.http.conn.HttpHostConnectException;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.util.EntityUtils;

import com.SgwMiniSetup.common.CommonFunc;
import com.SgwMiniSetup.common.StringEncoder;
import com.SgwMiniSetup.sample.SgwMiniSetup;

//import javax.xml.bind.ValidationException;

import com.SgwSetting.common.CommonParam;
import com.SgwSetting.http.SgwHttpClient;
//import com.sun.dhcpmgr.data.Network;
import com.SgwSetting.network.Network;

import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;


/**
* SearchSgwIpAddressは、スマートゲートウェイの検索を行うクラスです。
* @author　株式会社エネゲート
*
*/
public class SearchSgwIpAddress {

	public static Map<String,String> smartGatewayInfoMap = new HashMap<String,String>();
	//【＠Ver.2.04】：　検索結果のエコンコードもマップで保持する
	public static Map<String,String> smartGatewayEncodeMap = new HashMap<String, String>();
	//スマートゲートウェイタイプ
	public static Map<String,String> smartGatewayTypeMap = new HashMap<String, String>();

	public static boolean isNewVersion = false;
	
	public static final int HTTP_CONNECTION_TIMEOUT = 60000;
	
	// 現在の検索中のIPアドレス
	private String currentIpAddress = "";

    /* {src_lang=Java}*/
	public void calcNetworkAddress() {
		
		int i_subnet = getSubnetCider();
		//i_subnet = 24;	// 第4クォーテッドに限定
		String mask = convertSubnetCIDR2IPv4(i_subnet);
		
		try {
			InetAddress myHost = InetAddress.getLocalHost();
			String ipAddr = myHost.getHostAddress();
			CommonParam.hostAddress = ipAddr;
			Network network = new Network(ipAddr, mask);
			CommonParam.subnetAddress = mask;
			CommonParam.networkAddress = network.getNetworkNumber().toString();
			CommonParam.broadCastAddress = network.getBroadcastAddress();
			System.out.println("ネットワークアドレス        :" + CommonParam.networkAddress);
			System.out.println("ブロードキャストアドレス:" + CommonParam.broadCastAddress);

			// 複数のネットワーク・アドレスを確認する。
			//System.out.println("----------");
			//checkAnotherIpAddress();
			//System.out.println("----------");

		} catch (Exception e) {
			System.out.println("ネットワークアドレスの計算に失敗しました。⇒calcNetworkAddress()");
			//e.printStackTrace();
		}
	}

	// 複数のネットワーク・アドレスを確認
	//public ArrayList<NetworkInfo> checkAnotherIpAddress() {
	public ArrayList<NetworkInfo> getAnotherIpAddress() {

		//NetworkInterfaceクラスを使って複数のIPアドレスを取得
		//【参考】http://harikofu.blog.fc2.com/blog-entry-727.html
		//http://www.itmedia.co.jp/enterprise/articles/0407/27/news031.html
		//http://www.yukun.info/blog/2010/05/java-networkinterface-ipv6-ipv4.html
		
		//ネットワーク情報のリストを初期化
		ArrayList<NetworkInfo> networkInfoList = new ArrayList<NetworkInfo>();

		try {
			// ネットワークインターフェイスを取得
			Enumeration<NetworkInterface> enumNetIF = NetworkInterface.getNetworkInterfaces();
			int default_i_subnet = getSubnetCider();
			//i_subnet = 24;	// 第4オーテッドに限定
			String default_mask = convertSubnetCIDR2IPv4(default_i_subnet);

			// 取得できた場合、処理を行う
			if (null != enumNetIF) {
				int i = 0;
				// ネットワークインターフェイスの全件を処理する
				while (enumNetIF.hasMoreElements()) {
					// ネットワークインターフェイスを１件取得
					NetworkInterface netIF = (NetworkInterface) enumNetIF.nextElement();
					// ネットワークインターフェイスからInetAddressを取得
					Enumeration<InetAddress> enumInetAddress = netIF.getInetAddresses();
					
					// InetAddressの全件を処理する
					while (enumInetAddress.hasMoreElements()) {
						// InetAddressを１件取得
						InetAddress inetAddr = (InetAddress) enumInetAddress.nextElement();
						
						// 取得した情報をログに出力
						if (inetAddr instanceof java.net.Inet4Address && !inetAddr.isLoopbackAddress()) {
							System.out.println("ネットワークインターフェイス【" + netIF.getDisplayName() + "】");
							System.out.println("ローカルホスト	[" + i + "]:" + inetAddr.toString());
							System.out.println("ドメイン名		[" + i + "]:" + inetAddr.getCanonicalHostName());	// ドメイン名
							System.out.println("ホスト名 		[" + i + "]:" + inetAddr.getHostName());			// ホスト名
							System.out.println("IPアドレス		[" + i + "]:" + inetAddr.getHostAddress());			// IPアドレス
							
							String mask = default_mask;
							try {
								int i_subnet = getSubnetCiderByNetIF(netIF);
								mask = convertSubnetCIDR2IPv4(i_subnet);
							} catch (Exception e) { }
							
							try {
								String ipAddr = inetAddr.getHostAddress();
								Network network = new Network(ipAddr, mask);
								
								NetworkInfo inetInfo = new NetworkInfo();
								inetInfo.subnetAdress = mask;
								inetInfo.networkAddress = network.getNetworkNumber().toString();
								inetInfo.broadCastAddress = network.getBroadcastAddress();
								networkInfoList.add(inetInfo);
								
								System.out.println("サブネットマスク	[" + i + "]:" + inetInfo.subnetAdress);
								System.out.println("ネットワークアドレス	[" + i + "]:" + inetInfo.networkAddress);
								System.out.println("ブロードキャストアドレス	[" + i + "]:" + inetInfo.broadCastAddress);
								
							} catch (Exception e) {
								System.out.println("ネットワークアドレス [" + i + "]の計算に失敗しました。⇒calcNetworkAddress()");
								//e.printStackTrace();
							}
							i++;
						}
					}
				}
			} else {
				System.out.println("ネットワークインターフェイス未取得");
			}

		} catch (SocketException e) {
			System.out.println("ネットワークインターフェイス取得エラー");
			e.printStackTrace();
		}
		
		return networkInfoList;
	}

	/**
	 * searchSgwIpは、同一ネットワーク内のスマートゲートウェイを検索するメソッドです
	 * @return スマートゲートウェイの検索に成功した場合はtrue、失敗した場合はfalseを返します。
	 */
	/*SGWの複数検索に対応*/
	//public String searchSgwIp(int spNum) {
	public Map<String,String> searchSgwIp(int spNum) {
		
		//calcNetworkAddress();
		String[] sAry = CommonParam.networkAddress.split("\\.");
		int startIP_Octet1 = Integer.parseInt(sAry[0]);
		int startIP_Octet2 = Integer.parseInt(sAry[1]);
		int startIP_Octet3 = Integer.parseInt(sAry[2]);
		int startIP_Octet4 = Integer.parseInt(sAry[3]);
		String[] eAry = CommonParam.broadCastAddress.split("\\.");
		int endIP_Octet1 = Integer.parseInt(eAry[0]);
		int endIP_Octet2 = Integer.parseInt(eAry[1]);
		int endIP_Octet3 = Integer.parseInt(eAry[2]);
		int endIP_Octet4 = Integer.parseInt(eAry[3]);

		CommonParam.searchEndFlg = false;
		CommonParam.findSgwForSearching = false;

		boolean hasSmartGatewayInfo = false;

		for (int cnt_oct1 = startIP_Octet1; cnt_oct1 <= endIP_Octet1; cnt_oct1++) {// 第一オクテット
			for (int cnt_oct2 = startIP_Octet2; cnt_oct2 <= endIP_Octet2; cnt_oct2++) {// 第2オクテット
				for (int cnt_oct3 = startIP_Octet3; cnt_oct3 <= endIP_Octet3; cnt_oct3++) {// 第3オクテット
					for (int cnt_oct4 = startIP_Octet4; cnt_oct4 <= endIP_Octet4; cnt_oct4++) {// 第4オクテット
						try {
							/*IPアドレス*/
							String checkStrIp = String.valueOf(cnt_oct1) + "."
									+ String.valueOf(cnt_oct2) + "."
									+ String.valueOf(cnt_oct3) + "."
									+ String.valueOf(cnt_oct4);

							if (!checkStrIp.equals(CommonParam.networkAddress) && !checkStrIp.equals(CommonParam.broadCastAddress)) {
								// Log.d("IPアドレス：", String.valueOf(cnt_oct4));

								// 余りがspNumMin～spNumMaxのみを検索対象とする
								if ((cnt_oct4 % CommonParam.THREAD_NUM_SGW_SEARCH) == spNum) {
									String baseUrl = "http://" + String.valueOf(cnt_oct1)
													+ "." + String.valueOf(cnt_oct2)
													+ "." + String.valueOf(cnt_oct3)
													+ "." + String.valueOf(cnt_oct4)
													+ "/";

									InetAddress inetAddress;
									inetAddress = InetAddress.getByName(String .valueOf(cnt_oct1)
											+ "." + String.valueOf(cnt_oct2)
											+ "." + String.valueOf(cnt_oct3)
											+ "."+ String.valueOf(cnt_oct4));
									
									currentIpAddress = inetAddress.getHostAddress();	// 検索中のIPアドレスを保持
									
									//SGW情報判定処理
									synchronized (SearchSgwIpAddress.this) { //スレッドの排他制御のタイミングを早める2
										if (checkSmartGatewayInfo(inetAddress)) {
											hasSmartGatewayInfo = true;
										}
									}
									
/************************************ ここから、SGW情報判定処理　************************************/
//									String sirialNo = "";
//									String url = "";
//									String encode = "Shift_JIS";
//									int type = -1;
//									//Ver 2.17
//									String webPageVersion = "1.00";
//									
//									Boolean resIcmp = false;
//									String[] command = { "ping", "-n", "2", "-w", "30", inetAddress.getHostAddress() };
//									String[] command_for_mac = { "ping", "-c", "2", inetAddress.getHostAddress() };
//									
//									boolean isMacOS = SearchSgwIpAddress.isMacOS();
//									boolean isLinuxOS = SearchSgwIpAddress.isLinuxOS();
//									if (isMacOS || isLinuxOS) {
//										resIcmp = new ProcessBuilder(command_for_mac).start().waitFor() == 0;
//									} else {
//										resIcmp = new ProcessBuilder(command).start().waitFor() == 0;
//									}
//
//									if (resIcmp == true) {
//										synchronized (SearchSgwIpAddress.this) { //スレッドの排他制御のタイミングを早める2
//										System.out.println("ICMP　OK " + inetAddress.getHostAddress());
//
//										/* GETリクエスト発行 */
//										url = baseUrl + "index.cgi";
//										
//										if (CommonParam.useOkHttpClient) {
//											OkHttpClient okHttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
//											
//											Request request = new Request.Builder()
//									                .url(url)
//									                .get()
//									                .build();
//
//											// 同期処理
//											Response response = okHttpClient.newCall(request).execute();
//											if (response.isSuccessful()
//													|| response.code() != HttpURLConnection.HTTP_NOT_FOUND) {
//												System.out.println("リクエストURL: " + url);
//												System.out.println("ステータス文: " + response.code());
//												/* レスポンスボディー内容 */
//												String resStr = response.body().string();
//												
//												/* レスポンスボディーが空白ではない場合、UTF-8にエンコード */
//												if (resStr != null && resStr != ""
//														&& resStr.indexOf("Shift_JIS") > 0) { // レスポンスがShift-JISの時のみ
//													resStr = StringEncoder.encodeUtf8ToSjis(resStr);
//												}
//
//												/* "TopPage"が含まれるか */
//												int checkFile = checkRespBody(resStr);
//												int checkFileForSGW = checkRespBodyForSGW(resStr);
//																										
//												if (checkFile != -1 || checkFileForSGW != -1) {
//
//													CommonParam.smartGatewayIp =
//															String.valueOf(cnt_oct1) + "." +
//																	String.valueOf(cnt_oct2) + "." +
//																	String.valueOf(cnt_oct3) + "." +
//																	String.valueOf(cnt_oct4);
//
//													/*** 製造番号を取得する ***/
//													sirialNo = getSerialNoFromStringText(resStr);
//													/*** エンコードを取得する ***/
//													encode = getEncodeFromStringText(resStr);
//													/*** SGWタイプ ***/
//													type = CommonFunc.getSgwTypeByResString(resStr);
//
//													/*Mapに追加*/
//													smartGatewayInfoMap.put(checkStrIp, sirialNo);
//													smartGatewayEncodeMap.put(checkStrIp, encode);
//													smartGatewayTypeMap.put(checkStrIp, Integer.toString(type));
//
//													hasSmartGatewayInfo = true;
//												}
//											}
//											else {													
//												//index.cgiで接続が拒否された場合
//												url = baseUrl + "index_media.cgi";
//												
//												request = new Request.Builder()
//										                .url(url)
//										                .get()
//										                .build();
//
//												// 同期処理
//												response = okHttpClient.newCall(request).execute();
//												if (response.isSuccessful()
//														|| response.code() != HttpURLConnection.HTTP_NOT_FOUND) {
//											
//													/* レスポンスボディー内容 */
//													String resStr = response.body().string();
//
//													int checkFileForSGWPlusMC = checkRespBodyForSGWplusMC(resStr);
//
//													/* "media.css"が含まれている場合 */														
//													if (checkFileForSGWPlusMC != -1) {															
//														CommonParam.smartGatewayIp =
//																String.valueOf(cnt_oct1) + "." +
//																String.valueOf(cnt_oct2) + "." +
//																String.valueOf(cnt_oct3) + "." +
//																String.valueOf(cnt_oct4);
//
//														/*** 製造番号を取得する ***/
//														sirialNo = SearchSgwIpAddress.getSerialNoFromAuthID(resStr);
//
//														/*** エンコードを取得する ***/
//														encode = getEncodeFromStringText(resStr);
//														
//														/*** SGWタイプを取得する ***/
//														type = CommonFunc.getSgwTypeByResString(resStr);
//
//														/*Mapに追加*/
//														smartGatewayInfoMap.put(checkStrIp, sirialNo);
//														smartGatewayEncodeMap.put(checkStrIp, encode);
//														smartGatewayTypeMap.put(checkStrIp, Integer.toString(type));
//
//														hasSmartGatewayInfo = true;
//													}
//												}
//											}
//										} 
//										// DeaultHttpClientを使用
//										else {
//											//【＠Ver.2.04】： デフォールトのProxy設定をしてHttpクライアンを生成
//											DefaultHttpClient httpClient = SgwHttpClient.createHttpClientWithProxy();
//	
//											HttpParams httpParams = httpClient.getParams();
//											//接続確立のタイムアウトを設定（単位：ms）  ⇒ 2秒
//											HttpConnectionParams.setConnectionTimeout(httpParams, 2*1000);
//											//接続後のタイムアウトを設定（単位：ms）  ⇒ 2秒
//											HttpConnectionParams.setSoTimeout(httpParams, 2*1000);
//	
//											try {
//												HttpResponse res = null;
//												try {
//													res = httpClient.execute(new HttpGet(url));
//												} catch (Exception e) {
//													System.out.println("HTTP NG "+url);
//												}
//												
//												if (res != null && res.getEntity() != null
//														&& res.getStatusLine().getStatusCode() == 200) {	// ステータスコード200
//													
//													StatusLine resLine = res.getStatusLine();
//													System.out.println("リクエストURL: " + url);
//													System.out.println("ステータス文: " + resLine.toString());
//	
//													//if (resCode == 200) {
//													if (resLine != null
//															&& resLine.toString().indexOf("200") > 0) {	// ステータスコード「200」を含む
//														//synchronized (SearchSgwIpAddress.this) {
//	
//															/* レスポンスボディー内容 */
//															String resStr = EntityUtils.toString(res.getEntity(),"UTF-8");
//	
//															// エンティティの後処理（エンティティ内のInputStreamのクローズ処理)
//															EntityUtils.consume(res.getEntity());
//	
//															//【＠Ver.2.04】： レスポンスボディーが空白でない場合、Shift_JISにエンコードする。
//															//実は、「Shift_JIS」の場合、一旦UTF-8でエンコードしてしまっているので、効果がない。
//															if (resStr != null && resStr != ""
//																	&& resStr.indexOf("Shift_JIS") > 0) {	// レスポンスがShift-JISの時のみ
//																resStr = StringEncoder.encodeUtf8ToSjis(resStr);
//															}
//	
//															// 標準出力でパフォーマンスが落ちることを懸念し、一時的にコメントアウトする。
//															int checkFile = checkRespBody(resStr);
//															int checkFileForSGW = checkRespBodyForSGW(resStr);
//	
//															/* "TopPage"が含まれている場合 */
//															if (checkFile != -1 || checkFileForSGW != -1) {
//	
//																/*** 製造番号 ***/
//																sirialNo = getSerialNoFromStringText(resStr);	
//																/*** エンコード ***/
//																encode = getEncodeFromStringText(resStr);															
//																/*** SGWタイプ ***/
//																type = CommonFunc.getSgwTypeByResString(resStr);
//	
//																/*Mapに追加*/
//																smartGatewayInfoMap.put(checkStrIp, sirialNo);
//																smartGatewayEncodeMap.put(checkStrIp, encode);
//																smartGatewayTypeMap.put(checkStrIp, Integer.toString(type));
//	
//																hasSmartGatewayInfo = true;
//	
//															}//"TopPage"含むか判定の閉じ括弧
//														}//resCode==200判定の閉じ括弧
//														try {
//															Thread.sleep(100);
//														} catch (Exception e) {
//															;
//														}
//													} // myClient判定の閉じ括弧
//													else {
//														url = baseUrl + "index_media.cgi";
//														try {
//															res = httpClient.execute(new HttpGet(url));
//														} catch (Exception e) {
//															System.out.println("HTTP NG "+url);
//														}
//														
//														//正常に接続できた場合
//														if (res != null && res.getEntity() != null 
//																&& res.getStatusLine().getStatusCode() == 200) {	// ステータスコード200
//															System.out.println("リクエストURL: " + url);
//															StatusLine resLine = res.getStatusLine();
//															System.out.println("ステータス文: " + resLine.toString());
//															
//															/* レスポンスボディー内容 */
//															String resStr = new String(EntityUtils.toString(res.getEntity()).getBytes("ISO8859-1"), "UTF-8");
//															// エンティティの後処理（エンティティ内のInputStreamのクローズ処理)
//															EntityUtils.consume(res.getEntity());
//															
//															int checkFileForSGW = checkRespBodyForSGWplusMC(resStr);
//	
//															/* "TopPage"が含まれている場合 */
//															if (checkFileForSGW != -1) {
//																/*** 製造番号 ***/
//																sirialNo = getSerialNoFromAuthID(resStr);;	
//																/*** エンコード ***/
//																encode = "UTF-8";																
//																/*** SGWタイプ ***/
//																type = CommonFunc.getSgwTypeByResString(resStr);
//	
//																/*Mapに追加*/
//																smartGatewayInfoMap.put(checkStrIp, sirialNo);
//																smartGatewayEncodeMap.put(checkStrIp, encode);
//																smartGatewayTypeMap.put(checkStrIp, Integer.toString(type));
//	
//																hasSmartGatewayInfo = true;
//															}
//														}
//													}
//												} catch (SocketTimeoutException sｔe) {
//													System.out.println("[Error]:ソケット接続タイムアウト: " + url);
//												} catch (HttpHostConnectException he) {
//													System.out.println("[Error]:Http接続できませんでした。: " + url);
//												} catch (ConnectTimeoutException cte) {
//													System.out.println("[Error]:接続タイムアウト" + url);
//												} catch (ConnectException ce) {
//													System.out.println("[Error]:接続できませんでした。: " + url);
//												} catch (Exception e) {
//													e.printStackTrace();
//												} finally {
//													// コネクションを確実に終了させる
//													httpClient.getConnectionManager().shutdown();
//												}
//											}
//										} //synchronizedの閉じ括弧
//									} else
//									{
//										System.out.println("ICMP　NG " + inetAddress.getHostAddress());
//									}
/************************************ ここまで、SGW情報判定処理　************************************/
									
								}// 余りがspNumMin～spNumMaxのみを検索対象とする
							}// ネットワークアドレスと違うなら
						} catch (Exception e) {
							//System.out.println("ステータスコード（又はレスポンスボディ）の取得に失敗しました。⇒searchSgwIp() -> " + currentIpAddress);
							//e.printStackTrace();
						}
					}// 第4オクテット閉じ括弧

					// 検索終了フラグをtrueに設定
					boolean isMacOS = SearchSgwIpAddress.isMacOS();
					if (hasSmartGatewayInfo && !isMacOS) {
						CommonParam.searchEndFlg = true;
						CommonParam.findSgwForSearching = true;
					}
				}// 第3オクテット閉じ括弧
			}// 第2オクテット閉じ括弧
		}// 第1オクテット閉じ括弧

		// ↑↑↑↑↑↑↑↑↑　上のfor文のループ中にも追加しました。 ↑↑↑↑↑↑↑↑↑
		// 検索終了フラグをtrueに設定
		CommonParam.searchEndFlg = true;
				
		return smartGatewayInfoMap;
	}
	
	/**
	 * スマートゲートウェイ情報の判定処理
	 * 
	 * @return スマートゲートウェイの情報取得できた場合はtrue、失敗した場合はfalseを返します。
	 */
	//public static boolean checkSmartGatewayInfo(SearchSgwIpAddress searchSgwIpAddress, InetAddress inetAddress) throws Exception {
	public static boolean checkSmartGatewayInfo(InetAddress inetAddress) throws Exception {
		boolean hasSmartGatewayInfo = false;
		
		String sirialNo = "";
		String url = "";
		String encode = "Shift_JIS";
		int type = -1;
		//Ver 2.17
		String webPageVersion = "1.00";
		
		String checkStrIp = inetAddress.getHostAddress();
		String baseUrl = "http://" + checkStrIp + "/";
		
		Boolean resIcmp = false;
		String[] command = { "ping", "-n", "2", "-w", "30", inetAddress.getHostAddress() };
		String[] command_for_mac = { "ping", "-c", "2", inetAddress.getHostAddress() };
		
		try {
			boolean isMacOS = SearchSgwIpAddress.isMacOS();
			boolean isLinuxOS = SearchSgwIpAddress.isLinuxOS();
			if (isMacOS || isLinuxOS) {
				resIcmp = new ProcessBuilder(command_for_mac).start().waitFor() == 0;
			} else {
				resIcmp = new ProcessBuilder(command).start().waitFor() == 0;
			}
			
			int searchResultCount = 0;
			if (smartGatewayInfoMap != null && !smartGatewayInfoMap.isEmpty()) {
				searchResultCount = smartGatewayInfoMap.size();
			}
			
			if (resIcmp == true) {
				//synchronized (searchSgwIpAddress) { //スレッドの排他制御のタイミングを早める2
				System.out.println("ICMP OK [" + searchResultCount + "] " + inetAddress.getHostAddress());
	
				/* GETリクエスト発行 */
				url = baseUrl + "index.cgi";
				
				if (CommonParam.useOkHttpClient) {
					//OkHttpClient okHttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
					OkHttpClient okHttpClient = SgwHttpClient.createOkHttpClientWithProxy(HTTP_CONNECTION_TIMEOUT);
					
					Request request = new Request.Builder()
			                .url(url)
			                .get()
			                .build();
	
					// 同期処理
					Response response = okHttpClient.newCall(request).execute();
					if (response.isSuccessful()
							|| response.code() != HttpURLConnection.HTTP_NOT_FOUND) {
						System.out.println("リクエストURL: " + url);
						System.out.println("ステータス文: " + response.code());
						/* レスポンスボディー内容 */
						String resStr = response.body().string();
						
						/* レスポンスボディーが空白ではない場合、UTF-8にエンコード */
						if (resStr != null && resStr != ""
								&& resStr.indexOf("Shift_JIS") > 0) { // レスポンスがShift-JISの時のみ
							resStr = StringEncoder.encodeUtf8ToSjis(resStr);
						}
	
						/* "TopPage"が含まれるか */
						int checkFile = checkRespBody(resStr);
						int checkFileForSGW = checkRespBodyForSGW(resStr);
																				
						if (checkFile != -1 || checkFileForSGW != -1) {
	
							//CommonParam.smartGatewayIp =
							//		String.valueOf(cnt_oct1) + "." +
							//				String.valueOf(cnt_oct2) + "." +
							//				String.valueOf(cnt_oct3) + "." +
							//				String.valueOf(cnt_oct4);
							CommonParam.smartGatewayIp = inetAddress.getHostAddress();
	
							/*** 製造番号を取得する ***/
							sirialNo = getSerialNoFromStringText(resStr);
							/*** エンコードを取得する ***/
							encode = getEncodeFromStringText(resStr);
							/*** SGWタイプ ***/
							type = CommonFunc.getSgwTypeByResString(resStr);
	
							/*Mapに追加*/
							smartGatewayInfoMap.put(checkStrIp, sirialNo);
							smartGatewayEncodeMap.put(checkStrIp, encode);
							smartGatewayTypeMap.put(checkStrIp, Integer.toString(type));
	
							hasSmartGatewayInfo = true;
						}
					}
					else {													
						//index.cgiで接続が拒否された場合
						url = baseUrl + "index_media.cgi";
						
						request = new Request.Builder()
				                .url(url)
				                .get()
				                .build();
	
						// 同期処理
						response = okHttpClient.newCall(request).execute();
						if (response.isSuccessful()
								|| response.code() != HttpURLConnection.HTTP_NOT_FOUND) {
					
							/* レスポンスボディー内容 */
							String resStr = response.body().string();
	
							int checkFileForSGWPlusMC = checkRespBodyForSGWplusMC(resStr);
	
							/* "media.css"が含まれている場合 */														
							if (checkFileForSGWPlusMC != -1) {															
								//CommonParam.smartGatewayIp =
								//		String.valueOf(cnt_oct1) + "." +
								//		String.valueOf(cnt_oct2) + "." +
								//		String.valueOf(cnt_oct3) + "." +
								//		String.valueOf(cnt_oct4);
								CommonParam.smartGatewayIp = inetAddress.getHostAddress();
	
								/*** 製造番号を取得する ***/
								sirialNo = SearchSgwIpAddress.getSerialNoFromAuthID(resStr);
	
								/*** エンコードを取得する ***/
								encode = getEncodeFromStringText(resStr);
								
								/*** SGWタイプを取得する ***/
								type = CommonFunc.getSgwTypeByResString(resStr);
	
								/*Mapに追加*/
								smartGatewayInfoMap.put(checkStrIp, sirialNo);
								smartGatewayEncodeMap.put(checkStrIp, encode);
								smartGatewayTypeMap.put(checkStrIp, Integer.toString(type));
	
								hasSmartGatewayInfo = true;
							}
						}
					}
				} 
				// DeaultHttpClientを使用
				else {
					//【＠Ver.2.04】： デフォールトのProxy設定をしてHttpクライアンを生成
					//DefaultHttpClient httpClient = SgwHttpClient.createHttpClientWithProxy();
					DefaultHttpClient httpClient = SgwHttpClient.createHttpClientWithProxy(HTTP_CONNECTION_TIMEOUT);
	
					HttpParams httpParams = httpClient.getParams();
					//接続確立のタイムアウトを設定（単位：ms）  ⇒ 2秒
					HttpConnectionParams.setConnectionTimeout(httpParams, 2*1000);
					//接続後のタイムアウトを設定（単位：ms）  ⇒ 2秒
					HttpConnectionParams.setSoTimeout(httpParams, 2*1000);
	
					try {
						HttpResponse res = null;
						try {
							res = httpClient.execute(new HttpGet(url));
						} catch (Exception e) {
							System.out.println("HTTP NG "+url);
						}
						
						if (res != null && res.getEntity() != null
								&& res.getStatusLine().getStatusCode() == 200) {	// ステータスコード200
							
							StatusLine resLine = res.getStatusLine();
							System.out.println("リクエストURL: " + url);
							System.out.println("ステータス文: " + resLine.toString());
	
							//if (resCode == 200) {
							if (resLine != null
									&& resLine.toString().indexOf("200") > 0) {	// ステータスコード「200」を含む
								//synchronized (SearchSgwIpAddress.this) {
	
									/* レスポンスボディー内容 */
									String resStr = EntityUtils.toString(res.getEntity(),"UTF-8");
	
									// エンティティの後処理（エンティティ内のInputStreamのクローズ処理)
									EntityUtils.consume(res.getEntity());
	
									//【＠Ver.2.04】： レスポンスボディーが空白でない場合、Shift_JISにエンコードする。
									//実は、「Shift_JIS」の場合、一旦UTF-8でエンコードしてしまっているので、効果がない。
									if (resStr != null && resStr != ""
											&& resStr.indexOf("Shift_JIS") > 0) {	// レスポンスがShift-JISの時のみ
										resStr = StringEncoder.encodeUtf8ToSjis(resStr);
									}
	
									// 標準出力でパフォーマンスが落ちることを懸念し、一時的にコメントアウトする。
									int checkFile = checkRespBody(resStr);
									int checkFileForSGW = checkRespBodyForSGW(resStr);
	
									/* "TopPage"が含まれている場合 */
									if (checkFile != -1 || checkFileForSGW != -1) {
	
										/*** 製造番号 ***/
										sirialNo = getSerialNoFromStringText(resStr);	
										/*** エンコード ***/
										encode = getEncodeFromStringText(resStr);															
										/*** SGWタイプ ***/
										type = CommonFunc.getSgwTypeByResString(resStr);
	
										/*Mapに追加*/
										smartGatewayInfoMap.put(checkStrIp, sirialNo);
										smartGatewayEncodeMap.put(checkStrIp, encode);
										smartGatewayTypeMap.put(checkStrIp, Integer.toString(type));
	
										hasSmartGatewayInfo = true;
	
									}//"TopPage"含むか判定の閉じ括弧
								}//resCode==200判定の閉じ括弧
								try {
									Thread.sleep(100);
								} catch (Exception e) {
									;
								}
							} // myClient判定の閉じ括弧
							else {
								url = baseUrl + "index_media.cgi";
								try {
									res = httpClient.execute(new HttpGet(url));
								} catch (Exception e) {
									System.out.println("HTTP NG "+url);
								}
								
								//正常に接続できた場合
								if (res != null && res.getEntity() != null 
										&& res.getStatusLine().getStatusCode() == 200) {	// ステータスコード200
									System.out.println("リクエストURL: " + url);
									StatusLine resLine = res.getStatusLine();
									System.out.println("ステータス文: " + resLine.toString());
									
									/* レスポンスボディー内容 */
									String resStr = new String(EntityUtils.toString(res.getEntity()).getBytes("ISO8859-1"), "UTF-8");
									// エンティティの後処理（エンティティ内のInputStreamのクローズ処理)
									EntityUtils.consume(res.getEntity());
									
									int checkFileForSGW = checkRespBodyForSGWplusMC(resStr);
	
									/* "TopPage"が含まれている場合 */
									if (checkFileForSGW != -1) {
										/*** 製造番号 ***/
										sirialNo = getSerialNoFromAuthID(resStr);;	
										/*** エンコード ***/
										encode = "UTF-8";																
										/*** SGWタイプ ***/
										type = CommonFunc.getSgwTypeByResString(resStr);
	
										/*Mapに追加*/
										smartGatewayInfoMap.put(checkStrIp, sirialNo);
										smartGatewayEncodeMap.put(checkStrIp, encode);
										smartGatewayTypeMap.put(checkStrIp, Integer.toString(type));
	
										hasSmartGatewayInfo = true;
									}
								}
							}
						} catch (SocketTimeoutException sｔe) {
							System.out.println("[Error]:ソケット接続タイムアウト: " + url);
						} catch (HttpHostConnectException he) {
							System.out.println("[Error]:Http接続できませんでした。: " + url);
						} catch (ConnectTimeoutException cte) {
							System.out.println("[Error]:接続タイムアウト" + url);
						} catch (ConnectException ce) {
							System.out.println("[Error]:接続できませんでした。: " + url);
						} catch (Exception e) {
							e.printStackTrace();
						} finally {
							// コネクションを確実に終了させる
							httpClient.getConnectionManager().shutdown();
						}
					}
				//} //synchronizedの閉じ括弧
			} else {
				System.out.println("ICMP NG [" + searchResultCount + "] " + inetAddress.getHostAddress());
			}
		} catch (Exception e) {
			throw e;
		}
		
		return hasSmartGatewayInfo;
	}

	public static String getSerialNoFromStringText(String resStr) {
		String sirialNo = "";
		try {
			/*日本語版 or 英語版*/
			int langIndex = resStr.indexOf("<html lang=\"ja\">");
			if (langIndex != -1) {
				CommonParam.lang = "ja";
			} else {
				CommonParam.lang = "en";
			}

			int idIndex = resStr.indexOf("ID");
			if (idIndex != -1) {

				// 日本語版の場合
				if (CommonParam.lang == "ja") {
					sirialNo = resStr.substring(idIndex + 4, idIndex + 4 + 8);

					//SGW対策（１文字ずらして取得する）
					if (sirialNo != null && sirialNo.trim().length() == 7) {
						sirialNo = resStr.substring(idIndex + 3, idIndex + 3 + 8);
					}

				// 英語版の場合
				} else if (CommonParam.lang == "en") {
					sirialNo = resStr.substring(idIndex + 3, idIndex + 3 + 8);
				}
			}
		} catch (Exception e) {  }
		return sirialNo;
	}
	
	public static String getAuthIDFromStringText(String resStr) {
		String authID = "";
		try {
			int firstIndex = resStr.indexOf("<td>");
			int lastIndex = resStr.indexOf("</td>", firstIndex);
			if (firstIndex != -1 && firstIndex < lastIndex) {
				authID = resStr.substring(firstIndex + 4, lastIndex);
			}
		} catch (Exception e) {  }
		return authID;
	}
	
	public static String getSerialNoFromAuthID(String resStr) {
		String sirialNo = "--------";
		try {
			String authID = getAuthIDFromStringText(resStr);
			if (authID.length() == 39) { 
				sirialNo = authID.substring(30, 34) + authID.substring(35, 39);
			}
		} catch (Exception e) {  }
		return sirialNo;
	}

//	/**
//	 *  Version確認
//	 *
//	 * @param resStr
//	 * @return Ver.に続く文字列(4文字分)を戻します
//	 */
//	public static String getVersionFromStringText(String resStr) {
//		String strVersion = "";
//
//		try {
//			//Versionを確認する為に「Ver.」の有無を判定
//			int idIndex = resStr.indexOf("Ver.");
//			if (idIndex != -1) {
//
//				//Ver.に続く4文字を取得
//				strVersion = resStr.substring(idIndex + 4, idIndex + 8);
//
//				//Ver.に続く4文字を取得しfloat型にキャスト
//				Float fVersion = Float.valueOf(strVersion);
//				//2.0以上であれば新バージョンと判断
//				if (fVersion >= 2.0f) {
//					isNewVersion = true;
//				}
//			}
//		} catch (Exception e) {}
//		return strVersion;
//	}


	/**
	 * テキストデータからエンコード指定の文字列を取得する
	 *
	 * @param resStr
	 * @return Shift_JISまたはUTF-8を戻します。
	 */
	public static String getEncodeFromStringText(String resStr) {
		String retStr = "Shift_JIS";
		try {
			if (resStr != null && resStr.indexOf("UTF-8") > 0) {
				retStr = "UTF-8";
			}
		} catch (Exception e) {  }
		return retStr;
	}

	private static int checkRespBody(String resStr)
	{
		//int res = resStr.indexOf(CommonParam.SEARCH_STR_HTMLFILE);
		int res_1 = resStr.indexOf(CommonParam.SEARCH_STR_HTMLFILE_1);
		int res_2 = resStr.indexOf(CommonParam.SEARCH_STR_HTMLFILE_2);
		int res = res_1;
		if (res < res_2) { res = res_2; }
		return res;
	}

	private static int checkRespBodyForSGW(String resStr)
	{
		int res_for_sgw = resStr.indexOf(CommonParam.SEARCH_STR_HTMLFILE_FOR_SGW);
		int res_for_sgw_en = resStr.indexOf(CommonParam.SEARCH_STR_HTMLFILE_FOR_SGW_EN);
		int res = res_for_sgw;
		if (res_for_sgw < res_for_sgw_en) { res = res_for_sgw_en; }
		return res;
	}
	
	/**
	 * スマートゲートウェイのタイプ判定（for SGW-Plus Ver.3.xx）　【＠Ver.2.22】
	 *
	 * @param resStr HTMLレスポンス
	 * @return スマートゲートウェイのタイプ判定結果を戻します。
	 */
	private static int checkRespBodyForSGWplusMC(String resStr)
	{
		int res_for_sgw_plus = resStr.indexOf(CommonParam.SEARCH_STR_HTMLFILE_FOR_SGW_PLUS_MC);
		return res_for_sgw_plus;
	}

	private static boolean sendGetRequest(SgwHttpClient myClient){
		try {
			myClient.doGet();
		} catch (Exception e) {
			//e.printStackTrace();
			System.out.println("GETリクエストに失敗しました。");
			return false;
		}
		return true;
	}

	/**
	 * サブネット(CIDER表記)をIPv4形式に変換
	 * @param subnet
	 *            サブネット(CIDR表記) : 0〜32
	 * @return 結果文字列(IPv4形式のサブネットマスク)
	 */
	private static String convertSubnetCIDR2IPv4(final int subnet) {
		if (subnet < 0 || subnet > 32) {
	    	// MacOSの場合はエラーを回避する
	    	if (isMacOS() || isLinuxOS()) {
		    	System.out.println("[エラー]: 引数(subnet)は 0〜32 までの数値でなければなりません。(" + subnet + ")");
		    	//【暫定措置】: 典型的なサブネット形式を戻す
		    	return "255.255.255.0";	
	    	} else {
		        throw new IllegalArgumentException(
		            "引数(subnet)は 0〜32 までの数値でなければなりません。(" + subnet + ")");
	    	}
	    }
	    
	    // 典型的なサブネット形式
	    if (subnet % 8 == 0) {
	        if (subnet == 8) {
	            return "255.0.0.0";
	        } else if (subnet == 16) {
	            return "255.255.0.0";
	        } else if (subnet == 24) {
	            return "255.255.255.0";
	        }
	    }

	    // 汎用的なサブネット変換
	    final StringBuilder subnetBinary = new StringBuilder(
	        Long.toBinaryString((long) (Math.pow(2, subnet) - 1)));
	    for (int i = subnetBinary.length(); i <= 32; i++) {
	        subnetBinary.append("0");
	    }

	    final StringBuilder result = new StringBuilder();
	    for (int i = 8, length = subnetBinary.length(); i <= length; i += 8) {
	        result.append(Integer.parseInt(subnetBinary.substring(i - 8, i), 2)).append(".");
	    }
	    result.setLength(result.length() - 1);
	    
	    return result.toString();
	}

	/**
	 * サブネット(CIDER表記)を取得
	 * @return サブネット(CIDR表記) : 0〜32
	 */
	private static int getSubnetCider(){
		try{
			InetAddress thiscomputer = InetAddress.getLocalHost();
			NetworkInterface thisNetworkInterface = NetworkInterface.getByInetAddress(thiscomputer);
			int thisComputerSubnetMask = thisNetworkInterface.getInterfaceAddresses().get(0).getNetworkPrefixLength();
			return thisComputerSubnetMask;
			//return 0;
		}catch(Exception e){
			System.out.println("サブネットマスクの取得に失敗しました。⇒getSubnetCider()");
			return 0;
		}
	}
	
	/**
	 * サブネット(CIDER表記)を取得
	 * @return サブネット(CIDR表記) : 0〜32
	 */
	private static int getSubnetCiderByNetIF(NetworkInterface netIF){
		try{
			NetworkInterface thisNetworkInterface = netIF;
			int thisComputerSubnetMask = thisNetworkInterface.getInterfaceAddresses().get(0).getNetworkPrefixLength();
			return thisComputerSubnetMask;
		}catch(Exception e){
			System.out.println("サブネットマスクの取得に失敗しました。⇒getSubnetCiderByNetIF()");
			return 0;
		}
	}

	/**
	 * 指定したURLにHTTPリクエスト要求し、そのレスポンスボディを取得
	 *
	 * @param requestURL リクエストURL
	 * @return HTTPレスポンスのボディ部分を戻します。
	 */
	private String getResponseBody(String requestURL) {
		 // クライアントの生成
		//DefaultHttpClient client = new DefaultHttpClient();
		//DefaultHttpClient client = SgwHttpClient.createHttpClientWithProxy();
		DefaultHttpClient client = SgwHttpClient.createHttpClientWithProxy(HTTP_CONNECTION_TIMEOUT);

		try {
			// 対象ページにアクセス
			HttpGet httpget = new HttpGet(requestURL);
			HttpResponse res = null;
			res = client.execute(httpget);

			String responseBody = "";
			if (res.getEntity() != null) {
				// ボディの取得
				//【＠Ver.2.04】：SGW-Plusか、エンコード指定がUTF-8の場合のみ、UTF-8でエンコード
				//          それ以外は、デフォールトのShift_JISでエンコード処理する
				if (SgwMiniSetup.IS_SGW_PLUS || SgwMiniSetup.isUtf8Encode()) {
					responseBody = EntityUtils.toString(res.getEntity(),"UTF-8");
				} else {
					responseBody = EntityUtils.toString(res.getEntity(),"SJIS");
				}
			}
			// エンティティの後処理（エンティティ内のInputStreamのクローズ処理)
			EntityUtils.consume(res.getEntity());

//			/*レスポンスボディーが空白ではない場合、Shift_JISにエンコード*/
//			if (responseBody != null && responseBody != ""
//					&& responseBody.indexOf("Shift_JIS") > 0) {	// レスポンスがShift-JISの時のみ
//				responseBody = StringEncoder.encodeUtf8ToSjis(responseBody);
//			}

			return responseBody;

		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			// コネクションを確実に終了させる
			client.getConnectionManager().shutdown();
		}

		return null;
	}


	/**
	 * Mac OSかどうかを判定する
	 *
	 * @return Mac OSかどうかを戻します。
	 */
	public static boolean isMacOS() {
		boolean rtnBoo = false;
		String osname = System.getProperty("os.name");
		// MacOSであったときの処理
		if (osname.indexOf("Mac") >= 0) {
			rtnBoo = true;
		}
		return rtnBoo;
	}
	
	/**
	 * Linux OSかどうかを判定する
	 *
	 * @return Linux OSかどうかを戻します。
	 */
	public static boolean isLinuxOS() {
		boolean rtnBoo = false;
		String osname = System.getProperty("os.name");
		// LinuxOSであったときの処理
		if (osname.indexOf("Linux") >= 0) {
			rtnBoo = true;
		}
		return rtnBoo;
	}
	
	/**
	 * 検索中のIPアドレスを取得する
	 *
	 * @return 検索中のIPアドレスを戻します。
	 */
	public String getCurrentIpAddress() {
		return currentIpAddress;
	}

	/*public static void main(String[] args) {
		SearchSgwIpAddress sgwAddress = new SearchSgwIpAddress();
		sgwAddress.searchSgwIp();
	}*/

}