package com.SgwSetting.thread;

import java.awt.print.Pageable;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.InetAddress;
import java.net.SocketTimeoutException;
import java.net.URL;
import java.util.Calendar;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import com.SgwMiniSetup.common.CommonFunc;
import com.SgwMiniSetup.sample.SgwMiniSetup;
import com.SgwSetting.common.CommonParam;
import com.SgwSetting.http.HTMLAnalyzer;
import com.SgwSetting.http.SgwHttpClient;
import com.SgwSetting.smartgateway.SearchSgwIpAddress;

import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;


public class ThreadStart {
	private long start = 0;
	private long end = 0;
	//カレンダー
	private int iyear;
	private int imonth;
	private int iday;
	private int ihour;
	private int iminute;
	private int isecond;
	private String year;
	private String month;
	private String day;
	private String hour;
	private String minute;
	//日付取得
	private Calendar calendar = Calendar.getInstance();
	
	String sgwIpAddress;
	
	// コンストラクタ
	public ThreadStart() {
		this.sgwIpAddress = CommonParam.smartGatewayIp;
	}
	public ThreadStart(String sgwIpAddress) {
		this.sgwIpAddress = sgwIpAddress;
	}

    public String StartThreadSearchSgw(){
    	return this.StartThreadSearchSgw(null);
    }
    public String StartThreadSearchSgw(JFrame frame){
    	CommonParam.searchEndFlg = false;
    	CommonParam.findSgwForSearching = false;
    	CommonParam.checkSearchResult = true;
    	CommonParam.continueSearchResult = false;
    	CommonParam.stopSearchResult = false;
    	
    	start = System.currentTimeMillis();
    	
		String[] sAry = CommonParam.subnetAddress.split("\\.");
		if(Integer.parseInt(sAry[3]) == 0){
			;
		}else{
			CommonParam.THREAD_NUM_SGW_SEARCH = CommonParam.MAX_HOST_NUM - Integer.parseInt(sAry[3]);
			CommonParam.restThread = CommonParam.THREAD_NUM_SGW_SEARCH;
		}

		//スレッド用リストの初期化
		CommonFunc.clearSearchThreadList();
		
		// マルチキャスト受信開始
		SendMulticastToSgw multicastThread = new SendMulticastToSgw();
		multicastThread.start();
		try {
			Thread.sleep(1000); // 1秒待つ
		} catch(Exception e) {}
		multicastThread.sendMulticast();   // マルチキャスト送信
		
		for(int i = 1; i < CommonParam.THREAD_NUM_SGW_SEARCH; i++){
			SearchSgwThread th;
			th = new SearchSgwThread(i);
			th.start();

			//スレッド用リストに格納
			CommonFunc.addSearchThreadList(th);
		}

		SearchSgwThread0 th0 = new SearchSgwThread0();
		th0.start();
    	CommonFunc.addSearchThreadList(th0);
    	
    	//while(CommonParam.serchEndFlg == false){
		//while (CommonParam.serchEndFlg == false && CommonParam.restThread > 1) {
		do {
			Thread lastTh = CommonFunc.getLastSgwSearchThread();
			if (lastTh != null 
					&& ((SearchSgwThread) lastTh).getCurrentIpAddress() != null) {
				System.out.println("スレッド数：(" + CommonFunc.getSearchThreadList().size() + ") 最終スレッドIP = [" + ((SearchSgwThread) lastTh).getCurrentIpAddress() +"]");
			} else {
				System.out.println("スレッド数：(" + CommonParam.restThread + ")");
			}
			
			/* SGW検索全スレッドの実行済を確認 */
			try {
				Thread.sleep(1 * 1000);	// スレッドのチェック間隔を1秒単位

				long time = (System.currentTimeMillis() - start) / 1000;
				
				//30秒後毎に、マルチキャスト送信
				if (!CommonParam.findSgwForSearching) {
					long add_time = time % CommonParam.THREAD_WAIT_TIME;
					if (add_time > CommonParam.THREAD_WAIT_TIME - 2) {
						multicastThread.sendMulticast();   // マルチキャスト送信
					}
				}
				
				// 最大待ち時間を過ぎると自動的に終了
				if (time > CommonParam.MAX_WAIT_TIME) {
					break;
				}
				
				// 最後のスレッドの場合は、20秒に縮める
				if (CommonParam.restThread == 1 
						&& time > CommonParam.MAX_WAIT_TIME_0) {
					break;
				}
				
				// 検索結果が見つかったら、ダイアログ確認して検索終了
				if (((CommonParam.checkSearchResult && CommonParam.findSgwForSearching
						&& time > CommonParam.MAX_WAIT_TIME_1)								// 30秒以上掛かっている
						|| CommonParam.stopSearchResult)									// 検索中止フラグが立っていない
						&& !com.SgwMiniSetup.common.CommonParam.registAllServerHost) {		// サーバ一括登録モードではない
					int size = 0;
					if (!SearchSgwIpAddress.smartGatewayInfoMap.isEmpty()) {
						size = SearchSgwIpAddress.smartGatewayInfoMap.size();
					}
					String title = "検索を終了しますか？";
					String mes = "スマートゲートウェイが " + size + "件見つかりました。\n\n検索を終了しますか？\n\n";
					int res = JOptionPane.showConfirmDialog(frame, mes, title, JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
					if (res == JOptionPane.YES_OPTION) {
						CommonParam.searchEndFlg = true;	// 検索終了フラグをtrueに設定
						break;
					} else if (res == JOptionPane.NO_OPTION) {
						CommonParam.checkSearchResult = false;	// 検索確認フラグをfalseに設定
						CommonParam.stopSearchResult = false;
					}
				}
				
				// 検索結果が見つからず、ダイアログ確認して検索終了
				if (!CommonParam.continueSearchResult && !CommonParam.findSgwForSearching
						&& time > CommonParam.MAX_WAIT_TIME_2								// 60秒以上掛かっている
						&& !com.SgwMiniSetup.common.CommonParam.registAllServerHost) {		// サーバ一括登録モードではない
					int size = 0;
					if (!SearchSgwIpAddress.smartGatewayInfoMap.isEmpty()) {
						size = SearchSgwIpAddress.smartGatewayInfoMap.size();
					}
					String title = "検索を続けますか？";
					String mes = "スマートゲートウェイが見つかりません。\n\nそれでも、検索を続けますか？\n （*最大10分かかる場合がございます）\n\n";
					String selectvalues[] = {"はい", "いいえ"};
					int res = JOptionPane.showOptionDialog(frame, mes, title, JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE, null, selectvalues, selectvalues[1]);
					if (res == 1) {
						CommonParam.searchEndFlg = true;	// 検索終了フラグをtrueに設定
						break;
					} else if (res == 0) {
						CommonParam.continueSearchResult = true;	// 検索続行をtrueに設定
					}
				}
				
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		} while (CommonParam.restThread > 0 
				&& CommonFunc.getSearchThreadList().size() > 0);

		end = System.currentTimeMillis();
		System.out.println("検索時間：" + String.valueOf((end - start) / 1000) + "秒");

    	if(CommonParam.restThread >= 1){
    		System.out.println(CommonParam.restThread + "個のスレッドが時間内に終了しませんでした");
    	}
    	
    	//マルチキャスト処理を止める
    	multicastThread.stopRecievingMulticast();
    	
		//残っているThreadをクリアする
		CommonFunc.clearSearchThreadList();
		
		String[] str = CommonParam.smartGatewayIp.split("\\.");
		if (str.length == 4) {
			return CommonParam.smartGatewayIp;
		} else {
			return "";
		}
	}
    
	/**
	 * スマートゲートウェイへログインを送信するメソッドです
	 * @return　スマートゲートウェイへの会員登録が成功した場合はtrue、失敗した場合はfalseを返します。　
	 */
	public boolean loginToSgw() {
		boolean result = false;
		try {
			String myUrl = "http://" + this.sgwIpAddress + CommonParam.CGI_FILENAME_LOGIN;
			SgwHttpClient myClient = new SgwHttpClient(myUrl);
			String myMessage = "USER=root&PASSWORD=root";
			myClient.doPost(myMessage);
			myClient.getStatusCode();
			int stscode = myClient.getStatusCode();
			if(stscode != HttpURLConnection.HTTP_NOT_FOUND){
				result = true;
				System.out.println("... SGWにログインしました [成功]");
			} else {
				System.out.println("... SGWにログインできませんでした [失敗]");
			}
			//System.out.println(myClient.getStatusCode());
			//System.out.println(myClient.getResponseToString());
		} catch (Exception e) {
			if (e instanceof SocketTimeoutException){
				System.out.println("... SGWにログインできませんでした [通信失敗]");
			} else {
				e.printStackTrace();
			}
		}
		return result;
	}
	
	/**
	 * スマートゲートウェイへ会員登録要求を送信するメソッドです
	 * @return　スマートゲートウェイへの会員登録が成功した場合はtrue、失敗した場合はfalseを返します。　
	 */
	public boolean registMember() {
		boolean result = false;
		try {
			String myUrl = "http://" + this.sgwIpAddress + CommonParam.CGI_FILENAME_REGIST_MEMB;
			SgwHttpClient myClient = new SgwHttpClient(myUrl);
			String myMessage = "YES_BTN=はい&CENTER_CONFIRM=OK";
			myClient.doPost(myMessage);
			myClient.getStatusCode();
			int stscode = myClient.getStatusCode();
			if(stscode != HttpURLConnection.HTTP_NOT_FOUND){
				result = true;
				System.out.println("... 会員登録しました [成功]");
			} else {
				System.out.println("... 会員登録できませんでした [失敗]");
			}
			//System.out.println(myClient.getStatusCode());
			//System.out.println(myClient.getResponseToString());
		} catch (Exception e) {
			if (e instanceof SocketTimeoutException){
				System.out.println("... 会員登録できませんでした [通信失敗]");
			} else {
				e.printStackTrace();
			}
		}
		return result;
	}

	/**
	 * スマートゲートウェイへ時刻設定要求を送信するメソッドです
	 * @return　スマートゲートウェイへの通信が成功した場合はtrue、失敗した場合はfalseを返します。　
	 */
	public boolean setDate() {
		boolean result = false;
		try {
			String myUrl = "http://" + this.sgwIpAddress + CommonParam.CGI_FILENAME_TIME_SET;
			SgwHttpClient myClient = new SgwHttpClient(myUrl);
			//String myMessage = "TIME_YEAR=2013&TIME_MON=1&TIME_DAY=1&TIME_HOUR=2&TIME_MIN=2&SETTING_BTN=設定";
			timerCalendor();
			String myMessage = "TIME_YEAR=" + year +
								"&TIME_MON=" + month +
								"&TIME_DAY=" + day +
								"&TIME_HOUR=" + hour +
								"&TIME_MIN=" + minute +
								"&SETTING_BTN=設定";

			myClient.doPost(myMessage);
			int stscode = myClient.getStatusCode();
			if(stscode != HttpURLConnection.HTTP_NOT_FOUND){
				result = true;
				System.out.println("... 時刻設定しました [成功]　-> " + sgwIpAddress);
			} else {
				System.out.println("... 時刻設定できませんでした [失敗]　-> " + sgwIpAddress);
			}
			//System.out.println(myClient.getStatusCode());
			//System.out.println(myClient.getResponseToString());
		} catch (Exception e) {
			if (e instanceof SocketTimeoutException){
				System.out.println("... 時刻設定できませんでした [通信失敗]　-> " + sgwIpAddress);
			} else {
				e.printStackTrace();
			}
		}
		return result;
	}

	/**
	 * カレンダークラスから現在の年月日時分を取得する
	 * @param	なし
	 * @return	なし
	 * @throws Exception
	 */
	private void timerCalendor() throws Exception{

		try
		{
			calendar = Calendar.getInstance();
			//年の取得
			iyear = calendar.get(Calendar.YEAR);
			//月の取得
			imonth = calendar.get(Calendar.MONTH) + 1;
			//日の取得
			iday = calendar.get(Calendar.DATE);
			//時間の取得
			ihour = calendar.get(Calendar.HOUR_OF_DAY);
			//分の取得
			iminute = calendar.get(Calendar.MINUTE);
			//秒の取得
			isecond = calendar.get(Calendar.SECOND);
			year = String.valueOf(iyear);
			month = String.valueOf(imonth);
			day = String.valueOf(iday);
			hour = String.valueOf(ihour);
			minute = String.valueOf(iminute);
			String.valueOf(isecond);

			//int kminute = String.valueOf(minute).length();
			//if(kminute == 1){
				//minute = "0" + minute;
			//}

		}catch(Exception e){
			throw e;
		}
	}
	
	/**
	 * スマートゲートウェイへサーバ名を登録を送信するメソッドです
	 * 
	 * @param hostName サーバのホスト名
	 * @return　スマートゲートウェイへの会員登録が成功した場合はtrue、失敗した場合はfalseを返します。　
	 */
	public boolean registServerHostName(String hostName) {
		boolean result = false;
		try {
			String myUrl = "http://" + sgwIpAddress + CommonParam.CGI_FILENAME_REGIST_SRV;
			SgwHttpClient myClient = new SgwHttpClient(myUrl);
			// ポート番号は443、送信データは30分に固定
			String myMessage = "PORT=443&HOST=" + hostName + "&DATA_FORM=30&SETTING_BTN=設定";
			myClient.doPost(myMessage);
			myClient.getStatusCode();
			int stscode = myClient.getStatusCode();
			if(stscode != HttpURLConnection.HTTP_NOT_FOUND){
				result = true;
				System.out.println("... サーバ名を登録しました [成功]　-> " + sgwIpAddress);
			} else {
				System.out.println("... サーバ名を登録できませんでした [失敗]　-> " + sgwIpAddress);
			}
			//System.out.println(myClient.getStatusCode());
			//System.out.println(myClient.getResponseToString());
		} catch (Exception e) {
			if (e instanceof SocketTimeoutException){
				System.out.println("... サーバ名を登録できませんでした [通信失敗]　-> " + sgwIpAddress);
			} else {
				e.printStackTrace();
			}
		}
		return result;
	}

	/**
	 * スマートゲートウェイから登録サーバ名を取得するメソッドです
	 * 
	 * @param hostName サーバのホスト名
	 * @return　スマートゲートウェイへの会員登録が成功した場合はtrue、失敗した場合はfalseを返します。　
	 */
	public String getServerHostNameByHttpURLConnection(String encode) {
		String result = null;
		StringBuilder strBuf = new StringBuilder();
		
		if (encode == null || encode.length() == 0) {
			encode = "UFT-8";
		}
		String commnSetBody = "";
		
		try {
			String myUrl = "http://" + sgwIpAddress + "/mainte_admin_set.cgi";
			
			HttpURLConnection con = null;
			// URLの作成
			URL url = new URL(myUrl);        
			// 接続用HttpURLConnectionオブジェクト作成
			con = (HttpURLConnection)url.openConnection();
			// リクエストメソッドの設定
			con.setRequestMethod("GET");
			// リダイレクトを自動で許可しない設定
			con.setInstanceFollowRedirects(false);
			// ヘッダーの設定(複数設定可能)
			con.setRequestProperty("Accept-Language", "jp");
			// 接続
			con.connect();
			
			// 本文の取得
			InputStream in = con.getInputStream();
			InputStreamReader inReader = new InputStreamReader(in, encode);
			BufferedReader bufReader = new BufferedReader(inReader);
            String line = null;
            // 1行ずつテキストを読み込む
            while((line = bufReader.readLine()) != null) {
            	strBuf.append(line);
            }
            bufReader.close();
            inReader.close();
            in.close();
			in.close();
		} catch (Exception e) { }
		
		try {
			if (strBuf.length() > 0) {
				// ボディの取得
				commnSetBody = strBuf.toString();
			}
			
			if (commnSetBody == null || commnSetBody.length() == 0 || commnSetBody.contains("404 Not Found")) {
				// SGW-I型対策
				String loginURL = "http://" + sgwIpAddress + "/login.cgi";
				String requestURL = "http://" + sgwIpAddress + "/admin_set.cgi";
				commnSetBody = SgwMiniSetup.getResponseWithLogin(loginURL, "root", "root", requestURL);
			}
			
			if (commnSetBody != null && commnSetBody.length() > 0) {
				// サーバ名の取得
				String startTag = "<input type=\"text\" name=\"HOST\" maxlength=\"64\"";
				int positon = 0;
				result = HTMLAnalyzer.getTagAttributeValue(commnSetBody, positon, startTag);
				
				if (result != null && result.length() > 0) {
					System.out.println("... サーバ名を取得しました [成功]　-> " + result);
				} else {
					System.out.println("... サーバ名を取得できませんでした [失敗]　-> " + result);
				}
			} else {
				System.out.println("... サーバ名を取得できませんでした [失敗]　-> " + sgwIpAddress);
			}
			
		} catch (Exception e) {
			if (e instanceof SocketTimeoutException){
				System.out.println("... サーバ名を取得できませんでした [通信失敗]　-> " + sgwIpAddress);
			} else if (e instanceof ClientProtocolException) {
				e.printStackTrace();
				System.out.println("... サーバ名を取得できませんでした [プロトコルエラー]　-> " + sgwIpAddress);
			} else {
				//e.printStackTrace();
				System.out.println("... サーバ名を取得できませんでした [取得失敗]　-> " + sgwIpAddress);
			}
		}
		return result;
	}
	
	/**
	 * スマートゲートウェイから登録サーバ名を取得するメソッドです
	 * 
	 * @param hostName サーバのホスト名
	 * @return　スマートゲートウェイへの会員登録が成功した場合はtrue、失敗した場合はfalseを返します。　
	 */
	public String getServerHostName(String encode) {
		String result = null;
		if (encode == null || encode.length() == 0) {
			encode = "UFT-8";
		}
		
		String myUrl = "http://" + sgwIpAddress + "/mainte_admin_set.cgi";
		
		if (CommonParam.useOkHttpClient) {
			/* クライアントの生成 */
			//OkHttpClient okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
			OkHttpClient okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			
			try {
				/* リクエスト処理 */
				Request request = new Request.Builder()
		                .url(myUrl)
		                .get()
		                .build();
	
				// 同期処理
				Response response = okhttpClient.newCall(request).execute();
				
				String commnSetBody = "";
				if (response.isSuccessful()) {
					// ボディの取得
					commnSetBody = CommonFunc.convertInputStreamToString(response.body().byteStream(), encode);
					
					if (commnSetBody == null || commnSetBody.length() == 0 || commnSetBody.contains("404 Not Found")) {
						// SGW-I型対策
						String loginURL = "http://" + sgwIpAddress + "/login.cgi";
						String requestURL = "http://" + sgwIpAddress + "/admin_set.cgi";
						commnSetBody = SgwMiniSetup.getResponseWithLogin(loginURL, "root", "root", requestURL);
					}
					
					// サーバ名の取得
					String startTag = "<input type=\"text\" name=\"HOST\" maxlength=\"64\"";
					int positon = 0;
					result = HTMLAnalyzer.getTagAttributeValue(commnSetBody, positon, startTag);
					
					System.out.println("... サーバ名を取得しました [成功]　-> " + result);
				} else {
					System.out.println("... サーバ名を取得できませんでした [失敗]　-> " + sgwIpAddress);
				}
			} catch (Exception e) {
				System.out.println("... サーバ名を取得できませんでした [失敗]　-> " + sgwIpAddress);
				e.printStackTrace();
			} 
		} else {
			try {
				//DefaultHttpClient client = SgwHttpClient.createHttpClientWithProxy();
				DefaultHttpClient client = SgwHttpClient.createHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
				
				// 通信設定ページにアクセス
				HttpGet httpget = new HttpGet(myUrl);
				HttpResponse res = client.execute(httpget);
				String commnSetBody = "";
				if (res.getEntity() != null) {
					// ボディの取得
					commnSetBody = EntityUtils.toString(res.getEntity(), encode);
					// エンティティの後処理（エンティティ内のInputStreamのクローズ処理)
					EntityUtils.consume(res.getEntity());
					
					if (commnSetBody == null || commnSetBody.length() == 0 || commnSetBody.contains("404 Not Found")) {
						// SGW-I型対策
						String loginURL = "http://" + sgwIpAddress + "/login.cgi";
						String requestURL = "http://" + sgwIpAddress + "/admin_set.cgi";
						commnSetBody = SgwMiniSetup.getResponseWithLogin(loginURL, "root", "root", requestURL);
					}
					
					// サーバ名の取得
					String startTag = "<input type=\"text\" name=\"HOST\" maxlength=\"64\"";
					int positon = 0;
					result = HTMLAnalyzer.getTagAttributeValue(commnSetBody, positon, startTag);
					
					System.out.println("... サーバ名を取得しました [成功]　-> " + result);
					
				} else {
					System.out.println("... サーバ名を取得できませんでした [失敗]　-> " + sgwIpAddress);
				}
					
			} catch (Exception e) {
				if (e instanceof SocketTimeoutException){
					System.out.println("... サーバ名を取得できませんでした [通信失敗]　-> " + sgwIpAddress);
				} else if (e instanceof ClientProtocolException) {
					e.printStackTrace();
					System.out.println("... サーバ名を取得できませんでした [プロトコルエラー]　-> " + sgwIpAddress);
				} else {
					//e.printStackTrace();
					System.out.println("... サーバ名を取得できませんでした [取得失敗]　-> " + sgwIpAddress);
				}
			}
		}
			
		return result;
	}
	
	/**
	 * スマートゲートウェイから製造番号を取得するメソッドです
	 * 
	 * @param hostName サーバのホスト名
	 * @return　スマートゲートウェイへの会員登録が成功した場合はtrue、失敗した場合はfalseを返します。　
	 */
	public String getSgwSerialNo(String encode) {
		String result = null;
		if (encode == null || encode.length() == 0) {
			encode = "UFT-8";
		}
		
		String myUrl = "http://" + sgwIpAddress + "/index.cgi";
		
		if (CommonParam.useOkHttpClient) {
			/* クライアントの生成 */
			//OkHttpClient okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
			OkHttpClient okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			
			try {
				/* リクエスト処理 */
				Request request = new Request.Builder()
		                .url(myUrl)
		                .get()
		                .build();
	
				// 同期処理
				Response response = okhttpClient.newCall(request).execute();
				String commnSetBody = "";
				if (response.isSuccessful()) {
					// ボディの取得
					commnSetBody = CommonFunc.convertInputStreamToString(response.body().byteStream(), encode);
					
					// サーバ名の取得
					result = SearchSgwIpAddress.getSerialNoFromStringText(commnSetBody);
					
					System.out.println("... SGWの製造番号を取得しました [成功]　-> " + result);
					
					// マップを更新
					if (result != null && result.length() > 0) {
						SearchSgwIpAddress.smartGatewayInfoMap.put(sgwIpAddress, result);
					}
				} else {
					System.out.println("... SGWの製造番号を取得できませんでした [失敗]　-> " + sgwIpAddress);
				}
			} catch (Exception e) {
				System.out.println("... SGWの製造番号を取得できませんでした [失敗]　-> " + sgwIpAddress);
				e.printStackTrace();
			} 
		} else {
			try {
				//DefaultHttpClient client = SgwHttpClient.createHttpClientWithProxy();
				DefaultHttpClient client = SgwHttpClient.createHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
				
				// 通信設定ページにアクセス
				HttpGet httpget = new HttpGet(myUrl);
				HttpResponse res2 = client.execute(httpget);
				String commnSetBody = "";
				if (res2.getEntity() != null) {
					// ボディの取得
					commnSetBody = EntityUtils.toString(res2.getEntity(), encode);
					// エンティティの後処理（エンティティ内のInputStreamのクローズ処理)
					EntityUtils.consume(res2.getEntity());
					
					// サーバ名の取得
					result = SearchSgwIpAddress.getSerialNoFromStringText(commnSetBody);
					
					System.out.println("... SGWの製造番号を取得しました [成功]　-> " + result);
					
					// マップを更新
					if (result != null && result.length() > 0) {
						SearchSgwIpAddress.smartGatewayInfoMap.put(sgwIpAddress, result);
					}
					
				} else {
					System.out.println("... SGWの製造番号を取得できませんでした [失敗]　-> " + sgwIpAddress);
				}
					
			} catch (Exception e) {
				if (e instanceof SocketTimeoutException){
					System.out.println("... SGWの製造番号を取得できませんでした [通信失敗]　-> " + sgwIpAddress);
				} else {
					//e.printStackTrace();
					System.out.println("... SGWの製造番号を取得できませんでした [取得失敗]　-> " + sgwIpAddress);
				}
			}
		}
		
		return result;
	}
}
