package com.SgwMiniSetup.sample;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Desktop;
import java.awt.DisplayMode;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.Thread.UncaughtExceptionHandler;
import java.net.CookieManager;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.BevelBorder;

import org.apache.http.Header;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
//import org.apache.http.client.HttpClient;//方法②
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import com.SgwMiniSetup.common.CommonFunc;
import com.SgwMiniSetup.common.ScaledImageButton;
import com.SgwMiniSetup.common.ScaledImageLabel;
import com.SgwMiniSetup.thread.CommTestThread;
import com.SgwSetting.common.CommonParam;
import com.SgwSetting.http.HTMLAnalyzer;
import com.SgwSetting.http.SgwHttpClient;
//import com.SgwSetting.http.WebWeiwOnJFrame4Gen;
import com.SgwSetting.smartgateway.SearchSgwIpAddress;

import okhttp3.FormBody;
import okhttp3.HttpUrl;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

/**
 * スマートゲートウェイ 簡単セットアップGUI(PC版) - メインフレーム処理
 *
 * @author Copyright (c) 2013 Enegate Co, ltd.
 * @version 1.00
 */
public class SgwMiniSetup extends JFrame implements ActionListener {
	/**
	 * アプリの定数
	 */
	private static final long serialVersionUID = 1L;

	// ========================================================================================================
	// 各コンポーネントの宣言
	// ========================================================================================================
	// アプリ全体
	private static JFrame frame = null; // ウィンドウとなるフレーム
	private static CardLayout layout = null; // ベースとなるパネルのレイアウト
	private static JPanel panelBase = null; // 各パネルを貼りつけるベースとなるパネル
	// 各パネル
	private static JPanel panel_top = null; // TOP画面
	private static JPanel panel_guide1 = null; // 設定ガイド1画面
	private static JPanel panel_guide2 = null; // 設定ガイド2画面
	private static JPanel panel_guide3 = null; // 設定ガイド3画面
	private static JPanel panel_guide4 = null; // 設定ガイド4画面
	private static JPanel panel_guide5 = null; // 設定ガイド5画面
	private static JPanel panel_guide6 = null; // 設定ガイド6画面
	private static JPanel panel_guide7 = null; // 設定ガイド7画面
	private static JPanel panel_guide8 = null; // 設定ガイド8画面
	private static JPanel panel_search1 = null; // スマートゲートウェイの検索1画面
	private static JPanel panel_search2 = null; // スマートゲートウェイの検索2画面
	private static JPanel panel_regist1 = null; // 利用登録1画面
	private static JPanel panel_regist2 = null; // 利用登録2画面
	private static JPanel panel_detail = null; // 詳細画面

	public static int TIME_OUT_1 = 60000;

	// ========================================================================================================
	// 各パネルの文言
	// ========================================================================================================
	// アプリ共通
	//private final static String MSG_APLI_TITLE       = "スマートゲートウェイ mini　簡単セットアップ";  // アプリのタイトル名
	private final static String MSG_APLI_TITLE = com.SgwMiniSetup.common.CommonParam.APLI_TITLE; // アプリのタイトル名
	private final static String MSG_APLI_VERSION = com.SgwMiniSetup.common.CommonParam.APLI_VERSION; // バージョン情報
	private final static String MSG_APLI_COPYRIGHT = com.SgwMiniSetup.common.CommonParam.APLI_COPYRIGHT; // コピーライト

	private final static String MSG_APLI_DOUBLE_BOOT = // 多重起動時のダイアログ
	"スマートゲートウェイ簡単セットアップは既に起動しています。";

	// TOPページ
	//private final static String MSG_TOP_TITLE       = "スマートゲートウェイmini";          // タイトル
	private final static String MSG_TOP_TITLE = "スマートゲートウェイ"; // タイトル
	private final static String MSG_TOP_SUBTITLE = "簡単セットアップ"; // サブタイトル
	private final static String MSG_TOP_EXPLANATION = // 説明文
	"<html><body>" +
			"簡単セットアップをご利用いただきありがとうございます。<br />" +
			"本アプリケーションでは、「スマートゲートウェイの設定」と「利用登録」が行えます。<br />" +
			"</body></html>";

	// 設定ガイド(共通)
	private final static String MSG_GUIDE_TITLE = "スマートゲートウェイ"; // タイトル
	private final static String MSG_GUIDE_SUBTITLE = "簡単セットアップ"; // サブタイトル

	// スマートゲートウェイの検索(共通)
	private final static String MSG_SEARCH_TITLE = "簡単セットアップ"; // タイトル
	private final static String MSG_SEARCH_SUBTITLE = "スマートゲートウェイの検索"; // サブタイトル

	// 利用登録(共通)
	private final static String MSG_REGIST_TITLE = "簡単セットアップ"; // タイトル
	private final static String MSG_REGIST_SUBTITLE = "利用登録"; // サブタイトル

	// 詳細画面
	private final static String MSG_DETAIL_TITLE = "スマートゲートウェイ"; // タイトル
	private final static String MSG_DETAIL_SUBTITLE = "詳細設定メニュー"; // サブタイトル
	private final static String MSG_DETAIL_MEDIACONV_TITLE = "メディアコンバータ"; // サブタイトル

	// 内部ブラウザ画面
	private final static String MSG_METER_SET_SITE_TITLE = "スマートゲートウェイ"; // タイトル
	private final static String MSG_METER_SET_SITE_SUBTITLE = "計器設定"; // サブタイトル

	// ========================================================================================================
	// 各パネルの設定値
	// ========================================================================================================
	// アプリ全体の設定
	private static final boolean APLI_WINDOW_RESIZE_FLG = false; // アプリのサイズを変更可能か(true:可変、false:固定)
	private static final String APLI_LOOK_AND_FEEL = // アプリの見た目(Look&Feel：Metal調)
	"javax.swing.plaf.metal.MetalLookAndFeel"; // "Metal"
	//"com.sun.java.swing.plaf.motif.MotifLookAndFeel";			// "CDE/Motif"
	//"com.sun.java.swing.plaf.windows.WindowsLookAndFeel";		// "Windows"
	//"com.sun.java.swing.plaf.windows.WindowsClassicLookAndFeel";	// "WindowsClassic"
	private static final String APLI_LOOK_AND_FEEL_FOR_WIN = // アプリの見た目(Look&Feel：Metal調)
	"com.sun.java.swing.plaf.windows.WindowsClassicLookAndFeel"; // "WindowsClassic"
	private static final String APLI_LOOK_AND_FEEL_FOR_MAC = // アプリの見た目(Look&Feel：Metal調)
	"javax.swing.plaf.metal.MetalLookAndFeel"; // "Metal"

	// 各画面のフォント色(RGB指定)
	private final static Color FONT_COLOR_TOP = new Color(0, 0, 0); // TOP画面(黒系:#00000)
	private final static Color FONT_COLOR_GUIDE = new Color(0, 0, 102); // 設定ガイド(青系:#000066)
	private final static Color FONT_COLOR_SEARCH = new Color(51, 153, 102); // スマートゲートウェイの検索(緑系:#336699)
	private final static Color FONT_COLOR_REGIST = new Color(153, 0, 0); // 利用登録(赤系:#990000)
	private final static Color FONT_COLOR_BTN = new Color(0, 0, 102); // ボタン(黒系:#00000)

	// 各画面のフォントサイズ(単位：ピクセル)
	private final static int FONT_SIZE_COMMON_TITLE = 14; // タイトル
	private final static int FONT_SIZE_COMMON_SUBTITLE = 26; // サブタイトル
	private final static int FONT_SIZE_COMMON_FOOTER = 12; // フッター
	private final static int FONT_SIZE_COMMON_PAGENO = 14; // ページ番号
	private final static int FONT_SIZE_TOP_EXPLANATION = 14; // TOP画面の説明文
	//private final static int FONT_SIZE_BTN = 24; // ボタン
	private final static int FONT_SIZE_BTN = 23; // ボタン

	// 文字の太さ
	private final static int FONT_WEIGHT_COMMON_TITLE = Font.BOLD; // タイトル
	private final static int FONT_WEIGHT_COMMON_SUBTITLE = Font.BOLD; // サブタイトル
	private final static int FONT_WEIGHT_COMMON_PAGE_NO = Font.BOLD; //  ページ番号
	private final static int FONT_WEIGHT_BTN = Font.BOLD; //ボタン

	// フォントの種類
	private final static String FONT_STYLE_COMMON_TITLE = Font.SANS_SERIF; // タイトル
	private final static String FONT_STYLE_COMMON_SUBTITLE = Font.SANS_SERIF; // サブタイトル
	private final static String FONT_STYLE_COMMON_PAGE_NO = Font.SANS_SERIF; // ページ番号
	private final static String FONT_STYLE_BTN = Font.SANS_SERIF; // ボタン

	// ラベル内での位置
	private final static int TEXT_ALIGN_PAGE_NO = JLabel.RIGHT; // ページ番号

	// ========================================================================================================
	// 各画面の共通のコンポーネント配置(単位：ピクセル)
	// ========================================================================================================
	// アプリのコンソールの大きさ
	private final static int APLI_WIDTH = 800; // 幅
	private final static int APLI_HEIGHT = 600; // 高さ

	// CardLayoutの水平方向および垂直方向の間隔
	private final static int CARD_LAYOUT_HGAP = 10; // 水平方向
	private final static int CARD_LAYOUT_VGAP = 10; // 垂直方向

	// 各パネルのタイトルの配置
	private final static int POS_COMMON_TITLE_X = 0; // X座標
	private final static int POS_COMMON_TITLE_Y = 0; // Y座標
	private final static int POS_COMMON_TITLE_WIDTH = 770; // 幅
	private final static int POS_COMMON_TITLE_HEIGHT = 20; // 高さ

	// 各パネルのサブタイトルの配置
	private final static int POS_COMMON_SUBTITLE_X = 0; // X座標
	private final static int POS_COMMON_SUBTITLE_Y = 20; // Y座標
	private final static int POS_COMMON_SUBTITLE_WIDTH = 770; // 幅
	private final static int POS_COMMON_SUBTITLE_HEIGHT = 40; // 高さ

	// 各パネルに表示する区切り線(上部)の配置
	private final static int POS_COMMON_SEPARATOR_TOP_X = 0; // X座標
	private final static int POS_COMMON_SEPARATOR_TOP_Y = 65; // Y座標
	private final static int POS_COMMON_SEPARATOR_TOP_WIDTH = 770; // 幅
	private final static int POS_COMMON_SEPARATOR_TOP_HEIGHT = 15; // 高さ

	// 各パネルに表示するページ番号の配置
	private final static int POS_COMMON_PAGENO_X = 0; // X座標
	private final static int POS_COMMON_PAGENO_Y = 470; // Y座標
	private final static int POS_COMMON_PAGENO_WIDTH = 710; // 幅
	private final static int POS_COMMON_PAGENO_HEIGHT = 40; // 高さ

	// 各パネルに表示する区切り線(下部)の配置
	private final static int POS_COMMON_SEPARATOR_BOTTOM_X = 0; // X座標
	private final static int POS_COMMON_SEPARATOR_BOTTOM_Y = 520; // Y座標
	private final static int POS_COMMON_SEPARATOR_BOTTOM_WIDTH = 770; // 幅
	private final static int POS_COMMON_SEPARATOR_BOTTOM_HEIGHT = 15; // 高さ

	// フッター(バージョン)の配置
	private final static int POS_COMMON_FOOTER_VERSION_X = 0; // X座標
	private final static int POS_COMMON_FOOTER_VERSION_Y = 525; // Y座標
	private final static int POS_COMMON_FOOTER_VERSION_WIDTH = 200; // 幅
	private final static int POS_COMMON_FOOTER_VERSION_HEIGHT = 25; // 高さ

	// フッター(コピーライト)の配置
	private final static int POS_COMMON_FOOTER_COPYRIGHT_X = 200; // X座標
	private final static int POS_COMMON_FOOTER_COPYRIGHT_Y = 525; // Y座標
	private final static int POS_COMMON_FOOTER_COPYRIGHT_WIDTH = 570; // 幅
	private final static int POS_COMMON_FOOTER_COPYRIGHT_HEIGHT = 25; // 高さ

	// 左側のボタン配置(TOP、次へ)
	private final static int POS_COMMON_BTN_LEFT_X = 0; // X座標
	private final static int POS_COMMON_BTN_LEFT_Y = 190; // Y座標
	private final static int POS_COMMON_BTN_LEFT_WIDTH = 48; // 幅
	private final static int POS_COMMON_BTN_LEFT_HEIGHT = 180; // 高さ

	// 説明文の背景画像の配置(設定ガイド、スマートゲートウェイ検索、利用登録)
	private final static int POS_COMMON_MSG_IMG_X = 55; // X座標
	private final static int POS_COMMON_MSG_IMG_Y = 95; // Y座標
	private final static int POS_COMMON_MSG_IMG_WIDTH = 660; // 幅
	private final static int POS_COMMON_MSG_IMG_HEIGHT = 380; // 高さ

	// 右側のボタン配置(前へ)
	private final static int POS_COMMON_BTN_RIGHT_X = 722; // X座標
	private final static int POS_COMMON_BTN_RIGHT_Y = 190; // Y座標
	private final static int POS_COMMON_BTN_RIGHT_WIDTH = 48; // 幅
	private final static int POS_COMMON_BTN_RIGHT_HEIGHT = 180; // 高さ

	// ========================================================================================================
	// 各画面の個別のコンポーネント配置(単位：ピクセル)
	// ========================================================================================================
	// TOP画面：終了ボタンの配置
	private final static int POS_TOP_BTN_CLOSE_X = 570; // X座標
	private final static int POS_TOP_BTN_CLOSE_Y = 0; // Y座標
	private final static int POS_TOP_BTN_CLOSE_WIDTH = 200; // 幅
	private final static int POS_TOP_BTN_CLOSE_HEIGHT = 50; // 高さ

	// TOP画面：説明文の配置
	private final static int POS_TOP_EXPLANATION_X = 60; // X座標
	private final static int POS_TOP_EXPLANATION_Y = 80; // Y座標
	private final static int POS_TOP_EXPLANATION_WIDTH = 650; // 幅
	private final static int POS_TOP_EXPLANATION_HEIGHT = 60; // 高さ

	// TOP画面：設定ガイドボタンの配置
	private final static int POS_TOP_BTN_GUIDE_X = 40; // X座標
	private final static int POS_TOP_BTN_GUIDE_Y = 160; // Y座標
	private final static int POS_TOP_BTN_GUIDE_WIDTH = 217; // 幅
	private final static int POS_TOP_BTN_GUIDE_HEIGHT = 232; // 高さ

	// TOP画面：スマートゲートウェイの検索ボタンの配置
	private final static int POS_TOP_BTN_SEARCH_X = 280; // X座標
	private final static int POS_TOP_BTN_SEARCH_Y = 160; // Y座標
	private final static int POS_TOP_BTN_SEARCH_WIDTH = 217; // 幅
	private final static int POS_TOP_BTN_SEARCH_HEIGHT = 232; // 高さ

	// TOP画面：利用登録ボタンの配置
	private final static int POS_TOP_BTN_REGIST_X = 525; // X座標
	private final static int POS_TOP_BTN_REGIST_Y = 160; // Y座標
	private final static int POS_TOP_BTN_REGIST_WIDTH = 217; // 幅
	private final static int POS_TOP_BTN_REGIST_HEIGHT = 232; // 高さ

	// TOP画面：スマートゲートウェイ見える化画面ボタンの配置
	private final static int POS_TOP_BTN_WEB_CONTENTS_X = 40; // X座標
	private final static int POS_TOP_BTN_WEB_CONTENTS_Y = 405; // Y座標
	private final static int POS_TOP_BTN_WEB_CONTENTS_WIDTH = 217; // 幅
	private final static int POS_TOP_BTN_WEB_CONTENTS_HEIGHT = 67; // 高さ

	// TOP画面：計器認証設定ボタンの配置
	private final static int POS_TOP_BTN_METER_SETTINGS_X = 280; // X座標
	private final static int POS_TOP_BTN_METER_SETTINGS_Y = 405; // Y座標
	private final static int POS_TOP_BTN_METER_SETTINGS_WIDTH = 217; // 幅
	private final static int POS_TOP_BTN_METER_SETTINGS_HEIGHT = 67; // 高さ

	// TOP画面：詳細ボタンの配置
	private final static int POS_TOP_BTN_DETAIL_X = 525; // X座標
	private final static int POS_TOP_BTN_DETAIL_Y = 405; // Y座標
	private final static int POS_TOP_BTN_DETAIL_WIDTH = 217; // 幅
	private final static int POS_TOP_BTN_DETAIL_HEIGHT = 67; // 高さ

	// TOP画面：サーバ一括登録ボタンの配置
	private final static int POS_TOP_BTN_REGIST_SERVER_X = 280; // X座標
	private final static int POS_TOP_BTN_REGIST_SERVER_Y = 405; // Y座標
	private final static int POS_TOP_BTN_REGIST_SERVER_WIDTH = 217; // 幅
	private final static int POS_TOP_BTN_REGIST_SERVER_HEIGHT = 67; // 高さ

	// 設定ガイド6画面：点滅回数10ボタンの配置
	private final static int POS_GUIDE6_BTN_FLASH10_X = 30; // X座標
	private final static int POS_GUIDE6_BTN_FLASH10_Y = 150; // Y座標
	private final static int POS_GUIDE6_BTN_FLASH10_WIDTH = 265; // 幅
	private final static int POS_GUIDE6_BTN_FLASH10_HEIGHT = 195; // 高さ

	// 設定ガイド6画面：点滅回数5ボタンの表示配置
	private final static int POS_GUIDE6_BTN_FLASH5_X = 390; // X座標
	private final static int POS_GUIDE6_BTN_FLASH5_Y = 150; // Y座標
	private final static int POS_GUIDE6_BTN_FLASH5_WIDTH = 265; // 幅
	private final static int POS_GUIDE6_BTN_FLASH5_HEIGHT = 195; // 高さ

	// 設定ガイド7画面：スマートゲートウェイの検索ボタンの配置
	private final static int POS_GUIDE7_BTN_SEARCH_X = 210; // X座標
	private final static int POS_GUIDE7_BTN_SEARCH_Y = 125; // Y座標
	private final static int POS_GUIDE7_BTN_SEARCH_WIDTH = 217; // 幅
	private final static int POS_GUIDE7_BTN_SEARCH_HEIGHT = 232; // 高さ

	// 設定ガイド8画面：完了ボタンの配置
	private final static int POS_GUIDE8_BTN_END_X = 290; // X座標
	private final static int POS_GUIDE8_BTN_END_Y = 310; // Y座標
	private final static int POS_GUIDE8_BTN_END_WIDTH = 94; // 幅
	private final static int POS_GUIDE8_BTN_END_HEIGHT = 50; // 高さ

	// スマートゲートウェイの検索1画面：検索開始ボタンの配置
	private final static int POS_SEARCH1_BTN_KENSAKU_X = 265; // X座標
	private final static int POS_SEARCH1_BTN_KENSAKU_Y = 290; // Y座標
	private final static int POS_SEARCH1_BTN_KENSAKU_WIDTH = 155; // 幅
	private final static int POS_SEARCH1_BTN_KENSAKU_HEIGHT = 57; // 高さ

	// スマートゲートウェイの検索2画面：完了ボタンの配置
	private final static int POS_SEARCH2_BTN_END_X = 290; // X座標
	private final static int POS_SEARCH2_BTN_END_Y = 95; // Y座標
	private final static int POS_SEARCH2_BTN_END_WIDTH = 94; // 幅
	private final static int POS_SEARCH2_BTN_END_HEIGHT = 50; // 高さ

	// スマートゲートウェイの検索2画面：利用登録ボタンの配置
	private final static int POS_SEARCH2_BTN_KAIIN_X = 480; // X座標
	//private final static int POS_SEARCH2_BTN_KAIIN_Y      = 265;       // Y座標
	private final static int POS_SEARCH2_BTN_KAIIN_Y = 280; // Y座標
	private final static int POS_SEARCH2_BTN_KAIIN_WIDTH = 136; // 幅
	private final static int POS_SEARCH2_BTN_KAIIN_HEIGHT = 49; // 高さ

	// 利用登録2画面：利用規約文のテキストエリアの余白
	private final static int POS_REGIST2_TEXAAREA_PADDING_TOP = 5; // 上
	private final static int POS_REGIST2_TEXAAREA_PADDING_LEFT = 10; // 左
	private final static int POS_REGIST2_TEXAAREA_PADDING_RIGHT = 10; // 右
	private final static int POS_REGIST2_TEXAAREA_PADDING_BOTTOM = 5; // 下

	// 利用登録2画面：利用規約文のテキストエリアの表示配置
	private final static int POS_REGIST2_SCROLLPANE_X = 30; // X座標
	private final static int POS_REGIST2_SCROLLPANE_Y = 25; // Y座標
	private final static int POS_REGIST2_SCROLLPANE_WIDTH = 600; // 幅
	private final static int POS_REGIST2_SCROLLPANE_HEIGHT = 250; // 高さ

	// 利用登録2画面：同意するボタンの表示配置
	private final static int POS_REGIST2_BTN_AGREE_X = 260; // X座標
	private final static int POS_REGIST2_BTN_AGREE_Y = 300; // Y座標
	private final static int POS_REGIST2_BTN_AGREE_WIDTH = 137; // 幅
	private final static int POS_REGIST2_BTN_AGREE_HEIGHT = 49; // 高さ

	// 詳細設定画面：設定Webリンクする各ボタンの表示配置
	//private final static int POS_DETAIL_BTN_LINK_X      = 85;            // X座標
	private final static int POS_DETAIL_BTN_LINK_X = 70; // X座標
	//private final static int POS_DETAIL_BTN_LINK_X2      = 440;            // X座標
	private final static int POS_DETAIL_BTN_LINK_X2 = 425; // X座標
	//private final static int POS_DETAIL_BTN_LINK_WIDTH  = 320;            // 幅
	private final static int POS_DETAIL_BTN_LINK_WIDTH = 335; // 幅
	private final static int POS_DETAIL_BTN_LINK_HEIGHT = 50; // 高さ

	//チェックボックス
	private final static int POS_LAUNCH_BROWSER_CHK_X = 440; // X座標
	private final static int POS_LAUNCH_BROWSER_CHK_Y = 480; // Y座標
	private final static int POS_LAUNCH_BROWSER_CHK_WIDTH = 320; // 幅
	private final static int POS_LAUNCH_BROWSER_CHK_HEIGHT = 30; // 高さ

	// ========================================================================================================
	// 画像リソース
	// ========================================================================================================
	// アプリのfavicon画像ファイルパス
	//private final static String IMG_APLI_FAVICON    = "res/img/favicon.png";
	public final static String IMG_APLI_FAVICON = "img/SGWMiniSetup_48x48.png";

	// ボタン画像ファイルパス
	private final static String IMG_BTN_GUIDE_ON = "res/img/btn_guide_on.png"; // 設定ガイドへボタン(フォーカス有)
	private final static String IMG_BTN_GUIDE_OFF = "res/img/btn_guide_off.png"; // 設定ガイドへボタン(フォーカス無)
	private final static String IMG_BTN_SEARCH_ON = "res/img/btn_search_on.png"; // スマートゲートウェイの検索へボタン(フォーカス有)
	private final static String IMG_BTN_SEARCH_OFF = "res/img/btn_search_off.png"; // スマートゲートウェイの検索へボタン(フォーカス無)
	private final static String IMG_BTN_REGIST_ON = "res/img/btn_regist_on.png"; // 利用登録へボタン(フォーカス有)
	private final static String IMG_BTN_REGIST_OFF = "res/img/btn_regist_off.png"; // 利用登録へボタン(フォーカス無)//
	private final static String IMG_BTN_TOP_ON = "res/img/btn_top_on.png"; // TOPへ戻るボタン(フォーカス有)
	private final static String IMG_BTN_TOP_OFF = "res/img/btn_top_off.png"; // TOPへ戻るボタン(フォーカス無)
	private final static String IMG_BTN_PREV_ON = "res/img/btn_prev_on.png"; // 前へボタン(フォーカス有)
	private final static String IMG_BTN_PREV_OFF = "res/img/btn_prev_off.png"; // 前へボタン(フォーカス無)
	private final static String IMG_BTN_NEXT_ON = "res/img/btn_next_on.png"; // 次へボタン(フォーカス有)
	private final static String IMG_BTN_NEXT_OFF = "res/img/btn_next_off.png"; // 次へボタン(フォーカス無)
	private final static String IMG_BTN_CLOSE_ON = "res/img/btn_close_on.png"; // 終了するボタン(フォーカス有)
	private final static String IMG_BTN_CLOSE_OFF = "res/img/btn_close_off.png"; // 終了するボタン(フォーカス無)
	private final static String IMG_BTN_END_ON = "res/img/btn_end_on.png"; // 完了ボタン(フォーカス有)
	private final static String IMG_BTN_END_OFF = "res/img/btn_end_off.png"; // 完了ボタン(フォーカス無)
	private final static String IMG_BTN_KAIIN_ON = "res/img/btn_kaiin_on.png"; // 利用登録ボタン(フォーカス有)
	private final static String IMG_BTN_KAIIN_OFF = "res/img/btn_kaiin_off.png"; // 利用登録ボタン(フォーカス無)
	private final static String IMG_BTN_AGREE_ON = "res/img/btn_agree_on.png"; // 同意するボタン(フォーカス有)
	private final static String IMG_BTN_AGREE_OFF = "res/img/btn_agree_off.png"; // 同意するボタン(フォーカス無)
	private final static String IMG_BTN_KENSAKU_ON = "res/img/btn_kensaku_on.png"; // 検索開始ボタン(フォーカス有)
	private final static String IMG_BTN_KENSAKU_OFF = "res/img/btn_kensaku_off.png"; // 検索開始ボタン(フォーカス無)
	private final static String IMG_BTN_FLASH10_ON = "res/img/btn_flash10_on.png"; // 点滅した回数10ボタン(フォーカス有)
	private final static String IMG_BTN_FLASH10_OFF = "res/img/btn_flash10_off.png"; // 点滅した回数10ボタン(フォーカス無)
	private final static String IMG_BTN_FLASH5_ON = "res/img/btn_flash5_on.png"; // 点滅した回数5ボタン(フォーカス有)
	private final static String IMG_BTN_FLASH5_OFF = "res/img/btn_flash5_off.png"; // 点滅した回数5ボタン(フォーカス無)
	private final static String IMG_BTN_DETAIL_ON = "res/img/btn_detail_on.png"; // 詳細ボタン(フォーカス有)
	private final static String IMG_BTN_DETAIL_OFF = "res/img/btn_detail_off.png"; // 詳細ボタン(フォーカス無)
	private final static String IMG_BTN_REGIST_SERVER_ON = "res/img/btn_regist_server_on.png"; // 詳細ボタン(フォーカス有)
	private final static String IMG_BTN_REGIST_SERVER_OFF = "res/img/btn_regist_server_off.png"; // 詳細ボタン(フォーカス無)

	public final static String IMG_BTN_SGW_VISUALIZATION1 = "res/img/btn_web_contents_1.png"; // 見える化画面(有効/フォーカス無)
	public final static String IMG_BTN_SGW_VISUALIZATION2 = "res/img/btn_web_contents_2.png"; // 見える化画面(有効/フォーカス有)
	public final static String IMG_BTN_SGW_VISUALIZATION3 = "res/img/btn_web_contents_3.png"; // 見える化画面(無効/フォーカス無)
	public final static String IMG_BTN_SGW_VISUALIZATION4 = "res/img/btn_web_contents_4.png"; // 見える化画面(無効/フォーカス有)
	public final static String IMG_BTN_METER_SETTINGS1 = "res/img/btn_meter_settings_1.png"; // 計器認証設定(有効/フォーカス無)
	public final static String IMG_BTN_METER_SETTINGS2 = "res/img/btn_meter_settings_2.png"; // 計器認証設定(有効/フォーカス有)
	public final static String IMG_BTN_METER_SETTINGS3 = "res/img/btn_meter_settings_3.png"; // 計器認証設定(無効/フォーカス無)
	public final static String IMG_BTN_METER_SETTINGS4 = "res/img/btn_meter_settings_4.png"; // 計器認証設定(無効/フォーカス有)

	private final ImageIcon IMG_ICON_VISUALIZATION_1 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION1));
	private final ImageIcon IMG_ICON_VISUALIZATION_2 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION2));
	private final ImageIcon IMG_ICON_VISUALIZATION_3 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION3));
	private final ImageIcon IMG_ICON_VISUALIZATION_4 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION4));
	private final ImageIcon IMG_ICON_METER_SETTINGS_1 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS1));
	private final ImageIcon IMG_ICON_METER_SETTINGS_2 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS2));
	private final ImageIcon IMG_ICON_METER_SETTINGS_3 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS3));
	private final ImageIcon IMG_ICON_METER_SETTINGS_4 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS4));

	// 説明文の背景画像ファイルパス(設定ガイド1 - 7ページ)
	private final static String IMG_MSG_GUIDE1 = "res/img/msg_guide1.png";
	private final static String IMG_MSG_GUIDE2 = "res/img/msg_guide2.png";
	private final static String IMG_MSG_GUIDE3 = "res/img/msg_guide3.png";
	private final static String IMG_MSG_GUIDE4 = "res/img/msg_guide4.png";
	private final static String IMG_MSG_GUIDE5 = "res/img/msg_guide5.png";
	private final static String IMG_MSG_GUIDE6 = "res/img/msg_guide6.png";
	private final static String IMG_MSG_GUIDE7 = "res/img/msg_guide7.png";
	private final static String IMG_MSG_GUIDE8 = "res/img/msg_guide8.png";

	// 説明文の背景画像ファイルパス(スマートゲートウェイの検索1 - 2ページ)
	private final static String IMG_MSG_SEARCH1 = "res/img/msg_search1.png";
	private final static String IMG_MSG_SEARCH2 = "res/img/msg_search2.png";

	// 説明文の背景画像ファイルパス(利用登録1 - 2ページ)
	private final static String IMG_MSG_REGIST1 = "res/img/msg_regist1.png";
	private final static String IMG_MSG_REGIST2 = "res/img/msg_regist2.png";
	
	// ボタン画像ファイルパス(サイズ大)
	private final static String IMG_BTN_GUIDE_ON_X2 = "res/img/btn_guide_on_x2.png"; // 設定ガイドへボタン(フォーカス有)
	private final static String IMG_BTN_GUIDE_OFF_X2 = "res/img/btn_guide_off_x2.png"; // 設定ガイドへボタン(フォーカス無)
	private final static String IMG_BTN_SEARCH_ON_X2 = "res/img/btn_search_on_x2.png"; // スマートゲートウェイの検索へボタン(フォーカス有)
	private final static String IMG_BTN_SEARCH_OFF_X2 = "res/img/btn_search_off_x2.png"; // スマートゲートウェイの検索へボタン(フォーカス無)
	private final static String IMG_BTN_REGIST_ON_X2 = "res/img/btn_regist_on_x2.png"; // 利用登録へボタン(フォーカス有)
	private final static String IMG_BTN_REGIST_OFF_X2 = "res/img/btn_regist_off_x2.png"; // 利用登録へボタン(フォーカス無)//
	private final static String IMG_BTN_TOP_ON_X2 = "res/img/btn_top_on_x2.png"; // TOPへ戻るボタン(フォーカス有)
	private final static String IMG_BTN_TOP_OFF_X2 = "res/img/btn_top_off_x2.png"; // TOPへ戻るボタン(フォーカス無)
	private final static String IMG_BTN_PREV_ON_X2 = "res/img/btn_prev_on_x2.png"; // 前へボタン(フォーカス有)
	private final static String IMG_BTN_PREV_OFF_X2 = "res/img/btn_prev_off_x2.png"; // 前へボタン(フォーカス無)
	private final static String IMG_BTN_NEXT_ON_X2 = "res/img/btn_next_on_x2.png"; // 次へボタン(フォーカス有)
	private final static String IMG_BTN_NEXT_OFF_X2 = "res/img/btn_next_off_x2.png"; // 次へボタン(フォーカス無)
	private final static String IMG_BTN_CLOSE_ON_X2 = "res/img/btn_close_on_x2.png"; // 終了するボタン(フォーカス有)
	private final static String IMG_BTN_CLOSE_OFF_X2 = "res/img/btn_close_off_x2.png"; // 終了するボタン(フォーカス無)
	private final static String IMG_BTN_END_ON_X2 = "res/img/btn_end_on_x2.png"; // 完了ボタン(フォーカス有)
	private final static String IMG_BTN_END_OFF_X2 = "res/img/btn_end_off_x2.png"; // 完了ボタン(フォーカス無)
	private final static String IMG_BTN_KAIIN_ON_X2 = "res/img/btn_kaiin_on_x2.png"; // 利用登録ボタン(フォーカス有)
	private final static String IMG_BTN_KAIIN_OFF_X2 = "res/img/btn_kaiin_off_x2.png"; // 利用登録ボタン(フォーカス無)
	private final static String IMG_BTN_AGREE_ON_X2 = "res/img/btn_agree_on_x2.png"; // 同意するボタン(フォーカス有)
	private final static String IMG_BTN_AGREE_OFF_X2 = "res/img/btn_agree_off_x2.png"; // 同意するボタン(フォーカス無)
	private final static String IMG_BTN_KENSAKU_ON_X2 = "res/img/btn_kensaku_on_x2.png"; // 検索開始ボタン(フォーカス有)
	private final static String IMG_BTN_KENSAKU_OFF_X2 = "res/img/btn_kensaku_off_x2.png"; // 検索開始ボタン(フォーカス無)
	private final static String IMG_BTN_FLASH10_ON_X2 = "res/img/btn_flash10_on_x2.png"; // 点滅した回数10ボタン(フォーカス有)
	private final static String IMG_BTN_FLASH10_OFF_X2 = "res/img/btn_flash10_off_x2.png"; // 点滅した回数10ボタン(フォーカス無)
	private final static String IMG_BTN_FLASH5_ON_X2 = "res/img/btn_flash5_on_x2.png"; // 点滅した回数5ボタン(フォーカス有)
	private final static String IMG_BTN_FLASH5_OFF_X2 = "res/img/btn_flash5_off_x2.png"; // 点滅した回数5ボタン(フォーカス無)
	private final static String IMG_BTN_DETAIL_ON_X2 = "res/img/btn_detail_on_x2.png"; // 詳細ボタン(フォーカス有)
	private final static String IMG_BTN_DETAIL_OFF_X2 = "res/img/btn_detail_off_x2.png"; // 詳細ボタン(フォーカス無)
	private final static String IMG_BTN_REGIST_SERVER_ON_X2 = "res/img/btn_regist_server_on_x2.png"; // 詳細ボタン(フォーカス有)
	private final static String IMG_BTN_REGIST_SERVER_OFF_X2 = "res/img/btn_regist_server_off_x2.png"; // 詳細ボタン(フォーカス無)
	
	public final static String IMG_BTN_SGW_VISUALIZATION1_X2 = "res/img/btn_web_contents_1_x2.png"; // 見える化画面(有効/フォーカス無)
	public final static String IMG_BTN_SGW_VISUALIZATION2_X2 = "res/img/btn_web_contents_2_x2.png"; // 見える化画面(有効/フォーカス有)
	public final static String IMG_BTN_SGW_VISUALIZATION3_X2 = "res/img/btn_web_contents_3_x2.png"; // 見える化画面(無効/フォーカス無)
	public final static String IMG_BTN_SGW_VISUALIZATION4_X2 = "res/img/btn_web_contents_4_x2.png"; // 見える化画面(無効/フォーカス有)
	public final static String IMG_BTN_METER_SETTINGS1_X2 = "res/img/btn_meter_settings_1_x2.png"; // 計器認証設定(有効/フォーカス無)
	public final static String IMG_BTN_METER_SETTINGS2_X2 = "res/img/btn_meter_settings_2_x2.png"; // 計器認証設定(有効/フォーカス有)
	public final static String IMG_BTN_METER_SETTINGS3_X2 = "res/img/btn_meter_settings_3_x2.png"; // 計器認証設定(無効/フォーカス無)
	public final static String IMG_BTN_METER_SETTINGS4_X2 = "res/img/btn_meter_settings_4_x2.png"; // 計器認証設定(無効/フォーカス有)
	
	private final ImageIcon IMG_ICON_VISUALIZATION_1_X2 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION1_X2));
	private final ImageIcon IMG_ICON_VISUALIZATION_2_X2 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION2_X2));
	private final ImageIcon IMG_ICON_VISUALIZATION_3_X2 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION3_X2));
	private final ImageIcon IMG_ICON_VISUALIZATION_4_X2 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION4_X2));
	private final ImageIcon IMG_ICON_METER_SETTINGS_1_X2 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS1_X2));
	private final ImageIcon IMG_ICON_METER_SETTINGS_2_X2 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS2_X2));
	private final ImageIcon IMG_ICON_METER_SETTINGS_3_X2 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS3_X2));
	private final ImageIcon IMG_ICON_METER_SETTINGS_4_X2 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS4_X2));

	// 説明文の背景画像ファイルパス(設定ガイド1 - 7ページ)
	private final static String IMG_MSG_GUIDE1_X2 = "res/img/msg_guide1_x2.png";
	private final static String IMG_MSG_GUIDE2_X2 = "res/img/msg_guide2_x2.png";
	private final static String IMG_MSG_GUIDE3_X2 = "res/img/msg_guide3_x2.png";
	private final static String IMG_MSG_GUIDE4_X2 = "res/img/msg_guide4_x2.png";
	private final static String IMG_MSG_GUIDE5_X2 = "res/img/msg_guide5_x2.png";
	private final static String IMG_MSG_GUIDE6_X2 = "res/img/msg_guide6_x2.png";
	private final static String IMG_MSG_GUIDE7_X2 = "res/img/msg_guide7_x2.png";
	private final static String IMG_MSG_GUIDE8_X2 = "res/img/msg_guide8_x2.png";

	// 説明文の背景画像ファイルパス(スマートゲートウェイの検索1 - 2ページ)
	private final static String IMG_MSG_SEARCH1_X2 = "res/img/msg_search1_x2.png";
	private final static String IMG_MSG_SEARCH2_X2 = "res/img/msg_search2_x2.png";

	// 説明文の背景画像ファイルパス(利用登録1 - 2ページ)
	private final static String IMG_MSG_REGIST1_X2 = "res/img/msg_regist1_x2.png";
	private final static String IMG_MSG_REGIST2_X2 = "res/img/msg_regist2_x2.png";

	// ボタン画像ファイルパス(サイズ特大)
	private final static String IMG_BTN_GUIDE_ON_X3 = "res/img/btn_guide_on_x3.png"; // 設定ガイドへボタン(フォーカス有)
	private final static String IMG_BTN_GUIDE_OFF_X3 = "res/img/btn_guide_off_x3.png"; // 設定ガイドへボタン(フォーカス無)
	private final static String IMG_BTN_SEARCH_ON_X3 = "res/img/btn_search_on_x3.png"; // スマートゲートウェイの検索へボタン(フォーカス有)
	private final static String IMG_BTN_SEARCH_OFF_X3 = "res/img/btn_search_off_x3.png"; // スマートゲートウェイの検索へボタン(フォーカス無)
	private final static String IMG_BTN_REGIST_ON_X3 = "res/img/btn_regist_on_x3.png"; // 利用登録へボタン(フォーカス有)
	private final static String IMG_BTN_REGIST_OFF_X3 = "res/img/btn_regist_off_x3.png"; // 利用登録へボタン(フォーカス無)//
	private final static String IMG_BTN_TOP_ON_X3 = "res/img/btn_top_on_x3.png"; // TOPへ戻るボタン(フォーカス有)
	private final static String IMG_BTN_TOP_OFF_X3 = "res/img/btn_top_off_x3.png"; // TOPへ戻るボタン(フォーカス無)
	private final static String IMG_BTN_PREV_ON_X3 = "res/img/btn_prev_on_x3.png"; // 前へボタン(フォーカス有)
	private final static String IMG_BTN_PREV_OFF_X3 = "res/img/btn_prev_off_x3.png"; // 前へボタン(フォーカス無)
	private final static String IMG_BTN_NEXT_ON_X3 = "res/img/btn_next_on_x3.png"; // 次へボタン(フォーカス有)
	private final static String IMG_BTN_NEXT_OFF_X3 = "res/img/btn_next_off_x3.png"; // 次へボタン(フォーカス無)
	private final static String IMG_BTN_CLOSE_ON_X3 = "res/img/btn_close_on_x3.png"; // 終了するボタン(フォーカス有)
	private final static String IMG_BTN_CLOSE_OFF_X3 = "res/img/btn_close_off_x3.png"; // 終了するボタン(フォーカス無)
	private final static String IMG_BTN_END_ON_X3 = "res/img/btn_end_on_x3.png"; // 完了ボタン(フォーカス有)
	private final static String IMG_BTN_END_OFF_X3 = "res/img/btn_end_off_x3.png"; // 完了ボタン(フォーカス無)
	private final static String IMG_BTN_KAIIN_ON_X3 = "res/img/btn_kaiin_on_x3.png"; // 利用登録ボタン(フォーカス有)
	private final static String IMG_BTN_KAIIN_OFF_X3 = "res/img/btn_kaiin_off_x3.png"; // 利用登録ボタン(フォーカス無)
	private final static String IMG_BTN_AGREE_ON_X3 = "res/img/btn_agree_on_x3.png"; // 同意するボタン(フォーカス有)
	private final static String IMG_BTN_AGREE_OFF_X3 = "res/img/btn_agree_off_x3.png"; // 同意するボタン(フォーカス無)
	private final static String IMG_BTN_KENSAKU_ON_X3 = "res/img/btn_kensaku_on_x3.png"; // 検索開始ボタン(フォーカス有)
	private final static String IMG_BTN_KENSAKU_OFF_X3 = "res/img/btn_kensaku_off_x3.png"; // 検索開始ボタン(フォーカス無)
	private final static String IMG_BTN_FLASH10_ON_X3 = "res/img/btn_flash10_on_x3.png"; // 点滅した回数10ボタン(フォーカス有)
	private final static String IMG_BTN_FLASH10_OFF_X3 = "res/img/btn_flash10_off_x3.png"; // 点滅した回数10ボタン(フォーカス無)
	private final static String IMG_BTN_FLASH5_ON_X3 = "res/img/btn_flash5_on_x3.png"; // 点滅した回数5ボタン(フォーカス有)
	private final static String IMG_BTN_FLASH5_OFF_X3 = "res/img/btn_flash5_off_x3.png"; // 点滅した回数5ボタン(フォーカス無)
	private final static String IMG_BTN_DETAIL_ON_X3 = "res/img/btn_detail_on_x3.png"; // 詳細ボタン(フォーカス有)
	private final static String IMG_BTN_DETAIL_OFF_X3 = "res/img/btn_detail_off_x3.png"; // 詳細ボタン(フォーカス無)
	private final static String IMG_BTN_REGIST_SERVER_ON_X3 = "res/img/btn_regist_server_on_x3.png"; // 詳細ボタン(フォーカス有)
	private final static String IMG_BTN_REGIST_SERVER_OFF_X3 = "res/img/btn_regist_server_off_x3.png"; // 詳細ボタン(フォーカス無)
	
	public final static String IMG_BTN_SGW_VISUALIZATION1_X3 = "res/img/btn_web_contents_1_x3.png"; // 見える化画面(有効/フォーカス無)
	public final static String IMG_BTN_SGW_VISUALIZATION2_X3 = "res/img/btn_web_contents_2_x3.png"; // 見える化画面(有効/フォーカス有)
	public final static String IMG_BTN_SGW_VISUALIZATION3_X3 = "res/img/btn_web_contents_3_x3.png"; // 見える化画面(無効/フォーカス無)
	public final static String IMG_BTN_SGW_VISUALIZATION4_X3 = "res/img/btn_web_contents_4_x3.png"; // 見える化画面(無効/フォーカス有)
	public final static String IMG_BTN_METER_SETTINGS1_X3 = "res/img/btn_meter_settings_1_x3.png"; // 計器認証設定(有効/フォーカス無)
	public final static String IMG_BTN_METER_SETTINGS2_X3 = "res/img/btn_meter_settings_2_x3.png"; // 計器認証設定(有効/フォーカス有)
	public final static String IMG_BTN_METER_SETTINGS3_X3 = "res/img/btn_meter_settings_3_x3.png"; // 計器認証設定(無効/フォーカス無)
	public final static String IMG_BTN_METER_SETTINGS4_X3 = "res/img/btn_meter_settings_4_x3.png"; // 計器認証設定(無効/フォーカス有)
	
	private final ImageIcon IMG_ICON_VISUALIZATION_1_X3 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION1_X3));
	private final ImageIcon IMG_ICON_VISUALIZATION_2_X3 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION2_X3));
	private final ImageIcon IMG_ICON_VISUALIZATION_3_X3 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION3_X3));
	private final ImageIcon IMG_ICON_VISUALIZATION_4_X3 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SGW_VISUALIZATION4_X3));
	private final ImageIcon IMG_ICON_METER_SETTINGS_1_X3 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS1_X3));
	private final ImageIcon IMG_ICON_METER_SETTINGS_2_X3 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS2_X3));
	private final ImageIcon IMG_ICON_METER_SETTINGS_3_X3 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS3_X3));
	private final ImageIcon IMG_ICON_METER_SETTINGS_4_X3 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_METER_SETTINGS4_X3));

	// 説明文の背景画像ファイルパス(設定ガイド1 - 7ページ)
	private final static String IMG_MSG_GUIDE1_X3 = "res/img/msg_guide1_x3.png";
	private final static String IMG_MSG_GUIDE2_X3 = "res/img/msg_guide2_x3.png";
	private final static String IMG_MSG_GUIDE3_X3 = "res/img/msg_guide3_x3.png";
	private final static String IMG_MSG_GUIDE4_X3 = "res/img/msg_guide4_x3.png";
	private final static String IMG_MSG_GUIDE5_X3 = "res/img/msg_guide5_x3.png";
	private final static String IMG_MSG_GUIDE6_X3 = "res/img/msg_guide6_x3.png";
	private final static String IMG_MSG_GUIDE7_X3 = "res/img/msg_guide7_x3.png";
	private final static String IMG_MSG_GUIDE8_X3 = "res/img/msg_guide8_x3.png";

	// 説明文の背景画像ファイルパス(スマートゲートウェイの検索1 - 2ページ)
	private final static String IMG_MSG_SEARCH1_X3 = "res/img/msg_search1_x3.png";
	private final static String IMG_MSG_SEARCH2_X3 = "res/img/msg_search2_x3.png";

	// 説明文の背景画像ファイルパス(利用登録1 - 2ページ)
	private final static String IMG_MSG_REGIST1_X3 = "res/img/msg_regist1_x3.png";
	private final static String IMG_MSG_REGIST2_X3 = "res/img/msg_regist2_x3.png";

	// ========================================================================================================
	// ページ番号
	// ========================================================================================================
	// 各ページの最大数
	private final static int PAGE_NO_MAX_GUIDE = 5; // 設定ガイド画面関係（※2015/09/24 5ページに変更）
	private final static int PAGE_NO_MAX_SEARCH = 2; // スマートゲートウェイの検索画面関係
	private final static int PAGE_NO_MAX_REGIST = 2; // 利用登録1画面関係

	// 現在のページの番号
	private final static int PAGE_NO_NOW_GUIDE1 = 1; // 設定ガイド1画面
	private final static int PAGE_NO_NOW_GUIDE2 = 2; // 設定ガイド2画面
	private final static int PAGE_NO_NOW_GUIDE3 = 3; // 設定ガイド3画面
	private final static int PAGE_NO_NOW_GUIDE4 = 4; // 設定ガイド4画面
	private final static int PAGE_NO_NOW_GUIDE5 = 5; // 設定ガイド5画面
	private final static int PAGE_NO_NOW_GUIDE6 = 6; // 設定ガイド6画面		(※p5,6は不要)
	//private final static int PAGE_NO_NOW_GUIDE7   = 7;       // 設定ガイド7画面
	private final static int PAGE_NO_NOW_GUIDE7 = 5; // 設定ガイド7画面
	private final static int PAGE_NO_NOW_GUIDE8 = 7; // 設定ガイド8画面
	private final static int PAGE_NO_NOW_SEARCH1 = 1; // スマートゲートウェイの検索1画面
	private final static int PAGE_NO_NOW_SEARCH2 = 2; // スマートゲートウェイの検索2画面
	private final static int PAGE_NO_NOW_REGIST1 = 1; // 利用登録1画面
	private final static int PAGE_NO_NOW_REGIST2 = 2; // 利用登録2画面
	
	// ========================================================================================================
	// その他
	// ========================================================================================================
	private final static String FILE_DOUBLE_BOOT_PATH = "res/file/lock"; // 多重起動のチェックに使うファイル名
	private final static String FILE_POLICY_PATH = "res/file/policy.txt"; // 利用規約
	//private final static String FILE_SEARCH_SGW_PATH  = "res/file/search_sgw.txt";  // SGWのIP検索結果を格納したファイル
	// 【注】JARファイル内では読み書きできないので、外部ファイルに入出力する
	public final static String FILE_SEARCH_SGW_PATH = "sgw_info.txt"; // SGWのIP検索結果を格納したファイル

	//アプリ終了後も取得したSGW情報を保持し続ける(仕様追加：2015/08/26)
	public JLabel label_footer_sgw_info;
	private final static String SMART_GATEWAY_INFO_LBL = "スマートゲートウェイ情報 ：　";
	private final static String MSG_NO_IP_ADDRESS = "(未取得)";
	public String smartGatewayInfo = MSG_NO_IP_ADDRESS;
	public boolean isSGWInfoChecked = false;

	private final static String TITLE_CONFIRM = "確認";
	private final static String TITLE_WARNING = "警告";
	private final static String TITLE_ERROR = "エラー";
	private final static String MES_WARNING_NO_IPADDRESS_OF_SGW = "スマートゲートウェイ情報が取得されていません。\n\nスマートゲートウェイの検索後、再び操作を行ってください。";
	//private final static String MES_ERROR_NO_CONNECTION_TO_SGW = "スマートゲートウェイと接続できません。\n\nネットワークの接続を確認後、ツールの再起動、または\nスマートゲートウェイの検索を行ってください。";
	private final static String MES_ERROR_NO_CONNECTION_TO_SGW = "スマートゲートウェイと接続できません。\n\n" +
			"ネットワークの接続を確認後、ツールの再起動、または\n「スマートゲートウェイの検索」を再度行ってください。\n\n" +
			"それでも、このまま設定操作を続けますか？";
	private final static String TITLE_WARNING_NO_IPADDRESS_OF_SGW = "[警告]: このまま設定操作を続けますか？";

	private final static String MES_WARNING_HAS_SEARCH_RESAULT = "前回のスマートゲートウェイの検索結果が存在します。\n\n検索結果を一旦クリアして、再検索しますか？\n\n";
	private final static String TITLE_WARNING_HAS_SEARCH_RESAULT = "[確認]: 再検索しますか？";
	
	private final static String MES_WARNING_MEDIACONV_MODE = "メディアコンバータモードでは操作できません。";
	private final static String TITLE_WARNING_MEDIACONV_MODE = "操作できません";

	//外部ブラウザと内部ブラウザの起動をチェックボックスで切替える　(仕様変更：2015/09/03)
	JCheckBox chk_launch_browser = new JCheckBox("Webブラウザを起動して表示");

	public String rootURL = "http://" + CommonParam.smartGatewayIp;

	public String requestURL = "http://192.168.0.199/";

	// スマートゲートウェイ設定画面表示
	private WebVeiwOnJFrame webVeiwOnJFrame = null;
	public static int WEB_VEW_SIZE_WIDTH = 900;
	public static int WEB_VEW_SIZE_HEIGHT = 700;
	
	public final static int WEB_VEW_SIZE_WIDTH_FOR_CONTETNS = 840;
	public final static int WEB_VEW_SIZE_HEIGHT_FOR_CONTETNS = 600;

	// スマートゲートウェイでは無い
	public static int TYPE_NOT_SGW = -1;

	// スマートゲートウェイ
	public static boolean IS_SGW = false;
	public static int TYPE_SGW = 0;
	// スマートゲートウェイmini
	public static boolean IS_SGW_MINI = true;
	public static int TYPE_SGW_MINI = 1;
	// スマートゲートウェイPlus
	public static boolean IS_SGW_PLUS = false;
	public static int TYPE_SGW_PLUS = 2;
	// スマートゲートウェイPlus（Ver.2.xx）
	public static boolean IS_SGW_PLUS_V2 = false;
	public static int TYPE_SGW_PLUS_V2 = 3;
	// スマートゲートウェイPlus（Ver.3.xx）
	public static boolean IS_SGW_PLUS_V3 = false;
	public static int TYPE_SGW_PLUS_V3 = 4;
	public static boolean IS_SGW_PLUS_MC = false;
	public static int TYPE_SGW_PLUS_MC = 5;
	// スマートゲートウェイPlus（Ver.4.xx）
	public static boolean IS_SGW_PLUS_V4 = false;
	public static int TYPE_SGW_PLUS_V4 = 6;
	// 現在のSGWタイプ
	public static int CURRENT_SGW_TYPE = TYPE_SGW_MINI;
	//　SGWの登録状態が空の時のラベル（空欄）
	public static String BLANK_STATUS_LBL = "　　　"; // 大文字スペース×３

	private static boolean isSupportedJavaVersion = true;

	public static DefaultHttpClient loginedClient = null;
	public static OkHttpClient loginedOkHttpClient = null;
	private static List<okhttp3.Cookie> currentOkCookies;

	//Webコンテンツ設定ダイアログを表示
	protected WebContentsSettingDialog webContentsDialog = null;

	//見える化ボタンと計器認証設定ボタン
	private JButton topBtn_meter_setting;
	private JButton topBtn_visualization;
	
	//高解像ディスプレイ対応
	public static boolean IS_HIGH_RESOLUTION = false;			// 高解像ディスプレイかの判定フラグ
	public static boolean IS_4K_RESOLUTION = false;				// ４Kディスプレイかの判定フラグ
	public static final double DISP_RATE_FOR_WQHD = 2.0d;		// 画面倍率(WQHD)
	public static final double DISP_RATE_FOR_4K = 3.0d;			// 画面倍率(4K)
	public static double DISP_RATE = DISP_RATE_FOR_WQHD;		// 画面倍率
	
	// 詳細画面のサブタイトル
	private JLabel subtitle_detail_settings;
	
	/**
	 * 開始メソッド。フレームの定義
	 *
	 * @param args パラメータ
	 * @throws IOException
	 * @throws InterruptedException
	 * @throws URISyntaxException
	 */
	public static void main(String[] args) throws IOException, InterruptedException, URISyntaxException {

		// ===================================================================================================
		// フレーム作成
		// ===================================================================================================
		// 例外エラーはハンドリングしてエラーダイアログで出力する。
		// そのため、JARをクリックしても何も起こらないことは基本的にない。
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				// EDTに例外ハンドラーを設定し、ErrorとRuntimeException を受け取る
				Thread.setDefaultUncaughtExceptionHandler(new UncaughtExceptionHandler() {
					public void uncaughtException(Thread t, Throwable e) {
						if (e instanceof java.lang.NullPointerException) {
							// 何もしない
						} else {
							ShowDialog.showErrorDialog(e);
						}
					}
				});

				try {
					// プロパティファイル読み込み
					CommonFunc.loadProperties();

					String java_version = System.getProperty("java.version");
					System.out.println("Javaバージョン:[" + java_version + "]\n");

					// フレームを作成して表示
					frame = new SgwMiniSetup();
					frame.setVisible(true);

				} catch (InterruptedException e) {
					e.printStackTrace();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * コンストラクタ
	 *
	 * @throws Exception
	 */
	public SgwMiniSetup() throws Exception {
		// ===================================================================================================
		// 多重起動のチェック
		// ===================================================================================================
		// すでにアプリが起動していた場合、多重起動はさせない。作業ファイルに排他ロックをかけて判断する。
		// アプリ右上の×ボタンか、System.exit(0);を行うことで排他ロックから解放される。
		/*
				URL fileUrl = getClass().getClassLoader().getResource(FILE_DOUBLE_BOOT_PATH);
				File file = new File(fileUrl.toURI());
				final FileOutputStream fos = new FileOutputStream(file);
				final FileChannel fc = fos.getChannel();
				final FileLock lock  = fc.tryLock();

				if(lock == null) {
					//既に起動されているので終了する
					System.out.println(MSG_APLI_DOUBLE_BOOT);
					ShowDialog.showInfoDialog(MSG_APLI_TITLE, MSG_APLI_DOUBLE_BOOT);
					System.exit(0);
				}

				// ロック開放処理を登録
				Runtime.getRuntime().addShutdownHook(
						new Thread() {
							public void run() {
								if(lock != null && lock.isValid()) {
									try {
										lock.release();
									} catch (IOException e) {
										e.printStackTrace();
									}
								}

								try {
									fc.close();
									fos.close();
								} catch (IOException e) {
									e.printStackTrace();
								}
							}
						}
				);
		*/
		
		// ディスプレイサイズをチェックする
		checkDisplaySize();
		
		// ========================================================================================================
		// フレーム上に貼りつける各パネルを作成
		// ========================================================================================================
		// ベースとなるパネルをCardLayoutとして作成
		panelBase = new JPanel();
		layout = new CardLayout(CARD_LAYOUT_HGAP, CARD_LAYOUT_VGAP);
		panelBase.setLayout(layout);

		// 各パネルを作成。TOP画面以外は、現在のページ番号と最大ページ番号を引数にして作成
		panel_top = setJPanelTop(); // TOP画面
		panel_guide1 = setJPanelGuide1(PAGE_NO_NOW_GUIDE1, PAGE_NO_MAX_GUIDE); // 設定ガイド1画面
		panel_guide2 = setJPanelGuide2(PAGE_NO_NOW_GUIDE2, PAGE_NO_MAX_GUIDE); // 設定ガイド2画面
		panel_guide3 = setJPanelGuide3(PAGE_NO_NOW_GUIDE3, PAGE_NO_MAX_GUIDE); // 設定ガイド3画面
		panel_guide4 = setJPanelGuide4(PAGE_NO_NOW_GUIDE4, PAGE_NO_MAX_GUIDE); // 設定ガイド4画面
		panel_guide5 = setJPanelGuide5(PAGE_NO_NOW_GUIDE5, PAGE_NO_MAX_GUIDE); // 設定ガイド5画面
		panel_guide6 = setJPanelGuide6(PAGE_NO_NOW_GUIDE6, PAGE_NO_MAX_GUIDE); // 設定ガイド6画面
		panel_guide7 = setJPanelGuide7(PAGE_NO_NOW_GUIDE7, PAGE_NO_MAX_GUIDE); // 設定ガイド7画面
		panel_guide8 = setJPanelGuide8(PAGE_NO_NOW_GUIDE8, PAGE_NO_MAX_GUIDE); // 設定ガイド8画面
		panel_search1 = setJPanelSearch1(PAGE_NO_NOW_SEARCH1, PAGE_NO_MAX_SEARCH); // スマートゲートウェイの検索1画面
		panel_search2 = setJPanelSearch2(PAGE_NO_NOW_SEARCH2, PAGE_NO_MAX_SEARCH); // スマートゲートウェイの検索2画面
		panel_regist1 = setJPanelRegist1(PAGE_NO_NOW_REGIST1, PAGE_NO_MAX_REGIST); // 利用登録1画面
		panel_regist2 = setJPanelRegist2(PAGE_NO_NOW_REGIST2, PAGE_NO_MAX_REGIST); // 利用登録2画面

		//2015/09/02追加
		panel_detail = setJPanelDetail();

		// ベースとなるパネルに、各パネルを追加
		panelBase.add(panel_top, "panel_top");
		panelBase.add(panel_guide1, "panel_guide1");
		panelBase.add(panel_guide2, "panel_guide2");
		panelBase.add(panel_guide3, "panel_guide3");
		panelBase.add(panel_guide4, "panel_guide4");
		panelBase.add(panel_guide5, "panel_guide5");
		panelBase.add(panel_guide6, "panel_guide6");
		panelBase.add(panel_guide7, "panel_guide7");
		panelBase.add(panel_guide8, "panel_guide8");
		panelBase.add(panel_search1, "panel_search1");
		panelBase.add(panel_search2, "panel_search2");
		panelBase.add(panel_regist1, "panel_regist1");
		panelBase.add(panel_regist2, "panel_regist2");

		panelBase.add(panel_detail, "panel_detail");

		// ========================================================================================================
		// フレーム作成
		// ========================================================================================================
		// ベースのパネルをフレームに追加
		getContentPane().add(panelBase, BorderLayout.CENTER);

		// ウインドウのタイトルを設定
		setTitle(MSG_APLI_TITLE);

		// フレームの幅、高さを設定
		if (IS_HIGH_RESOLUTION) {
			setSize(calcDispSize(APLI_WIDTH), calcDispSize(APLI_HEIGHT));
 		} else {
 			setSize(APLI_WIDTH, APLI_HEIGHT);
 		}

		// 画面中央に表示
		setLocationRelativeTo(null);

		// Closeボタンが押された時、ウィンドウを閉じる
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// フレームのサイズを変更可能にするか
		setResizable(APLI_WINDOW_RESIZE_FLG);

		// アプリのfaviconイメージをセット
		ImageIcon icon_favicon = new ImageIcon(getClass().getClassLoader().getResource(IMG_APLI_FAVICON));
		setIconImage(icon_favicon.getImage());

		// アプリのLook&Feel設定
		String osname = System.getProperty("os.name");
		// Windowsであったときの処理
		if (osname.indexOf("Windows") >= 0) {
			UIManager.setLookAndFeel(APLI_LOOK_AND_FEEL_FOR_WIN);
		// MacOSであったときの処理
		} else if (osname.indexOf("Mac") >= 0) {
			UIManager.setLookAndFeel(APLI_LOOK_AND_FEEL_FOR_MAC);
		} else {
			UIManager.setLookAndFeel(APLI_LOOK_AND_FEEL);
		}
		SwingUtilities.updateComponentTreeUI(this);

		// マウスイベント追加
		this.addMouseListener(new MouseAdapter() {
			public void mouseClicked(MouseEvent e) {
				showWebContentsDialog(false);
			}
		});
		
		// ウインドウイベント追加
		this.addWindowListener(new WindowAdapter() {
			// ウインドウが閉じると呼び出されます。
			public void windowClosing(WindowEvent we) {
				updateSgwInfo();
			}
		});

		// 画面更新
		updateDisplay(true);
	}
	
	public static int calcDispSize(int size) {
		return calcSizeForDispRate(size, DISP_RATE);
	}
	private static int calcSizeForDispRate(int size, double rate) {
		int result = size;
		try {
			if (rate > 0) {
				result = (int) Math.round(size * rate);
			}
		} catch (Exception e) { }
		return result;
	}
	
	public static int disCalcDispSize(int size) {
		return disCalcSizeForDispRate(size, DISP_RATE);
	}
	private static int disCalcSizeForDispRate(int size, double rate) {
		int result = size;
		try {
			if (rate > 0) {
				result = (int) Math.round(size / rate);
			}
		} catch (Exception e) { }
		return result;
	}

	private void showWebContentsDialog(boolean isVisible) {
		if (isVisible) {
			if (webContentsDialog == null) {
				webContentsDialog = new WebContentsSettingDialog(this);
			}
			webContentsDialog.setVisible(true);
		} else {
			if (webContentsDialog != null
					&& webContentsDialog.isVisible()) {
				webContentsDialog.setVisible(false);
			}
		}
	}
	
	// ディスプレイサイズをチェックする
	private void checkDisplaySize() {
		// デスクトップのサイズを取得する
		GraphicsEnvironment env = GraphicsEnvironment.getLocalGraphicsEnvironment();
		DisplayMode displayMode = env.getDefaultScreenDevice().getDisplayMode();
		// 変数widthとheightに画面の解像度の幅と高さを代入
		int width = displayMode.getWidth();
		int height = displayMode.getHeight();
		
		if (width > 1920 && height > 1080) {
			IS_HIGH_RESOLUTION = true;
			
			// ４Kディスプレイの場合は倍率を変更する
			if (width >= 3840 && height >= 2160) {
				IS_4K_RESOLUTION = true;
				DISP_RATE = DISP_RATE_FOR_4K;
			} else {
				DISP_RATE = DISP_RATE_FOR_WQHD;
			}
		} else {
			IS_4K_RESOLUTION = false;
			IS_HIGH_RESOLUTION = false;
		}
	}

	// 表示を更新する
	public void updateDisplay(boolean needsWarningMessage) {
		/*ファイルからSGW情報を読み込む*/
		readSavedSgwIp();

		// 設定／通信状態によって表示色を変える
		Color fontColor = Color.BLACK;
		if (smartGatewayInfo == MSG_NO_IP_ADDRESS) {
			fontColor = Color.RED;
		} else if (CommonParam.smartGatewayIp != null && CommonParam.smartGatewayIp.length() > 0) {
			String rootUrl = "http://" + CommonParam.smartGatewayIp + "/index.cgi";
			String rootUrlSub = "http://" + CommonParam.smartGatewayIp + "/index_media.cgi";
			// 通信テスト
			//CommTestThread th = new CommTestThread(this, rootUrl, needsWarningMessage);
			CommTestThread th = new CommTestThread(this, rootUrl, rootUrlSub, needsWarningMessage);
			th.start();
		}

		// 色の更新
		label_footer_sgw_info.setForeground(fontColor);
		// SGW情報の更新
		if (CommonParam.IP_ADDRESS_LBL != null
				&& CommonParam.IP_ADDRESS_LBL.length() > 0
				&& smartGatewayInfo != MSG_NO_IP_ADDRESS) {
			String status = BLANK_STATUS_LBL;
			if (CommonParam.smartGatewayStatus != null
					&& CommonParam.smartGatewayStatus.length() > 0) {
				status = CommonParam.smartGatewayStatus;
			}
			//【@Ver.2.04】：IPアドレス、SGW製造番号とともに、登録状況も表示する
			smartGatewayInfo = CommonParam.IP_ADDRESS_LBL + "[" + CommonParam.smartGatewayIp + "]        "
					+ CommonParam.SERIAL_NUMBER_LBL + "[" + CommonParam.smartGatewaySerialNo + "]        "
					+ CommonParam.REGIST_STATUS_LBL + "[" + status + "]　";
		} else {
			smartGatewayInfo = MSG_NO_IP_ADDRESS;
		}
		label_footer_sgw_info.setText(SMART_GATEWAY_INFO_LBL + smartGatewayInfo);

		// ボタンの表示/非表示を切り替える
		setButtonVisiblity(true);
	}
	
	public void setButtonVisiblity(boolean isCommTestSucceeded) {
		// ボタンの表示/非表示
		if (SgwMiniSetup.IS_SGW_PLUS && !SgwMiniSetup.IS_SGW_PLUS_MC) {
			if (com.SgwMiniSetup.common.CommonParam.registAllServerHost) {
				topBtn_meter_setting.setVisible(false);
			} else {
				topBtn_meter_setting.setVisible(true);
			}
			if (SgwMiniSetup.IS_SGW_PLUS_V2 || SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4) {
				topBtn_visualization.setVisible(true);
			} else {
				topBtn_visualization.setVisible(false);
			}
		} else {
			topBtn_meter_setting.setVisible(false);
			topBtn_visualization.setVisible(false);
		} 

		if (!isCommTestSucceeded) {
			CommonParam.authorizationId = null;
			CommonParam.authorizationPassword = null;
			CommonParam.hasSmartMeterValue = false;
		}
		
		// ボタンの状態を更新する
		updateButtonStatus();
	}
	
	// ボタンの状態を更新する
	public void updateButtonStatus() {
		if (CommonParam.hasSmartMeterValue) {
			if (topBtn_visualization != null) {
				if (IS_HIGH_RESOLUTION) {
					if (IS_4K_RESOLUTION) {
						topBtn_visualization.setIcon(IMG_ICON_VISUALIZATION_1_X3);
						topBtn_visualization.setRolloverIcon(IMG_ICON_VISUALIZATION_2_X3);
						topBtn_visualization.setPressedIcon(IMG_ICON_VISUALIZATION_2_X3);
					} else {
						topBtn_visualization.setIcon(IMG_ICON_VISUALIZATION_1_X2);
						topBtn_visualization.setRolloverIcon(IMG_ICON_VISUALIZATION_2_X2);
						topBtn_visualization.setPressedIcon(IMG_ICON_VISUALIZATION_2_X2);
					}
				} else {
					topBtn_visualization.setIcon(IMG_ICON_VISUALIZATION_1);
					topBtn_visualization.setRolloverIcon(IMG_ICON_VISUALIZATION_2);
					topBtn_visualization.setPressedIcon(IMG_ICON_VISUALIZATION_2);
				}
			}
			if (topBtn_visualization != null) {
				if (IS_HIGH_RESOLUTION) {
					if (IS_4K_RESOLUTION) {
						topBtn_meter_setting.setIcon(IMG_ICON_METER_SETTINGS_1_X3);
						topBtn_meter_setting.setRolloverIcon(IMG_ICON_METER_SETTINGS_2_X3);
						topBtn_meter_setting.setPressedIcon(IMG_ICON_METER_SETTINGS_2_X3);
					} else {
						topBtn_meter_setting.setIcon(IMG_ICON_METER_SETTINGS_1_X2);
						topBtn_meter_setting.setRolloverIcon(IMG_ICON_METER_SETTINGS_2_X2);
						topBtn_meter_setting.setPressedIcon(IMG_ICON_METER_SETTINGS_2_X2);
					}
				} else {
					topBtn_meter_setting.setIcon(IMG_ICON_METER_SETTINGS_1);
					topBtn_meter_setting.setRolloverIcon(IMG_ICON_METER_SETTINGS_2);
					topBtn_meter_setting.setPressedIcon(IMG_ICON_METER_SETTINGS_2);
				}
			}
		} else {
			if (topBtn_visualization != null) {
				if (IS_HIGH_RESOLUTION) {
					if (IS_4K_RESOLUTION) {
						topBtn_visualization.setIcon(IMG_ICON_VISUALIZATION_3_X3);
						topBtn_visualization.setRolloverIcon(IMG_ICON_VISUALIZATION_4_X3);
						topBtn_visualization.setPressedIcon(IMG_ICON_VISUALIZATION_4_X3);
					} else {
						topBtn_visualization.setIcon(IMG_ICON_VISUALIZATION_3_X2);
						topBtn_visualization.setRolloverIcon(IMG_ICON_VISUALIZATION_4_X2);
						topBtn_visualization.setPressedIcon(IMG_ICON_VISUALIZATION_4_X2);
					}
				} else {
					topBtn_visualization.setIcon(IMG_ICON_VISUALIZATION_3);
					topBtn_visualization.setRolloverIcon(IMG_ICON_VISUALIZATION_4);
					topBtn_visualization.setPressedIcon(IMG_ICON_VISUALIZATION_4);
				}
			}
			if (topBtn_visualization != null) {
				if (IS_HIGH_RESOLUTION) {
					if (IS_4K_RESOLUTION) {
						topBtn_meter_setting.setIcon(IMG_ICON_METER_SETTINGS_3_X3);
						topBtn_meter_setting.setRolloverIcon(IMG_ICON_METER_SETTINGS_4_X3);
						topBtn_meter_setting.setPressedIcon(IMG_ICON_METER_SETTINGS_4_X3);
					} else {
						topBtn_meter_setting.setIcon(IMG_ICON_METER_SETTINGS_3_X2);
						topBtn_meter_setting.setRolloverIcon(IMG_ICON_METER_SETTINGS_4_X2);
						topBtn_meter_setting.setPressedIcon(IMG_ICON_METER_SETTINGS_4_X2);
					}
				} else {
					topBtn_meter_setting.setIcon(IMG_ICON_METER_SETTINGS_3);
					topBtn_meter_setting.setRolloverIcon(IMG_ICON_METER_SETTINGS_4);
					topBtn_meter_setting.setPressedIcon(IMG_ICON_METER_SETTINGS_4);
				}
			}
		}
	}
	
	/**
	 * TOP画面のパネルに各コンポーネントをセットして返す
	 *
	 * @return JPanel panel TOP画面のパネル
	 */
	public JPanel setJPanelTop() {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_GUIDE_TITLE, FONT_COLOR_GUIDE);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_GUIDE_SUBTITLE, FONT_COLOR_GUIDE);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(ボタン無し)
		JLabel btn_left = setJLabelLeftButton();
		panel.add(btn_left);

		// 右側ボタン(ボタン無し)
		JLabel btn_right = setJLabelRightButton();
		panel.add(btn_right);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		// フッター(SGW情報)
		readSavedSgwIp();
		label_footer_sgw_info = setJabelFooterSmartGatewayInfo();
		panel.add(label_footer_sgw_info);

		// ========================================================================================================
		// この画面独自のコンポーネント
		// ========================================================================================================
		// 終了するボタン
		ImageIcon icon_close = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_CLOSE_OFF));
		ImageIcon rollover_close = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_CLOSE_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				icon_close = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_CLOSE_OFF_X3));
				rollover_close = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_CLOSE_ON_X3));
			} else {
				icon_close = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_CLOSE_OFF_X2));
				rollover_close = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_CLOSE_ON_X2));
			}
		}
		//JButton btn_close = new JButton(icon_close);
		JButton btn_close = new ScaledImageButton(icon_close);
		btn_close.setRolloverIcon(rollover_close);
		btn_close.setPressedIcon(rollover_close);
		if (IS_HIGH_RESOLUTION) {
			btn_close.setBounds(calcDispSize(POS_TOP_BTN_CLOSE_X), calcDispSize(POS_TOP_BTN_CLOSE_Y),
					calcDispSize(POS_TOP_BTN_CLOSE_WIDTH), calcDispSize(POS_TOP_BTN_CLOSE_HEIGHT));
		} else {
			btn_close.setBounds(POS_TOP_BTN_CLOSE_X, POS_TOP_BTN_CLOSE_Y,
					POS_TOP_BTN_CLOSE_WIDTH, POS_TOP_BTN_CLOSE_HEIGHT);
		}
		btn_close.setBorderPainted(false);
		btn_close.setContentAreaFilled(false);
		btn_close.addActionListener(this);
		btn_close.setActionCommand("btn_close");
		panel.add(btn_close);

		// 説明文
		JLabel label_msg = new JLabel(MSG_TOP_EXPLANATION);
		if (IS_HIGH_RESOLUTION) {
			label_msg.setBounds(calcDispSize(POS_TOP_EXPLANATION_X), calcDispSize(POS_TOP_EXPLANATION_Y),
					calcDispSize(POS_TOP_EXPLANATION_WIDTH), calcDispSize(POS_TOP_EXPLANATION_HEIGHT));
			label_msg.setFont(new Font(Font.SANS_SERIF, Font.BOLD, calcDispSize(FONT_SIZE_TOP_EXPLANATION)));
		} else {
			label_msg.setBounds(POS_TOP_EXPLANATION_X, POS_TOP_EXPLANATION_Y,
					POS_TOP_EXPLANATION_WIDTH, POS_TOP_EXPLANATION_HEIGHT);
			label_msg.setFont(new Font(Font.SANS_SERIF, Font.BOLD, FONT_SIZE_TOP_EXPLANATION));
		}
		label_msg.setForeground(FONT_COLOR_TOP);
		panel.add(label_msg);

		// 設定ガイドボタン
		ImageIcon icon_guide = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_GUIDE_OFF));
		ImageIcon rollover_guide = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_GUIDE_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				icon_guide = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_GUIDE_OFF_X3));
				rollover_guide = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_GUIDE_ON_X3));
			} else {
				icon_guide = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_GUIDE_OFF_X2));
				rollover_guide = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_GUIDE_ON_X2));
			}
		}
		//JButton btn_guide = new JButton(icon_guide);
		JButton btn_guide = new ScaledImageButton(icon_guide);
		btn_guide.setRolloverIcon(rollover_guide);
		btn_guide.setPressedIcon(rollover_guide);
		if (IS_HIGH_RESOLUTION) {
			btn_guide.setContentAreaFilled(true);
			btn_guide.setBounds(calcDispSize(POS_TOP_BTN_GUIDE_X), calcDispSize(POS_TOP_BTN_GUIDE_Y),
					calcDispSize(POS_TOP_BTN_GUIDE_WIDTH), calcDispSize(POS_TOP_BTN_GUIDE_HEIGHT));
		} else {
			btn_guide.setBounds(POS_TOP_BTN_GUIDE_X, POS_TOP_BTN_GUIDE_Y,
					POS_TOP_BTN_GUIDE_WIDTH, POS_TOP_BTN_GUIDE_HEIGHT);
		}
		btn_guide.setBorderPainted(false);
		btn_guide.setContentAreaFilled(false);
		btn_guide.addActionListener(this);
		btn_guide.setActionCommand("btn_guide");
		panel.add(btn_guide);

		// スマートゲートウェイの検索ボタン
		ImageIcon icon_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_OFF));
		ImageIcon rollover_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				icon_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_OFF_X3));
				rollover_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_ON_X3));
			} else {
				icon_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_OFF_X2));
				rollover_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_ON_X2));
			}
		}
		//JButton btn_search = new JButton(icon_search);
		JButton btn_search = new ScaledImageButton(icon_search);
		btn_search.setRolloverIcon(rollover_search);
		btn_search.setPressedIcon(rollover_search);
		if (IS_HIGH_RESOLUTION) {
			btn_search.setContentAreaFilled(true);
			btn_search.setBounds(calcDispSize(POS_TOP_BTN_SEARCH_X), calcDispSize(POS_TOP_BTN_SEARCH_Y),
					calcDispSize(POS_TOP_BTN_SEARCH_WIDTH), calcDispSize(POS_TOP_BTN_SEARCH_HEIGHT));
		} else {
			btn_search.setBounds(POS_TOP_BTN_SEARCH_X, POS_TOP_BTN_SEARCH_Y,
					POS_TOP_BTN_SEARCH_WIDTH, POS_TOP_BTN_SEARCH_HEIGHT);
		}
		btn_search.setBorderPainted(false);
		btn_search.setContentAreaFilled(false);
		btn_search.addActionListener(this);
		btn_search.setActionCommand("btn_search");
		panel.add(btn_search);

		// 利用登録ボタン
		ImageIcon icon_regist = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_OFF));
		ImageIcon rollover_regist = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				icon_regist = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_OFF_X3));
				rollover_regist = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_ON_X3));
			} else {
				icon_regist = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_OFF_X2));
				rollover_regist = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_ON_X2));
			}
		}
		//JButton btn_regist = new JButton(icon_regist);
		JButton btn_regist = new ScaledImageButton(icon_regist);
		btn_regist.setRolloverIcon(rollover_regist);
		btn_regist.setPressedIcon(rollover_regist);
		if (IS_HIGH_RESOLUTION) {
			btn_regist.setContentAreaFilled(true);
			btn_regist.setBounds(calcDispSize(POS_TOP_BTN_REGIST_X), calcDispSize(POS_TOP_BTN_REGIST_Y),
					calcDispSize(POS_TOP_BTN_REGIST_WIDTH), calcDispSize(POS_TOP_BTN_REGIST_HEIGHT));
		} else {
			btn_regist.setBounds(POS_TOP_BTN_REGIST_X, POS_TOP_BTN_REGIST_Y,
					POS_TOP_BTN_REGIST_WIDTH, POS_TOP_BTN_REGIST_HEIGHT);
		}
		btn_regist.setBorderPainted(false);
		btn_regist.setContentAreaFilled(false);
		btn_regist.addActionListener(this);
		btn_regist.setActionCommand("btn_regist");
		panel.add(btn_regist);

		/*詳細ボタン*/
		ImageIcon icon_detail = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_DETAIL_OFF));
		ImageIcon rollover_detail = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_DETAIL_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				icon_detail = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_DETAIL_OFF_X3));
				rollover_detail = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_DETAIL_ON_X3));
			} else {
				icon_detail = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_DETAIL_OFF_X2));
				rollover_detail = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_DETAIL_ON_X2));
			}
		}
		//JButton btn_detail = new JButton(icon_detail);
		JButton btn_detail = new ScaledImageButton(icon_detail);
		btn_detail.setRolloverIcon(rollover_detail);
		btn_detail.setPressedIcon(rollover_detail);
		if (IS_HIGH_RESOLUTION) {
			btn_detail.setContentAreaFilled(true);
			btn_detail.setBounds(calcDispSize(POS_TOP_BTN_DETAIL_X), calcDispSize(POS_TOP_BTN_DETAIL_Y),
					calcDispSize(POS_TOP_BTN_DETAIL_WIDTH), calcDispSize(POS_TOP_BTN_DETAIL_HEIGHT));
		} else {
			btn_detail.setBounds(POS_TOP_BTN_DETAIL_X, POS_TOP_BTN_DETAIL_Y,
					POS_TOP_BTN_DETAIL_WIDTH, POS_TOP_BTN_DETAIL_HEIGHT);
		}
		btn_detail.setBorderPainted(false);
		btn_detail.setContentAreaFilled(false);
		btn_detail.addActionListener(this);
		btn_detail.setActionCommand("btn_detail");
		panel.add(btn_detail);

		/*サーバ一括登録ボタン*/
		ImageIcon icon_regist_server = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_SERVER_OFF));
		ImageIcon rollover_regist_server = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_SERVER_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				icon_regist_server = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_SERVER_OFF_X3));
				rollover_regist_server = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_SERVER_ON_X3));
			} else {
				icon_regist_server = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_SERVER_OFF_X2));
				rollover_regist_server = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_REGIST_SERVER_ON_X2));
			}
		}
		//JButton btn_regist_server = new JButton(icon_regist_server);
		JButton btn_regist_server = new ScaledImageButton(icon_regist_server);
		btn_regist_server.setRolloverIcon(rollover_regist_server);
		btn_regist_server.setPressedIcon(rollover_regist_server);
		if (IS_HIGH_RESOLUTION) {
			btn_regist_server.setContentAreaFilled(true);
			btn_regist_server.setBounds(calcDispSize(POS_TOP_BTN_REGIST_SERVER_X), calcDispSize(POS_TOP_BTN_REGIST_SERVER_Y),
					calcDispSize(POS_TOP_BTN_REGIST_SERVER_WIDTH), calcDispSize(POS_TOP_BTN_REGIST_SERVER_HEIGHT));
		} else {
			btn_regist_server.setBounds(POS_TOP_BTN_REGIST_SERVER_X, POS_TOP_BTN_REGIST_SERVER_Y,
					POS_TOP_BTN_REGIST_SERVER_WIDTH, POS_TOP_BTN_REGIST_SERVER_HEIGHT);
		}
		btn_regist_server.setBorderPainted(false);
		btn_regist_server.setContentAreaFilled(false);
		btn_regist_server.addActionListener(this);
		btn_regist_server.setActionCommand("btn_regist_server");
		if (com.SgwMiniSetup.common.CommonParam.registAllServerHost) {
			panel.add(btn_regist_server);
		}

		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				//topBtn_visualization = new JButton(IMG_ICON_VISUALIZATION_3_X3);
				topBtn_visualization = new ScaledImageButton(IMG_ICON_VISUALIZATION_3_X3);
				topBtn_visualization.setRolloverIcon(IMG_ICON_VISUALIZATION_4_X3);
				topBtn_visualization.setPressedIcon(IMG_ICON_VISUALIZATION_4_X3);
			} else {
				//topBtn_visualization = new JButton(IMG_ICON_VISUALIZATION_3_X2);
				topBtn_visualization = new ScaledImageButton(IMG_ICON_VISUALIZATION_3_X2);
				topBtn_visualization.setRolloverIcon(IMG_ICON_VISUALIZATION_4_X2);
				topBtn_visualization.setPressedIcon(IMG_ICON_VISUALIZATION_4_X2);
			}
			topBtn_visualization.setContentAreaFilled(true);
			topBtn_visualization.setBounds(calcDispSize(POS_TOP_BTN_WEB_CONTENTS_X), calcDispSize(POS_TOP_BTN_WEB_CONTENTS_Y),
					calcDispSize(POS_TOP_BTN_WEB_CONTENTS_WIDTH), calcDispSize(POS_TOP_BTN_WEB_CONTENTS_HEIGHT));
		} else {
			//topBtn_visualization = new JButton(IMG_ICON_VISUALIZATION_3);
			topBtn_visualization = new ScaledImageButton(IMG_ICON_VISUALIZATION_3);
			topBtn_visualization.setRolloverIcon(IMG_ICON_VISUALIZATION_4);
			topBtn_visualization.setPressedIcon(IMG_ICON_VISUALIZATION_4);
			topBtn_visualization.setBounds(POS_TOP_BTN_WEB_CONTENTS_X, POS_TOP_BTN_WEB_CONTENTS_Y,
					POS_TOP_BTN_WEB_CONTENTS_WIDTH, POS_TOP_BTN_WEB_CONTENTS_HEIGHT);
		}
		topBtn_visualization.setBorderPainted(false);
		topBtn_visualization.setContentAreaFilled(false);
		topBtn_visualization.addActionListener(this);
		topBtn_visualization.setActionCommand("topBtn_visualization");
		panel.add(topBtn_visualization);

		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				//topBtn_meter_setting = new JButton(IMG_ICON_METER_SETTINGS_3_X3);
				topBtn_meter_setting = new ScaledImageButton(IMG_ICON_METER_SETTINGS_3_X3);
				topBtn_meter_setting.setRolloverIcon(IMG_ICON_METER_SETTINGS_4_X3);
				topBtn_meter_setting.setPressedIcon(IMG_ICON_METER_SETTINGS_4_X3);
			} else {
				//topBtn_meter_setting = new JButton(IMG_ICON_METER_SETTINGS_3_X2);
				topBtn_meter_setting = new ScaledImageButton(IMG_ICON_METER_SETTINGS_3_X2);
				topBtn_meter_setting.setRolloverIcon(IMG_ICON_METER_SETTINGS_4_X2);
				topBtn_meter_setting.setPressedIcon(IMG_ICON_METER_SETTINGS_4_X2);
			}
			topBtn_meter_setting.setContentAreaFilled(true);
			topBtn_meter_setting.setBounds(calcDispSize(POS_TOP_BTN_METER_SETTINGS_X), calcDispSize(POS_TOP_BTN_METER_SETTINGS_Y),
					calcDispSize(POS_TOP_BTN_METER_SETTINGS_WIDTH), calcDispSize(POS_TOP_BTN_METER_SETTINGS_HEIGHT));
		} else {
			//topBtn_meter_setting = new JButton(IMG_ICON_METER_SETTINGS_3);
			topBtn_meter_setting = new ScaledImageButton(IMG_ICON_METER_SETTINGS_3);
			topBtn_meter_setting.setRolloverIcon(IMG_ICON_METER_SETTINGS_4);
			topBtn_meter_setting.setPressedIcon(IMG_ICON_METER_SETTINGS_4);
			topBtn_meter_setting.setBounds(POS_TOP_BTN_METER_SETTINGS_X, POS_TOP_BTN_METER_SETTINGS_Y,
					POS_TOP_BTN_METER_SETTINGS_WIDTH, POS_TOP_BTN_METER_SETTINGS_HEIGHT);
		}
		topBtn_meter_setting.setBorderPainted(false);
		topBtn_meter_setting.setContentAreaFilled(false);
		topBtn_meter_setting.addActionListener(this);
		topBtn_meter_setting.setActionCommand("topBtn_meter_setting");
		
		// サーバ一括登録時は非表示にする
		if (!com.SgwMiniSetup.common.CommonParam.registAllServerHost) {
			panel.add(topBtn_meter_setting);
			
			// マウスイベント追加
			panel.addMouseListener(new MouseAdapter() {
				// クリックされた場合
				public void mouseClicked(MouseEvent me) {
					int conut = me.getClickCount();
					if (conut > 1) {
						// SGW情報再取得
						checkSmartGatewayInfo(false);
					} else {
						// SGW情報再取得
						checkSmartGatewayInfo(true);
					}
				}
			});
		}

		return panel;
	}

	/**
	 * 設定ガイド1画面のパネルに各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel 設定ガイド1画面のパネル
	 */
	public JPanel setJPanelGuide1(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_GUIDE_TITLE, FONT_COLOR_GUIDE);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_GUIDE_SUBTITLE, FONT_COLOR_GUIDE);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(TOP)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF, IMG_BTN_TOP_ON, "btn_top");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF_X3, IMG_BTN_TOP_ON_X3, "btn_top");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF_X2, IMG_BTN_TOP_ON_X2, "btn_top");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_GUIDE1);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE1_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE1_X2);
			}
		}
		panel.add(label_explanation);

		// 右側ボタン(次へ)
		JButton btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF, IMG_BTN_NEXT_ON, "btn_guide2");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X3, IMG_BTN_NEXT_ON_X3, "btn_guide2");
			} else {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X2, IMG_BTN_NEXT_ON_X2, "btn_guide2");
			}
		}
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_GUIDE);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		return panel;
	}

	/**
	 * 設定ガイド2画面のパネルに各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel 設定ガイド2画面のパネル
	 */
	public JPanel setJPanelGuide2(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_GUIDE_TITLE, FONT_COLOR_GUIDE);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_GUIDE_SUBTITLE, FONT_COLOR_GUIDE);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(前へ)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF, IMG_BTN_PREV_ON, "btn_guide1");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X3, IMG_BTN_PREV_ON_X3, "btn_guide1");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X2, IMG_BTN_PREV_ON_X2, "btn_guide1");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_GUIDE2);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE2_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE2_X2);
			}
		}
		panel.add(label_explanation);

		// 右側ボタン(次へ)
		JButton btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF, IMG_BTN_NEXT_ON, "btn_guide3");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X3, IMG_BTN_NEXT_ON_X3, "btn_guide3");
			} else {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X2, IMG_BTN_NEXT_ON_X2, "btn_guide3");
			}
		}
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_GUIDE);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		return panel;
	}

	/**
	 * 設定ガイド3画面のパネルに各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel 設定ガイド3画面のパネル
	 */
	public JPanel setJPanelGuide3(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_GUIDE_TITLE, FONT_COLOR_GUIDE);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_GUIDE_SUBTITLE, FONT_COLOR_GUIDE);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(前へ)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF, IMG_BTN_PREV_ON, "btn_guide2");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X3, IMG_BTN_PREV_ON_X3, "btn_guide2");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X2, IMG_BTN_PREV_ON_X2, "btn_guide2");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_GUIDE3);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE3_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE3_X2);
			}
		}
		
		panel.add(label_explanation);

		// 右側ボタン(次へ)
		JButton btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF, IMG_BTN_NEXT_ON, "btn_guide4");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X3, IMG_BTN_NEXT_ON_X3, "btn_guide4");
			} else {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X2, IMG_BTN_NEXT_ON_X2, "btn_guide4");
			}
		}
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_GUIDE);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		return panel;
	}

	/**
	 * 設定ガイド4画面のパネルに各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel 設定ガイド4画面のパネル
	 */
	public JPanel setJPanelGuide4(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_GUIDE_TITLE, FONT_COLOR_GUIDE);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_GUIDE_SUBTITLE, FONT_COLOR_GUIDE);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(前へ)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF, IMG_BTN_PREV_ON, "btn_guide3");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X3, IMG_BTN_PREV_ON_X3, "btn_guide3");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X2, IMG_BTN_PREV_ON_X2, "btn_guide3");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_GUIDE4);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE4_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE4_X2);
			}
		}
		panel.add(label_explanation);

		// 右側ボタン(次へ)
		//JButton btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF, IMG_BTN_NEXT_ON, "btn_guide5");
		JButton btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF, IMG_BTN_NEXT_ON, "btn_guide7"); // P5,6は不要
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X3, IMG_BTN_NEXT_ON_X3, "btn_guide7");
			} else {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X2, IMG_BTN_NEXT_ON_X2, "btn_guide7");
			}
		}
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_GUIDE);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		return panel;
	}

	/**
	 * 設定ガイド5画面のパネルに各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel 設定ガイド5画面のパネル
	 */
	public JPanel setJPanelGuide5(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_GUIDE_TITLE, FONT_COLOR_GUIDE);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_GUIDE_SUBTITLE, FONT_COLOR_GUIDE);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(前へ)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF, IMG_BTN_PREV_ON, "btn_guide4");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X3, IMG_BTN_PREV_ON_X3, "btn_guide4");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X2, IMG_BTN_PREV_ON_X2, "btn_guide4");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_GUIDE5);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE5_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE5_X2);
			}
		}
		panel.add(label_explanation);

		// 右側ボタン(次へ)
		JButton btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF, IMG_BTN_NEXT_ON, "btn_guide6");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X3, IMG_BTN_NEXT_ON_X3, "btn_guide6");
			} else {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X2, IMG_BTN_NEXT_ON_X2, "btn_guide6");
			}
		}
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_GUIDE);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		return panel;
	}

	/**
	 * 設定ガイド6画面のパネルに各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel 設定ガイド6画面のパネル
	 */
	public JPanel setJPanelGuide6(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_GUIDE_TITLE, FONT_COLOR_GUIDE);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_GUIDE_SUBTITLE, FONT_COLOR_GUIDE);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(前へ)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF, IMG_BTN_PREV_ON, "btn_guide5");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X3, IMG_BTN_PREV_ON_X3, "btn_guide5");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X2, IMG_BTN_PREV_ON_X2, "btn_guide5");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_GUIDE6);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE6_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE6_X2);
			}
		}
		panel.add(label_explanation);

		// 右側ボタン(ボタン無し)
		JLabel btn_right = setJLabelRightButton();
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_GUIDE);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		// ========================================================================================================
		// この画面独自のコンポーネント
		// ========================================================================================================
		// 点滅した回数10ボタン → 設定ガイド7画面へ(IP設定成功)
		ImageIcon icon_flash10 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_FLASH10_OFF));
		ImageIcon rollover_flash10 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_FLASH10_ON));
		JButton btn_flash10 = new JButton(icon_flash10);
		btn_flash10.setRolloverIcon(rollover_flash10);
		btn_flash10.setPressedIcon(rollover_flash10);
		btn_flash10.setBounds(POS_GUIDE6_BTN_FLASH10_X, POS_GUIDE6_BTN_FLASH10_Y,
				POS_GUIDE6_BTN_FLASH10_WIDTH, POS_GUIDE6_BTN_FLASH10_HEIGHT);
		btn_flash10.setBorderPainted(false);
		btn_flash10.setContentAreaFilled(false);
		btn_flash10.addActionListener(this);
		btn_flash10.setActionCommand("btn_flash10");
		label_explanation.add(btn_flash10);

		// 点滅した回数5ボタン → 設定ガイド8画面へ(IP設定失敗)
		ImageIcon icon_flash5 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_FLASH5_OFF));
		ImageIcon rollover_flash5 = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_FLASH5_ON));
		JButton btn_flash5 = new JButton(icon_flash5);
		btn_flash5.setRolloverIcon(rollover_flash5);
		btn_flash5.setPressedIcon(rollover_flash5);
		btn_flash5.setBounds(POS_GUIDE6_BTN_FLASH5_X, POS_GUIDE6_BTN_FLASH5_Y,
				POS_GUIDE6_BTN_FLASH5_WIDTH, POS_GUIDE6_BTN_FLASH5_HEIGHT);
		btn_flash5.setBorderPainted(false);
		btn_flash5.setContentAreaFilled(false);
		btn_flash5.addActionListener(this);
		btn_flash5.setActionCommand("btn_flash5");
		label_explanation.add(btn_flash5);

		return panel;
	}

	/**
	 * 設定ガイド7画面のパネル(IP設定成功)に各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel 設定ガイド7画面のパネル
	 */
	public JPanel setJPanelGuide7(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_GUIDE_TITLE, FONT_COLOR_GUIDE);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_GUIDE_SUBTITLE, FONT_COLOR_GUIDE);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(前へ)
		//JButton btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF, IMG_BTN_PREV_ON, "btn_guide6");
		JButton btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF, IMG_BTN_PREV_ON, "btn_guide4"); // ※p5,6は不要
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X3, IMG_BTN_PREV_ON_X3, "btn_guide4");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X2, IMG_BTN_PREV_ON_X2, "btn_guide4");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_GUIDE7);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE7_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE7_X2);
			}
		}
		panel.add(label_explanation);

		/* 設定ガイドの最終ページにTOPへ戻る釦追加(2015/11/16 hamai) */
		// 右側ボタン(ボタン無し)
		//		JLabel btn_right = setJLabelRightButton();
		//		panel.add(btn_right);

		// 右側ボタン(TOP)
		JButton btn_right = setJButtonRightButton(IMG_BTN_TOP_OFF, IMG_BTN_TOP_ON, "btn_top");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_right = setJButtonRightButton(IMG_BTN_TOP_OFF_X3, IMG_BTN_TOP_ON_X3, "btn_top");
			} else {
				btn_right = setJButtonRightButton(IMG_BTN_TOP_OFF_X2, IMG_BTN_TOP_ON_X2, "btn_top");
			}
		}
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_GUIDE);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		// ========================================================================================================
		// この画面独自のコンポーネント
		// ========================================================================================================
		// スマートゲートウェイの検索ボタン
		ImageIcon icon_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_OFF));
		ImageIcon rollover_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				icon_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_OFF_X3));
				rollover_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_ON_X3));
			} else {
				icon_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_OFF_X2));
				rollover_search = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_SEARCH_ON_X2));
			}
		}
		//JButton btn_search = new JButton(icon_search);
		JButton btn_search = new ScaledImageButton(icon_search);
		btn_search.setRolloverIcon(rollover_search);
		if (IS_HIGH_RESOLUTION) {
			btn_search.setBounds(calcDispSize(POS_GUIDE7_BTN_SEARCH_X), calcDispSize(POS_GUIDE7_BTN_SEARCH_Y),
					calcDispSize(POS_GUIDE7_BTN_SEARCH_WIDTH), calcDispSize(POS_GUIDE7_BTN_SEARCH_HEIGHT));
		} else {
			btn_search.setBounds(POS_GUIDE7_BTN_SEARCH_X, POS_GUIDE7_BTN_SEARCH_Y,
					POS_GUIDE7_BTN_SEARCH_WIDTH, POS_GUIDE7_BTN_SEARCH_HEIGHT);
		}
		btn_search.setBorderPainted(false);
		btn_search.setContentAreaFilled(false);
		btn_search.addActionListener(this);
		btn_search.setActionCommand("btn_search");
		label_explanation.add(btn_search);

		return panel;
	}

	/**
	 * 設定ガイド8画面のパネル(IP設定失敗)に各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel 設定ガイド8画面のパネル
	 */
	public JPanel setJPanelGuide8(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_GUIDE_TITLE, FONT_COLOR_GUIDE);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_GUIDE_SUBTITLE, FONT_COLOR_GUIDE);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(前へ)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF, IMG_BTN_PREV_ON, "btn_guide6");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X3, IMG_BTN_PREV_ON_X3, "btn_guide6");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X2, IMG_BTN_PREV_ON_X2, "btn_guide6");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_GUIDE8);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE8_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_GUIDE8_X2);
			}
		}
		panel.add(label_explanation);

		// 右側ボタン(ボタン無し)
		JLabel btn_right = setJLabelRightButton();
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_GUIDE);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		// ========================================================================================================
		// この画面独自のコンポーネント
		// ========================================================================================================
		// 完了ボタン
		ImageIcon icon_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_OFF));
		ImageIcon rollover_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_HIGH_RESOLUTION) {
				icon_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_OFF_X3));
				rollover_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_ON_X3));
			} else {
				icon_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_OFF_X2));
				rollover_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_ON_X2));
			}
		}
		//JButton btn_end = new JButton(icon_end);
		JButton btn_end = new ScaledImageButton(icon_end);
		btn_end.setRolloverIcon(rollover_end);
		btn_end.setPressedIcon(rollover_end);
		if (IS_HIGH_RESOLUTION) {
			btn_end.setBounds(calcDispSize(POS_GUIDE8_BTN_END_X), calcDispSize(POS_GUIDE8_BTN_END_Y),
					calcDispSize(POS_GUIDE8_BTN_END_WIDTH), calcDispSize(POS_GUIDE8_BTN_END_HEIGHT));
		} else {
			btn_end.setBounds(POS_GUIDE8_BTN_END_X, POS_GUIDE8_BTN_END_Y,
					POS_GUIDE8_BTN_END_WIDTH, POS_GUIDE8_BTN_END_HEIGHT);
		}
		btn_end.setBorderPainted(false);
		btn_end.setContentAreaFilled(false);
		btn_end.addActionListener(this);
		btn_end.setActionCommand("btn_guide1");
		label_explanation.add(btn_end);

		return panel;
	}

	/**
	 * スマートゲートウェイの検索1画面のパネルに各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel スマートゲートウェイの検索1画面のパネル
	 */
	public JPanel setJPanelSearch1(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_SEARCH_TITLE, FONT_COLOR_SEARCH);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_SEARCH_SUBTITLE, FONT_COLOR_SEARCH);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(TOP)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF, IMG_BTN_TOP_ON, "btn_top");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF_X3, IMG_BTN_TOP_ON_X3, "btn_top");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF_X2, IMG_BTN_TOP_ON_X2, "btn_top");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_SEARCH1);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_SEARCH1_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_SEARCH1_X2);
			}
		}
		panel.add(label_explanation);

		// 右側ボタン(ボタン無し)
		JLabel btn_right = setJLabelRightButton();
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_SEARCH);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		// ========================================================================================================
		// この画面独自のコンポーネント
		// ========================================================================================================
		// 検索開始ボタン
		ImageIcon icon_kensaku = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KENSAKU_OFF));
		ImageIcon rollover_kensaku = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KENSAKU_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_HIGH_RESOLUTION) {
				icon_kensaku = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KENSAKU_OFF_X3));
				rollover_kensaku = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KENSAKU_ON_X3));
			} else {
				icon_kensaku = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KENSAKU_OFF_X2));
				rollover_kensaku = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KENSAKU_ON_X2));
			}
		}
		//JButton btn_kensaku = new JButton(icon_kensaku);
		JButton btn_kensaku = new ScaledImageButton(icon_kensaku);
		btn_kensaku.setRolloverIcon(rollover_kensaku);
		btn_kensaku.setPressedIcon(rollover_kensaku);
		if (IS_HIGH_RESOLUTION) {
			btn_kensaku.setBounds(calcDispSize(POS_SEARCH1_BTN_KENSAKU_X), calcDispSize(POS_SEARCH1_BTN_KENSAKU_Y),
					calcDispSize(POS_SEARCH1_BTN_KENSAKU_WIDTH), calcDispSize(POS_SEARCH1_BTN_KENSAKU_HEIGHT));
		} else {
			btn_kensaku.setBounds(POS_SEARCH1_BTN_KENSAKU_X, POS_SEARCH1_BTN_KENSAKU_Y,
					POS_SEARCH1_BTN_KENSAKU_WIDTH, POS_SEARCH1_BTN_KENSAKU_HEIGHT);
		}
		btn_kensaku.setBorderPainted(false);
		btn_kensaku.setContentAreaFilled(false);
		btn_kensaku.addActionListener(this);
		btn_kensaku.setActionCommand("btn_kensaku");
		label_explanation.add(btn_kensaku);

		return panel;
	}

	/**
	 * スマートゲートウェイの検索2画面のパネルに各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel スマートゲートウェイの検索2画面のパネル
	 */
	public JPanel setJPanelSearch2(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_SEARCH_TITLE, FONT_COLOR_SEARCH);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_SEARCH_SUBTITLE, FONT_COLOR_SEARCH);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(前へ)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF, IMG_BTN_PREV_ON, "btn_search1");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X3, IMG_BTN_PREV_ON_X3, "btn_search1");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X2, IMG_BTN_PREV_ON_X2, "btn_search1");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_SEARCH2);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_SEARCH2_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_SEARCH2_X2);
			}
		}
		panel.add(label_explanation);

		// 右側ボタン(ボタン無し)
		JLabel btn_right = setJLabelRightButton();
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_SEARCH);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		// ========================================================================================================
		// この画面独自のコンポーネント
		// ========================================================================================================
		// 完了ボタン
		ImageIcon icon_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_OFF));
		ImageIcon rollover_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_HIGH_RESOLUTION) {
				icon_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_OFF_X3));
				rollover_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_ON_X3));
			} else {
				icon_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_OFF_X2));
				rollover_end = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_END_ON_X2));
			}
		}
		//JButton btn_end = new JButton(icon_end);
		JButton btn_end = new ScaledImageButton(icon_end);
		btn_end.setRolloverIcon(rollover_end);
		btn_end.setPressedIcon(rollover_end);
		if (IS_HIGH_RESOLUTION) {
			btn_end.setBounds(calcDispSize(POS_SEARCH2_BTN_END_X), calcDispSize(POS_SEARCH2_BTN_END_Y),
					calcDispSize(POS_SEARCH2_BTN_END_WIDTH), calcDispSize(POS_SEARCH2_BTN_END_HEIGHT));
		} else {
			btn_end.setBounds(POS_SEARCH2_BTN_END_X, POS_SEARCH2_BTN_END_Y,
					POS_SEARCH2_BTN_END_WIDTH, POS_SEARCH2_BTN_END_HEIGHT);
		}
		btn_end.setBorderPainted(false);
		btn_end.setContentAreaFilled(false);
		btn_end.addActionListener(this);
		btn_end.setActionCommand("btn_top"); // トップ画面へ移動
		label_explanation.add(btn_end);

		// 利用登録ボタン
		ImageIcon icon_kaiin = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KAIIN_OFF));
		ImageIcon rollover_kaiin = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KAIIN_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_HIGH_RESOLUTION) {
				icon_kaiin = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KAIIN_OFF_X3));
				rollover_kaiin = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KAIIN_ON_X3));
			} else {
				icon_kaiin = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KAIIN_OFF_X2));
				rollover_kaiin = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_KAIIN_ON_X2));
			}
		}
		//JButton btn_kaiin = new JButton(icon_kaiin);
		JButton btn_kaiin = new ScaledImageButton(icon_kaiin);
		btn_kaiin.setRolloverIcon(rollover_kaiin);
		btn_kaiin.setPressedIcon(rollover_kaiin);
		if (IS_HIGH_RESOLUTION) {
			btn_kaiin.setBounds(calcDispSize(POS_SEARCH2_BTN_KAIIN_X), calcDispSize(POS_SEARCH2_BTN_KAIIN_Y),
					calcDispSize(POS_SEARCH2_BTN_KAIIN_WIDTH), calcDispSize(POS_SEARCH2_BTN_KAIIN_HEIGHT));
		} else {
			btn_kaiin.setBounds(POS_SEARCH2_BTN_KAIIN_X, POS_SEARCH2_BTN_KAIIN_Y,
					POS_SEARCH2_BTN_KAIIN_WIDTH, POS_SEARCH2_BTN_KAIIN_HEIGHT);
		}
		btn_kaiin.setBorderPainted(false);
		btn_kaiin.setContentAreaFilled(false);
		btn_kaiin.addActionListener(this);
		//【@Ver.2.04】： イベントリスナーを追加　
		//  （※利用登録画面に遷移する際に、TOP画面を更新し、SGW情報を再取得）
		btn_kaiin.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				// 表示を更新する(状態を更新する)
				updateDisplay(false);
			}
		});
		btn_kaiin.setActionCommand("btn_regist1");
		label_explanation.add(btn_kaiin);

		return panel;
	}

	/**
	 * 利用登録1画面のパネルに各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel 利用登録1画面のパネル
	 */
	public JPanel setJPanelRegist1(int now_page_no, int max_page_no) {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// この画面独自のコンポーネント
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_REGIST_TITLE, FONT_COLOR_REGIST);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_REGIST_SUBTITLE, FONT_COLOR_REGIST);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(TOP)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF, IMG_BTN_TOP_ON, "btn_top");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF_X3, IMG_BTN_TOP_ON_X3, "btn_top");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF_X2, IMG_BTN_TOP_ON_X2, "btn_top");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_REGIST1);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_REGIST1_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_REGIST1_X2);
			}
		}
		panel.add(label_explanation);

		// 右側ボタン(次へ)
		JButton btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF, IMG_BTN_NEXT_ON, "btn_regist2");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X3, IMG_BTN_NEXT_ON_X3, "btn_regist2");
			} else {
				btn_right = setJButtonRightButton(IMG_BTN_NEXT_OFF_X2, IMG_BTN_NEXT_ON_X2, "btn_regist2");
			}
		}
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_REGIST);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		return panel;
	}

	/**
	 * 利用登録2画面のパネルに各コンポーネントをセットして返す
	 *
	 * @param  int now_page_no 現在のページ番号
	 * @param  int max_page_no 同系統のページの最大数
	 * @return JPanel panel 利用登録2画面のパネル
	 * @throws URISyntaxException
	 */
	public JPanel setJPanelRegist2(int now_page_no, int max_page_no) throws URISyntaxException {
		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_REGIST_TITLE, FONT_COLOR_REGIST);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_REGIST_SUBTITLE, FONT_COLOR_REGIST);
		panel.add(label_subtitle);

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(前へ)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF, IMG_BTN_PREV_ON, "btn_regist1");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X3, IMG_BTN_PREV_ON_X3, "btn_regist1");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_PREV_OFF_X2, IMG_BTN_PREV_ON_X2, "btn_regist1");
			}
		}
		panel.add(btn_left);

		// 説明文の背景画像
		JLabel label_explanation = setJLabelExplanation(IMG_MSG_REGIST2);
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				label_explanation = setJLabelExplanation(IMG_MSG_REGIST2_X3);
			} else {
				label_explanation = setJLabelExplanation(IMG_MSG_REGIST2_X2);
			}
		}
		panel.add(label_explanation);

		/* 利用登録の最終ページにTOPへ戻る釦追加(2015/11/16 hamai) */
		// 右側ボタン(ボタン無し)
		//		JLabel btn_right = setJLabelRightButton();
		//		panel.add(btn_right);

		// 右側ボタン(TOP)
		JButton btn_right = setJButtonRightButton(IMG_BTN_TOP_OFF, IMG_BTN_TOP_ON, "btn_top");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_right = setJButtonRightButton(IMG_BTN_TOP_OFF_X3, IMG_BTN_TOP_ON_X3, "btn_top");
			} else {
				btn_right = setJButtonRightButton(IMG_BTN_TOP_OFF_X2, IMG_BTN_TOP_ON_X2, "btn_top");
			}
		}
		panel.add(btn_right);

		// ページ番号
		JLabel label_page_no = setJabelPageNo(now_page_no, max_page_no, FONT_COLOR_REGIST);
		panel.add(label_page_no);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		// フッター(アプリVer)
		JLabel label_footer_version = setJabelFooterVersion();
		panel.add(label_footer_version);

		// フッター(コピーライト)
		JLabel label_footer_copyright = setJabelFooterCopyright();
		panel.add(label_footer_copyright);

		// ========================================================================================================
		// この画面独自のコンポーネント
		// ========================================================================================================
		// 利用規約文をファイルから読み込む
		StringBuilder buf = new StringBuilder();
		BufferedReader br = null;

		try {
			// 改行コード取得
			String crlf = System.getProperty("line.separator");

			// ファイル読み込み
			URL fileUrl = this.getClass().getClassLoader().getResource(FILE_POLICY_PATH);
			InputStream strm = fileUrl.openStream();
			InputStreamReader in = new InputStreamReader(strm, "UTF-8");
			BufferedReader inb = new BufferedReader(in);
			String line;

			// ファイル内容を1行ずつ取得し、改行コードを加えてバッファ出力
			while ((line = inb.readLine()) != null) {
				buf.append(line + crlf);
			}
			inb.close();
			in.close();

		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null) {
					br.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		// バッファの内容を取得
		String policy_msg = buf.toString();

		// 利用規約文のテキストエリア
		JTextArea agree_msg = new JTextArea(policy_msg);
		agree_msg.setLineWrap(true); // 折り返し
		agree_msg.setEditable(false); // 編集不可(readonly)
		agree_msg.setMargin(new Insets(POS_REGIST2_TEXAAREA_PADDING_TOP, POS_REGIST2_TEXAAREA_PADDING_LEFT,
				POS_REGIST2_TEXAAREA_PADDING_BOTTOM, POS_REGIST2_TEXAAREA_PADDING_RIGHT)); // 余白(padding)
		JScrollPane agree_scrollpane = new JScrollPane(agree_msg,
				JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER); // スクロールペイン
		if (IS_HIGH_RESOLUTION) {
			agree_scrollpane.setBounds(calcDispSize(POS_REGIST2_SCROLLPANE_X), calcDispSize(POS_REGIST2_SCROLLPANE_Y),
					calcDispSize(POS_REGIST2_SCROLLPANE_WIDTH), calcDispSize(POS_REGIST2_SCROLLPANE_HEIGHT));
		} else {
			agree_scrollpane.setBounds(POS_REGIST2_SCROLLPANE_X, POS_REGIST2_SCROLLPANE_Y,
					POS_REGIST2_SCROLLPANE_WIDTH, POS_REGIST2_SCROLLPANE_HEIGHT);
		}
		label_explanation.add(agree_scrollpane);

		// 利用登録ボタン
		ImageIcon icon_agree = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_AGREE_OFF));
		ImageIcon rollover_agree = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_AGREE_ON));
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				icon_agree = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_AGREE_OFF_X3));
				rollover_agree = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_AGREE_ON_X3));
			} else {
				icon_agree = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_AGREE_OFF_X2));
				rollover_agree = new ImageIcon(this.getClass().getClassLoader().getResource(IMG_BTN_AGREE_ON_X2));
			}
			
		}
		//JButton btn_agree = new JButton(icon_agree);
		JButton btn_agree = new ScaledImageButton(icon_agree);
		btn_agree.setRolloverIcon(rollover_agree);
		btn_agree.setPressedIcon(rollover_agree);
		if (IS_HIGH_RESOLUTION) {
			btn_agree.setBounds(calcDispSize(POS_REGIST2_BTN_AGREE_X), calcDispSize(POS_REGIST2_BTN_AGREE_Y),
					calcDispSize(POS_REGIST2_BTN_AGREE_WIDTH), calcDispSize(POS_REGIST2_BTN_AGREE_HEIGHT));
		} else {
			btn_agree.setBounds(POS_REGIST2_BTN_AGREE_X, POS_REGIST2_BTN_AGREE_Y,
					POS_REGIST2_BTN_AGREE_WIDTH, POS_REGIST2_BTN_AGREE_HEIGHT);
		}
		btn_agree.setBorderPainted(false);
		btn_agree.setContentAreaFilled(false);
		btn_agree.addActionListener(this);
		btn_agree.setActionCommand("btn_agree");
		label_explanation.add(btn_agree);

		return panel;
	}

	/**
	 * 詳細画面のパネルに各コンポーネントをセットして返す
	 *
	 * @return JPanel panel 詳細画面のパネル
	 */
	public JPanel setJPanelDetail() throws URISyntaxException {

		// ========================================================================================================
		// パネル初期化
		// ========================================================================================================
		// パネル作成。レイアウトは指定しないため、絶対位置で指定する事
		JPanel panel = new JPanel();
		panel.setLayout(null);

		// ========================================================================================================
		// 各画面共通のコンポーネント作成
		// ========================================================================================================
		// タイトル
		JLabel label_title = setJLabelTitle(MSG_DETAIL_TITLE, FONT_COLOR_GUIDE);
		panel.add(label_title);

		// サブタイトル
		JLabel label_subtitle = setJLabelSubTitle(MSG_DETAIL_SUBTITLE, FONT_COLOR_GUIDE);
		panel.add(label_subtitle);
		subtitle_detail_settings = label_subtitle;

		// 区切り線(上部)
		JSeparator separator_top = setSepalatorTop();
		panel.add(separator_top);

		// 左側ボタン(TOP)
		JButton btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF, IMG_BTN_TOP_ON, "btn_top");
		if (IS_HIGH_RESOLUTION) {
			if (IS_4K_RESOLUTION) {
				btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF_X3, IMG_BTN_TOP_ON_X3, "btn_top");
			} else {
				btn_left = setJButtonLeftButton(IMG_BTN_TOP_OFF_X2, IMG_BTN_TOP_ON_X2, "btn_top");
			}
		}
		panel.add(btn_left);

		// 右側ボタン(ボタン無し)
		JLabel btn_right = setJLabelRightButton();
		panel.add(btn_right);

		// 区切り線(下部)
		JSeparator separator_bottom = setSepalatorBottom();
		panel.add(separator_bottom);

		/* 「現在の状況」ボタン */
		JButton btn_current_status = createSettingButton("現在の状況", "btn_current_status", POS_DETAIL_BTN_LINK_X, 81);
		panel.add(btn_current_status);

		/* 「計器設定」ボタン */
		JButton btn_meter_setting = createSettingButton("計器設定", "btn_meter_setting", POS_DETAIL_BTN_LINK_X2, 81);
		panel.add(btn_meter_setting);

		/* 「時刻設定」ボタン */
		JButton btn_time_setting = createSettingButton("時刻設定", "btn_time_setting", POS_DETAIL_BTN_LINK_X, 140);
		panel.add(btn_time_setting);

		/* 「家電操作機器一覧」ボタン */
		JButton btn_device_control = createSettingButton("家電操作機器一覧", "btn_device_control", POS_DETAIL_BTN_LINK_X2, 140);
		panel.add(btn_device_control);

		/* 「通信設定」ボタン */
		JButton btn_communicate_setting = createSettingButton("通信設定", "btn_communicate_setting", POS_DETAIL_BTN_LINK_X, 198);
		panel.add(btn_communicate_setting);

		/* 「利用登録」ボタン　*/
		JButton btn_member_entry = createSettingButton("利用登録", "btn_member_entry", POS_DETAIL_BTN_LINK_X2, 198);
		panel.add(btn_member_entry);

		/* 「宅外操作設定」ボタン (root/root) */
		JButton btn_remote_setting = createSettingButton("宅外家電操作設定", "btn_remote_setting", POS_DETAIL_BTN_LINK_X, 256);
		panel.add(btn_remote_setting);

		/* 「サーバ設定」ボタン (admin/smart) */
		JButton btn_server_setting = createSettingButton("サーバ設定", "btn_server_setting", POS_DETAIL_BTN_LINK_X2, 256);
		panel.add(btn_server_setting);

		/* 「スマートメーターの状況」ボタン */
		JButton btn_smart_meter_status = createSettingButton("スマートメーターの状況", "btn_smart_meter_status", POS_DETAIL_BTN_LINK_X, 314);
		panel.add(btn_smart_meter_status);

		/* 「スマートメーター認証設定」ボタン */
		JButton btn_smart_meter_setting = createSettingButton("計器認証設定", "btn_smart_meter_setting", POS_DETAIL_BTN_LINK_X2, 314);
		panel.add(btn_smart_meter_setting);

		/* 「電界強度表示」ボタン */
		JButton btn_radio_field_strength_setting = createSettingButton("電界強度表示", "btn_radio_field_strength_setting", POS_DETAIL_BTN_LINK_X, 372);
		panel.add(btn_radio_field_strength_setting);

		// サーバ設定の操作ボタンは非表示にする
		//btn_server_setting.setVisible(false);

		// スマートメーター関連の操作ボタンは一旦、非表示にする
		btn_smart_meter_status.setVisible(false);
		btn_smart_meter_setting.setVisible(false);
		btn_radio_field_strength_setting.setVisible(false);

		/* 「スマートエコリンク計器設定」ボタン */
		JButton btn_smart_echolink_meter_setting = createSettingButton("スマートエコリンク計器設定", "btn_smart_echolink_meter_setting", POS_DETAIL_BTN_LINK_X2, 372);
		panel.add(btn_smart_echolink_meter_setting);

		/* 「Webコンテンツ設定」ボタン */
		JButton btn_web_contents_setting = createSettingButton("Webコンテンツ設定", "btn_web_contents_setting", POS_DETAIL_BTN_LINK_X, 430);
		panel.add(btn_web_contents_setting);
		
		/* 「システムログイン」ボタン */
		JButton btn_system_login = createSettingButton("システムログイン", "btn_system_login", POS_DETAIL_BTN_LINK_X2, 430);
		panel.add(btn_system_login);

		/* 「Webブラウザを起動して表示」チェックボックス */
		if (IS_HIGH_RESOLUTION) {
			chk_launch_browser.setBounds(calcDispSize(POS_LAUNCH_BROWSER_CHK_X), calcDispSize(POS_LAUNCH_BROWSER_CHK_Y),
					calcDispSize(POS_LAUNCH_BROWSER_CHK_WIDTH), calcDispSize(POS_LAUNCH_BROWSER_CHK_HEIGHT));
		} else {
			chk_launch_browser.setBounds(POS_LAUNCH_BROWSER_CHK_X, POS_LAUNCH_BROWSER_CHK_Y,
					POS_LAUNCH_BROWSER_CHK_WIDTH, POS_LAUNCH_BROWSER_CHK_HEIGHT);
		}
		chk_launch_browser.addActionListener(this);
		chk_launch_browser.setActionCommand("chk_launch_browser");
		chk_launch_browser.setHorizontalAlignment(JLabel.RIGHT);
		panel.add(chk_launch_browser);
		
		return panel;
	}

	private void updateDetailPanel() {
		/* 「スマートメーターの状況」ボタン（※SGW Plusのみボタン表示） */
		JButton btn_smart_meter_status = findButtonByCommandName(panel_detail, "btn_smart_meter_status");
		if (btn_smart_meter_status != null && IS_SGW_PLUS) {
			btn_smart_meter_status.setVisible(true);
		} else {
			btn_smart_meter_status.setVisible(false);
		}
		/* 「スマートメーター認証設定」ボタン（※SGW Plusのみボタン表示） */
		JButton btn_smart_meter_setting = findButtonByCommandName(panel_detail, "btn_smart_meter_setting");
		if (btn_smart_meter_setting != null && IS_SGW_PLUS) {
			btn_smart_meter_setting.setVisible(true);
		} else {
			btn_smart_meter_setting.setVisible(false);
		}
		/* 「電界強度表示」ボタン（※SGW Plusのみボタン表示） */
		JButton btn_radio_field_strength_setting = findButtonByCommandName(panel_detail, "btn_radio_field_strength_setting");
		if (btn_radio_field_strength_setting != null && IS_SGW_PLUS) {
			btn_radio_field_strength_setting.setVisible(true);
		} else {
			btn_radio_field_strength_setting.setVisible(false);
		}

		//【＠Ver.2.17】-->
		/* 「スマートエコリンク計器設定」ボタン */
		JButton btn_smart_echolink_meter_setting = findButtonByCommandName(panel_detail, "btn_smart_echolink_meter_setting");
		if (btn_smart_echolink_meter_setting != null && (IS_SGW_PLUS_V2 || IS_SGW_PLUS_V3 || IS_SGW_PLUS_V4)) {
			btn_smart_echolink_meter_setting.setVisible(true);
		} else {
			btn_smart_echolink_meter_setting.setVisible(false);
		}
		/* 「Webコンテンツ設定」ボタン */
		JButton btn_web_contents_setting = findButtonByCommandName(panel_detail, "btn_web_contents_setting");
		if (btn_web_contents_setting != null && (IS_SGW_PLUS_V2 || IS_SGW_PLUS_V3 || IS_SGW_PLUS_V4)) {
			btn_web_contents_setting.setVisible(true);
		} else {
			btn_web_contents_setting.setVisible(false);
		}
		//<--【＠Ver.2.17】
		
		/* 「システムログイン」ボタン */
		JButton btn_system_login = findButtonByCommandName(panel_detail, "btn_system_login");
		//if (btn_system_login != null && IS_SGW_PLUS_V4) {
		if (btn_system_login != null && (IS_SGW_PLUS_V2 || IS_SGW_PLUS_V4)) {
			btn_system_login.setVisible(true);
		} else {
			btn_system_login.setVisible(false);
		}

		/* 「Webブラウザを起動して表示」を有効にする */
		JCheckBox chk_launch_browser = findCheckBoxByCommandName(panel_detail, "chk_launch_browser");
		if (chk_launch_browser != null) {
			if (!isSupportedJavaVersion) {
				chk_launch_browser.setSelected(true);
				chk_launch_browser.setEnabled(true);
			} else {
				if (CommonParam.useExternalBrowser) {
					chk_launch_browser.setSelected(true);
				} else {
					chk_launch_browser.setSelected(false);
				}
				chk_launch_browser.setEnabled(true);
			}
		}
		
		/* 「現在の状況」ボタン */
		JButton btn_current_status = findButtonByCommandName(panel_detail, "btn_current_status");
		if (btn_current_status != null) {
			btn_current_status.setVisible(true);
		}

		/* 「計器設定」ボタン */
		JButton btn_meter_setting = findButtonByCommandName(panel_detail, "btn_meter_setting");
		if (btn_meter_setting != null) {
			btn_meter_setting.setVisible(true);
		}

		/* 「時刻設定」ボタン */
		JButton btn_time_setting = findButtonByCommandName(panel_detail, "btn_time_setting");
		/* 「家電操作機器一覧」ボタン */
		JButton btn_device_control = findButtonByCommandName(panel_detail, "btn_device_control");
		/* 「通信設定」ボタン */
		JButton btn_communicate_setting = findButtonByCommandName(panel_detail, "btn_communicate_setting");
		/* 「利用登録」ボタン　*/
		JButton btn_member_entry = findButtonByCommandName(panel_detail, "btn_member_entry");
		/* 「宅外操作設定」ボタン (root/root) */
		JButton btn_remote_setting = findButtonByCommandName(panel_detail, "btn_remote_setting");
		/* 「サーバ設定」ボタン (admin/smart) */
		JButton btn_server_setting = findButtonByCommandName(panel_detail, "btn_server_setting");
		
		if (IS_SGW_PLUS_MC) {
			if (subtitle_detail_settings != null) {
				subtitle_detail_settings.setText(MSG_DETAIL_MEDIACONV_TITLE);
			}
			
			/* 「現在の状況」ボタン */
			if (btn_current_status != null) {
				btn_current_status.setVisible(true);
				btn_current_status.setText("情報表示");
			}
			/* 「計器設定」ボタン */
			if (btn_meter_setting != null) {
				btn_meter_setting.setVisible(true);
				btn_meter_setting.setText("本体設定");
			}
			/* 「時刻設定」ボタン */
			if (btn_time_setting != null) {
				btn_time_setting.setVisible(false);
				//btn_time_setting.setText("AIF認証");
			}
			/* 「家電操作機器一覧」ボタン */
			if (btn_device_control != null) {
				btn_device_control.setVisible(false);
			}
			/* 「通信設定」ボタン */
			if (btn_communicate_setting != null) {
				btn_communicate_setting.setVisible(false);
			}
			/* 「利用登録」ボタン　*/
			if (btn_member_entry != null) {
				btn_member_entry.setVisible(false);
			}
			/* 「宅外操作設定」ボタン (root/root) */
			if (btn_remote_setting != null) {
				btn_remote_setting.setVisible(false);
			}
			/* 「サーバ設定」ボタン (admin/smart) */
			if (btn_server_setting != null) {
				btn_server_setting.setVisible(false);
			}
			/* 「スマートメーターの状況」ボタン（※SGW Plusのみボタン表示） */
			if (btn_smart_meter_status != null) {
				btn_smart_meter_status.setVisible(false);
			}
			/* 「スマートメーター認証設定」ボタン（※SGW Plusのみボタン表示） */
			if (btn_smart_meter_setting != null) {
				btn_smart_meter_setting.setVisible(false);
			}
			/* 「電界強度表示」ボタン（※SGW Plusのみボタン表示） */
			if (btn_radio_field_strength_setting != null) {
				btn_radio_field_strength_setting.setVisible(false);
			}

			/* 「スマートエコリンク計器設定」ボタン */
			if (btn_smart_echolink_meter_setting != null) {
				btn_smart_echolink_meter_setting.setVisible(false);
			}
			/* 「Webコンテンツ設定」ボタン */
			if (btn_web_contents_setting != null) {
				btn_web_contents_setting.setVisible(false);
			}
			/* 「システムログイン」ボタン */
			if (btn_system_login != null) {
				btn_system_login.setVisible(false);
			}
			/* 「Webブラウザを起動して表示」を有効にする */
			if (chk_launch_browser != null) {
				//chk_launch_browser.setEnabled(false);	// 無効にはしない
				chk_launch_browser.setSelected(true);
			}
		} else {
			if (subtitle_detail_settings != null) {
				subtitle_detail_settings.setText(MSG_DETAIL_SUBTITLE);
			}
			
			/* 「現在の状況」ボタン */
			if (btn_current_status != null) {
				btn_current_status.setVisible(true);
				btn_current_status.setText("現在の状況");
			}
			/* 「計器設定」ボタン */
			if (btn_meter_setting != null) {
				btn_meter_setting.setVisible(true);
				btn_meter_setting.setText("計器設定");
			}
			/* 「時刻設定」ボタン */
			if (btn_time_setting != null) {
				btn_time_setting.setVisible(true);
				btn_time_setting.setText("時刻設定");
			}
			/* 「家電操作機器一覧」ボタン */
			if (btn_device_control != null) {
				btn_device_control.setVisible(true);
			}
			/* 「通信設定」ボタン */
			if (btn_communicate_setting != null) {
				btn_communicate_setting.setVisible(true);
			}
			/* 「利用登録」ボタン　*/
			if (btn_member_entry != null) {
				btn_member_entry.setVisible(true);
			}
			/* 「宅外操作設定」ボタン (root/root) */
			if (btn_remote_setting != null) {
				btn_remote_setting.setVisible(true);
			}
			/* 「サーバ設定」ボタン (admin/smart) */
			if (btn_server_setting != null) {
				btn_server_setting.setVisible(true);
			}
			chk_launch_browser.setEnabled(true);
			chk_launch_browser.setSelected(false);
		}
		
		System.out.println("[JVM]: java.vm.name = [" + System.getProperty("java.vm.name") + "]");
		// Oracle Java以外だと 「Webブラウザを起動」をチェックする
		if(CommonFunc.checkOpenJava()) {
			chk_launch_browser.setSelected(true);
			//chk_launch_browser.setEnabled(false);
		}
	}

	private JButton findButtonByCommandName(JPanel panel, String name) {
		for (Component comp : panel.getComponents()) {
			if (comp != null && comp instanceof JButton) {
				String cmd = ((JButton) comp).getActionCommand();
				if (cmd != null && cmd.equals(name)) {
					return (JButton) comp;
				}
			}
		}
		return null;
	}

	private JCheckBox findCheckBoxByCommandName(JPanel panel, String name) {
		for (Component comp : panel.getComponents()) {
			if (comp != null && comp instanceof JCheckBox) {
				String cmd = ((JCheckBox) comp).getActionCommand();
				if (cmd != null && cmd.equals(name)) {
					return (JCheckBox) comp;
				}
			}
		}
		return null;
	}

	// 設定ボタンを新規作成
	private JButton createSettingButton(String titleLabel, String commandName, int x, int y) {
		JButton newButton = new JButton(titleLabel);
		BevelBorder border = new BevelBorder(BevelBorder.RAISED, Color.WHITE, Color.GRAY); //射影ボーダーでコンポーネント全体が立体的に浮いて見せる
		if (IS_HIGH_RESOLUTION) {
			newButton.setBounds(calcDispSize(x), calcDispSize(y), calcDispSize(POS_DETAIL_BTN_LINK_WIDTH), calcDispSize(POS_TOP_BTN_CLOSE_HEIGHT));
		} else {
			newButton.setBounds(x, y, POS_DETAIL_BTN_LINK_WIDTH, POS_TOP_BTN_CLOSE_HEIGHT);
		}
		newButton.setBorder(border);
		if (IS_HIGH_RESOLUTION) {
			newButton.setFont(new Font(FONT_STYLE_BTN, FONT_WEIGHT_BTN, calcDispSize(FONT_SIZE_BTN)));
		} else {
			newButton.setFont(new Font(FONT_STYLE_BTN, FONT_WEIGHT_BTN, FONT_SIZE_BTN));
		}
		newButton.setForeground(FONT_COLOR_BTN);
		newButton.setBorderPainted(true);
		newButton.setContentAreaFilled(false);
		newButton.setActionCommand(commandName);
		newButton.addActionListener(this);
		return newButton;
	}

	/**
	 * アクションのイベント設定
	 *
	 * @param ActionEvent e イベント情報
	 */
	public void actionPerformed(ActionEvent ae) {

		// ダイアログが表示されていれば、非表示にする（※ボタンアクションは）
		if (webContentsDialog != null
				&& webContentsDialog.isVisible()) {
			showWebContentsDialog(false); // 非表示にする
			return;
		}

		// コマンド名を取得
		String cmd = ae.getActionCommand();
		System.out.println("[cmd]: ActionCommand = [" + cmd + "]");

		// ==========================================================================
		// TOP画面関係
		// ==========================================================================
		if (cmd.equals("btn_top")) {
			// TOPボタンをクリックされた時、TOP画面へ戻る(他画面から)
			layout.show(panelBase, "panel_top");

			/*ファイルからSGW情報を読み込む*/
			//readSavedSgwIp();
			updateDisplay(false);
			//label_footer_sgw_info.setText(SMART_GATEWAY_INFO_LBL + smartGatewayInfo); //【＠Ver.2.04】；コメントアウト

		} else if (cmd.equals("btn_close")) {
			// 終了ボタンをクリックされた時、フレームを閉じる。
			// exit関数で終了しないと、多重起動防止のファイルを解放せず、再起動不可になるので注意。
			// 右上の×ボタンやタスクから終了した場合もファイルを解放してくれる。
			updateSgwInfo();
			setVisible(false);
			System.exit(0);

		} else if (cmd.equals("btn_guide")) {
			// 設定ガイドボタンをクリックされた時、設定ガイド画面へ遷移
			layout.show(panelBase, "panel_guide1");

		} else if (cmd.equals("btn_search")) {
			// スマートゲートウェイの検索ボタンをクリックされた時、スマートゲートウェイの検索画面へ遷移
			layout.show(panelBase, "panel_search1");

		} else if (cmd.equals("btn_regist")) {
			if (!IS_SGW_PLUS_MC) {
				// 画面更新
				updateDisplay(false);
	
				if (smartGatewayInfo.equals(MSG_NO_IP_ADDRESS)) {
					// 確認メッセージ表示
					JOptionPane.showMessageDialog(this, MES_WARNING_NO_IPADDRESS_OF_SGW, TITLE_CONFIRM, JOptionPane.INFORMATION_MESSAGE);
				} else if (isSGWInfoChecked == false) {
					// 警告メッセージ表示
					int res = JOptionPane.showConfirmDialog(this,
							MES_ERROR_NO_CONNECTION_TO_SGW,
							TITLE_WARNING_NO_IPADDRESS_OF_SGW,
							JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
					if (res == JOptionPane.YES_OPTION) {
						// 「はい」が選択すると、利用登録画面へ遷移
						layout.show(panelBase, "panel_regist1");
					}
				} else {
					// 利用登録ボタンをクリックされた時、利用登録画面へ遷移
					layout.show(panelBase, "panel_regist1");
				}
			} else {
				// 確認メッセージ表示
				JOptionPane.showMessageDialog(this, MES_WARNING_MEDIACONV_MODE, TITLE_WARNING_MEDIACONV_MODE, JOptionPane.INFORMATION_MESSAGE);
			}
		} else if (cmd.equals("btn_regist_server")) {
			// サーバ一括登録ダイアログを表示
			try {
				ServerHostSettingDialog dialog = new ServerHostSettingDialog(this);
				dialog.setVisible(true);
			} catch (Exception e) {
				e.printStackTrace();
			}

			// ==========================================================================
			// ガイド設定画面関係
			// ==========================================================================
		} else if (cmd.equals("btn_guide1")) {
			// 設定ガイド1画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_guide1");

		} else if (cmd.equals("btn_guide2")) {
			// 設定ガイド2画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_guide2");

		} else if (cmd.equals("btn_guide3")) {
			// 設定ガイド3画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_guide3");

		} else if (cmd.equals("btn_guide4")) {
			// 設定ガイド4画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_guide4");

		} else if (cmd.equals("btn_guide5")) {
			// 設定ガイド5画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_guide5");

		} else if (cmd.equals("btn_guide6")) {
			// 設定ガイド6画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_guide6");

		} else if (cmd.equals("btn_guide7")) {
			// 設定ガイド7画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_guide7");

		} else if (cmd.equals("btn_guide8")) {
			// 設定ガイド8画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_guide8");

		} else if (cmd.equals("btn_flash10")) {
			// 設定ガイド6画面の点滅回数10ボタンをクリックした場合、設定ガイド8画面へ(失敗)
			layout.show(panelBase, "panel_guide8");

		} else if (cmd.equals("btn_flash5")) {
			// 設定ガイド6画面の点滅回数5ボタンをクリックした場合、設定ガイド7画面へ(成功)
			layout.show(panelBase, "panel_guide7");

		// ==========================================================================
		// スマートゲートウェイの検索画面関係
		// ==========================================================================
		} else if (cmd.equals("btn_search1")) {
			// スマートゲートウェイの検索1画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_search1");

		} else if (cmd.equals("btn_search2")) {
			// スマートゲートウェイの検索2画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_search2");

		} else if (cmd.equals("btn_kensaku")) {
			//　既存の検索結果がある場合は確認ダイアログ
			int res = JOptionPane.YES_OPTION;
			if (!SearchSgwIpAddress.smartGatewayInfoMap.isEmpty()
					|| SearchSgwIpAddress.smartGatewayInfoMap.size() > 0) {
				res = JOptionPane.showConfirmDialog(this,
						MES_WARNING_HAS_SEARCH_RESAULT,
						TITLE_WARNING_HAS_SEARCH_RESAULT,
						JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE);
				if (res == JOptionPane.YES_OPTION) {
					// 検索結果のマップは一旦クリアする
					SearchSgwIpAddress.smartGatewayInfoMap.clear();
					SearchSgwIpAddress.smartGatewayEncodeMap.clear();
					SearchSgwIpAddress.smartGatewayTypeMap.clear();
				} else if (res == JOptionPane.CANCEL_OPTION) {
					// 何もしない
					return;
				}
			}

			// 検索結果がない、または「はい」を押下したときに検索する
			if (res == JOptionPane.YES_OPTION) {
				// スマートゲートウェイの検索2画面で検索開始ボタンをクリックした場合、検索開始ダイアログを表示
				SearchExecutionDialog exeDlg = new SearchExecutionDialog(this);
				exeDlg.setVisible(true);
			}

			// 検索開始ダイアログはモーダルなので閉じた後、ここからの処理が行われる
			//if(CommonParam.smartGatewayIp != "") {
			if (SearchSgwIpAddress.smartGatewayInfoMap.size() > 0) {

				// --------------------------------------------------------------
				// SGWのIPが見つかった
				// --------------------------------------------------------------
				// 見つかったSGW機器のIPをクラス変数にセット
				System.out.println("見つかったSGW機器の数：" + SearchSgwIpAddress.smartGatewayInfoMap.size());
				System.out.println("見つかったSGW機器情報：" + SearchSgwIpAddress.smartGatewayInfoMap);

				/*SGWの複数検索に対応(Add 2015/08/20)*/
				// 複数見つかったSGW機器のIPをクラス変数にセット
				Iterator<Entry<String, String>> entries = SearchSgwIpAddress.smartGatewayInfoMap.entrySet().iterator();
				while (entries.hasNext()) {
					Map.Entry<String, String> entry = (Map.Entry<String, String>) entries.next();
					String sgwIP = (String) entry.getKey();
					String sgwID = (String) entry.getValue();
					System.out.println("----------");
					System.out.println("IPアドレス:" + sgwIP);
					System.out.println("製造番号:" + sgwID);
				}

				// 検索結果ダイアログを表示
				SearchSuccessDialog sucDlg = new SearchSuccessDialog(this, SearchSgwIpAddress.smartGatewayInfoMap);

				sucDlg.setVisible(true);

				// スマートゲートウェイの検索2画面へ遷移
				layout.show(panelBase, "panel_search2");

			} else {
				// --------------------------------------------------------------
				// SGWのIPが見つからなかった
				// --------------------------------------------------------------
				// 検索結果失敗ダイアログを表示
				SearchError1Dialog err1Dlg = new SearchError1Dialog(this);
				err1Dlg.setVisible(true);

				// スマートゲートウェイの検索1画面へ遷移
				layout.show(panelBase, "panel_search1");
			}

		// ==========================================================================
		// 利用登録画面関係
		// ==========================================================================
		} else if (cmd.equals("btn_regist1")) {
			if (!SgwMiniSetup.IS_SGW_PLUS_MC) {
				// 利用登録1画面へ遷移するコマンドの場合
				layout.show(panelBase, "panel_regist1");
			} else {
				// 確認メッセージ表示
				JOptionPane.showMessageDialog(this, MES_WARNING_MEDIACONV_MODE, TITLE_WARNING_MEDIACONV_MODE, JOptionPane.INFORMATION_MESSAGE);
			}

		} else if (cmd.equals("btn_regist2")) {
			// 利用登録2画面へ遷移するコマンドの場合
			layout.show(panelBase, "panel_regist2");

		} else if (cmd.equals("btn_agree")) {
			// SGWのIPアドレスがあるか
			if (CommonParam.smartGatewayIp != "") {
				// --------------------------------------------------------------
				// SGWのIPが見つかった
				// --------------------------------------------------------------
				System.out.println("IPアドレス「" + CommonParam.smartGatewayIp + "」で利用登録確認");

				// 利用登録確認中ダイアログを表示
				RegistExecutionDialog regExtDlg = new RegistExecutionDialog(this);
				regExtDlg.setVisible(true);

				// 利用登録2画面で同意するボタンをクリックした場合、利用登録ダイアログを表示
				RegistSuccessDialog regSucDlg = new RegistSuccessDialog(this);
				regSucDlg.setVisible(true);

				// トップ画面に移動する
				layout.show(panelBase, "panel_top");

			} else {
				// --------------------------------------------------------------
				// SGWのIPが見つからなかった
				// --------------------------------------------------------------
				// 検索結果失敗画面を表示
				RegistErrorDialog regErrDlg = new RegistErrorDialog(this);
				regErrDlg.setVisible(true);
			}
		}

		// ==========================================================================
		// 詳細画面関係
		// ==========================================================================
		else if (cmd.equals("btn_detail")) {
			// 画面更新
			updateDisplay(false);

			if (smartGatewayInfo.equals(MSG_NO_IP_ADDRESS)) {
				// 確認メッセージ表示
				JOptionPane.showMessageDialog(this, MES_WARNING_NO_IPADDRESS_OF_SGW, TITLE_CONFIRM, JOptionPane.INFORMATION_MESSAGE);
			} else if (isSGWInfoChecked == false) {
				// 警告メッセージ表示
				//JOptionPane.showMessageDialog(this, MES_ERROR_NO_CONNECTION_TO_SGW, MES_TITLE_WARNING, JOptionPane.WARNING_MESSAGE);
				int res = JOptionPane.showConfirmDialog(this,
						MES_ERROR_NO_CONNECTION_TO_SGW,
						TITLE_WARNING_NO_IPADDRESS_OF_SGW,
						JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
				if (res == JOptionPane.YES_OPTION) {
					checkSupportedJavaVersion(true);
					// 詳細パネル更新
					updateDetailPanel();
					// 「はい」が選択すると、詳細画面へ遷移
					layout.show(panelBase, "panel_detail");
				}
			} else {
				checkSupportedJavaVersion(true);
				// 詳細パネル更新
				updateDetailPanel();
				// 詳細ボタンをクリックされた時、詳細画面へ遷移
				layout.show(panelBase, "panel_detail");
			}
		}

		// Topページの【見える化画面】クリック時
		else if (cmd.equals("topBtn_visualization")) {
			if (!IS_SGW_PLUS_MC) {
				String requestURL = "http://" + CommonParam.smartGatewayIp + CommonParam.WEB_TOP_CGI;
				// Webブラウザ起動
				if (CommonParam.useExternalBrowser) {
					launchWebBrowser(requestURL);
				} else {
					// WebViewを新規生成
					//webVeiwOnJFrame = new WebVeiwOnJFrame(requestURL, false, this.getX(), this.getY(), this.getWidth(), this.getHeight());
					webVeiwOnJFrame = new WebVeiwOnJFrame(requestURL, "スマートゲートウェイ　見える化画面", false, this.getX(), this.getY(), this.getWidth(), this.getHeight(), true);
					webVeiwOnJFrame.launchWebView();
					
					// イベント追加
					webVeiwOnJFrame.addWindowListener(new WindowAdapter() {
						// ウインドウが閉じると呼び出されます。
						public void windowClosing(WindowEvent we) {
							checkSmartGatewayInfo(true);
						}
					});
				}
			}
		}

		// Topページの【計器認証設定】クリック時
		else if (cmd.equals("topBtn_meter_setting")) {
			if (!IS_SGW_PLUS_MC) {
				String requestURL = "http://" + CommonParam.smartGatewayIp + CommonParam.SMART_METER_CGI;
				// Webブラウザ起動
				if (CommonParam.useExternalBrowser) {
					launchWebBrowser(requestURL);
				} else {
					// WebViewを新規生成
					//webVeiwOnJFrame = new WebVeiwOnJFrame(requestURL, true, this.getX(), this.getY(), this.getWidth(), this.getHeight());
					webVeiwOnJFrame = new WebVeiwOnJFrame(requestURL, "計器認証設定", true, this.getX(), this.getY(), this.getWidth(), this.getHeight(), false);
					webVeiwOnJFrame.launchWebView();
					
					// イベント追加
					webVeiwOnJFrame.addWindowListener(new WindowAdapter() {
						// ウインドウが閉じると呼び出されます。
						public void windowClosing(WindowEvent we) {
							checkSmartGatewayInfo(true);
						}
					});
				}
			}
		}

		else {
			rootURL = "http://" + CommonParam.smartGatewayIp;

			/******************************************************************
			【詳細画面内の各ボタン】外部ブラウザ起動する場合
			******************************************************************/
			if (chk_launch_browser.isSelected()) {
				if (CommonParam.smartGatewayIp.length() < 4) {
					return;
				}

				boolean isURLRequested = true;

				/* 現在の状況ボタン　クリック時 */
				if (cmd.equals("btn_current_status")) {
					if (IS_SGW_PLUS_MC) {
						requestURL = rootURL + "/index_media.cgi";
					} else {
						requestURL = rootURL + "/index.cgi";
					}
				}
				/* 計器設定ボタン　クリック時 */
				else if (cmd.equals("btn_meter_setting")) {
					if (IS_SGW_PLUS_MC) {
						requestURL = rootURL + "/index_media.cgi?media_set.html";
					} else {
						requestURL = rootURL + "/meter_set.cgi";
	
						// SGW Plusの場合は、別のURLを指定。
						if (SgwMiniSetup.IS_SGW_PLUS) {
							requestURL = rootURL + "/name_set.cgi";
						}
						}
				}
				/* 時刻設定設定ボタン　クリック時 */
				else if (cmd.equals("btn_time_setting")) {
					if (IS_SGW_PLUS_MC) {
						requestURL = rootURL + "/index_media.cgi?media_aif.html";
					} else {
						requestURL = rootURL + "/time_set.cgi";
					}
				}
				/* 「家電操作機器一覧」ボタン */
				else if (cmd.equals("btn_device_control")) {
					requestURL = rootURL + "/echonetlite_set.cgi";
				}
				/* 通信設定ボタン　クリック時 */
				else if (cmd.equals("btn_communicate_setting")) {
					requestURL = rootURL + "/comm_set.cgi";
				}
				/* 利用登録ボタン　クリック時 */
				else if (cmd.equals("btn_member_entry")) {
					requestURL = rootURL + "/test_connect_confirm.cgi";
				}
				/* 「宅外操作設定」ボタン (root/root) */
				else if (cmd.equals("btn_remote_setting")) {
					requestURL = rootURL + "/admin_set.cgi";

					// SGWの場合は、ブラウザ起動せず。
					if (SgwMiniSetup.IS_SGW) {
						isURLRequested = false;
					}
				}
				/* サーバー設定ボタン　クリック時 */
				else if (cmd.equals("btn_server_setting")) {
					// 管理者認証
					if (checkAdminAuthorization()) {
						requestURL = rootURL + "/mainte_admin_set.cgi";

						// SGWの場合は、管理画面を表示。
						if (SgwMiniSetup.IS_SGW) {
							requestURL = rootURL + "/admin_set.cgi";
						}
					} else {
						isURLRequested = false;
					}
				}
				/* 「スマートメーターの状況」ボタン */
				else if (cmd.equals("btn_smart_meter_status")) {
					requestURL = rootURL + "/smart_meter.cgi";
				}
				/* スマートメータ設定ボタン　クリック時 */
				else if (cmd.equals("btn_smart_meter_setting")) {
					requestURL = rootURL + "/smart_set.cgi";
				}
				/* 電界強度表示ボタン　クリック時 */
				else if (cmd.equals("btn_radio_field_strength_setting")) {
					requestURL = rootURL + "/rssi.cgi";
				}

				/* スマートエコリンク計器設定ボタン　クリック時 */
				else if (cmd.equals("btn_smart_echolink_meter_setting")) {
					requestURL = rootURL + "/meter_set.cgi";
				}
				/* Webコンテンツ設定ボタン　クリック時 */
				else if (cmd.equals("btn_web_contents_setting")) {
					//サブメニュー表示（下記は暫定）
					requestURL = rootURL + "/admin_set.cgi";
				}
				/* システムログインボタン　クリック時 */
				else if (cmd.equals("btn_system_login")) {
					//サブメニュー表示（下記は暫定）
					requestURL = rootURL + "/login.cgi";
				}

				/* チェックボックス　クリック時 */
				else if (cmd.equals("chk_launch_browser")) {
					isURLRequested = false;
					
					// 外部ブラウザを起動するかどうか？
					CommonParam.useExternalBrowser = chk_launch_browser.isSelected();
				}

				// Webブラウザ起動
				if (isURLRequested) {
					launchWebBrowser(requestURL);
				}

				/******************************************************************
					【詳細画面内の各ボタン】WebViewを起動する場合
				******************************************************************/
			} else if (!chk_launch_browser.isSelected()) {
				if (CommonParam.smartGatewayIp.length() < 4) {
					return;
				}

				boolean isURLRequested = true;
				boolean hasAuthentication = false;
				boolean needsWebBrowserRequested = false;

				/* 「現在の状況」ボタン　クリック時 */
				if (cmd.equals("btn_current_status")) {
					if (IS_SGW_PLUS_MC) {
						requestURL = rootURL + "/index_media.cgi";
					} else {
						requestURL = rootURL + "/index.cgi";
					}
				}
				/* 「計器設定」ボタン　クリック時 */
				else if (cmd.equals("btn_meter_setting")) {
					if (IS_SGW_PLUS_MC) {
						requestURL = rootURL + "/index_media.cgi?media_set.html";
					} else {
						requestURL = rootURL + "/meter_set.cgi";
	
						// SGW Plusの場合は、別のURLを指定。
						if (SgwMiniSetup.IS_SGW_PLUS) {
							requestURL = rootURL + "/name_set.cgi";
						}
					}
				}
				/* 「時刻設定設定」ボタン　クリック時 */
				else if (cmd.equals("btn_time_setting")) {
					if (IS_SGW_PLUS_MC) {
						requestURL = rootURL + "/index_media.cgi?media_aif.html";
					} else {
						requestURL = rootURL + "/time_set.cgi";
	
						// SGW Plusの場合は、確認ダイアログを表示する為、ブラウザで表示。
						if (SgwMiniSetup.IS_SGW_PLUS) {
							needsWebBrowserRequested = true;
						}
					}
				}
				/* 「家電操作機器一覧」ボタン */
				else if (cmd.equals("btn_device_control")) {
					requestURL = rootURL + "/echonetlite_set.cgi";
				}
				/* 「通信設定」ボタン　クリック時 */
				else if (cmd.equals("btn_communicate_setting")) {
					requestURL = rootURL + "/comm_set.cgi";
					hasAuthentication = true;
				}
				/* 「利用登録」ボタン　クリック時 */
				else if (cmd.equals("btn_member_entry")) {
					requestURL = rootURL + "/test_connect_confirm.cgi";

					// SGWの場合は、ユーザ認証が必要
					if (SgwMiniSetup.IS_SGW) {
						hasAuthentication = true;
					}
				}
				/* 「宅外操作設定」ボタン (root/root) */
				else if (cmd.equals("btn_remote_setting")) {
					//requestURL = rootURL + "/admin_set.cgi";
					//hasAuthentication = true;
					setRemoteControlSetting();
					isURLRequested = false;
				}
				/* 「サーバー設定」ボタン　クリック時*/
				else if (cmd.equals("btn_server_setting")) {
					// 管理者認証
					if (checkAdminAuthorization()) {
						requestURL = rootURL + "/mainte_admin_set.cgi";

						// SGWの場合は、URLが異なり、ユーザ認証が必要
						if (SgwMiniSetup.IS_SGW) {
							requestURL = rootURL + "/admin_set.cgi";
							hasAuthentication = true;
						} 
						// SGW Plus v3の場合は、確認ダイアログを表示する為、ブラウザで表示。
						else if (SgwMiniSetup.IS_SGW_PLUS_V3 || SgwMiniSetup.IS_SGW_PLUS_V4) {
							needsWebBrowserRequested = true;
						}
					} else {
						isURLRequested = false;
					}
				}
				/* 「スマートメーターの状況」ボタン */
				else if (cmd.equals("btn_smart_meter_status")) {
					requestURL = rootURL + "/smart_meter.cgi";
				}
				/* 「スマートメータ認証設定」ボタン　クリック時 */
				else if (cmd.equals("btn_smart_meter_setting")) {
					requestURL = rootURL + "/smart_set.cgi";
					hasAuthentication = true;
				}
				/* 「電界強度表示」ボタン　クリック時 */
				else if (cmd.equals("btn_radio_field_strength_setting")) {
					requestURL = rootURL + "/rssi.cgi";
					hasAuthentication = true;
				}

				/* スマートエコリンク計器設定ボタン　クリック時 */
				else if (cmd.equals("btn_smart_echolink_meter_setting")) {
					requestURL = rootURL + "/meter_set.cgi";
					hasAuthentication = true;
				}
				/* Webコンテンツ設定ボタン　クリック時 */
				else if (cmd.equals("btn_web_contents_setting")) {
					//Webコンテンツ設定ダイアログを表示
					//WebContentsSettingDialog dialog = new WebContentsSettingDialog(this);
					//dialog.setVisible(true);
					showWebContentsDialog(true);
					isURLRequested = false;
				}
				/* システムログインボタン　クリック時 */
				else if (cmd.equals("btn_system_login")) {
					requestURL = rootURL + "/login.cgi";
				}

				/* チェックボックス　クリック時 */
				else if (cmd.equals("chk_launch_browser")) {
					isURLRequested = false;
				}

				// Web画面表示
				if (isURLRequested) {
					if (needsWebBrowserRequested) {
						//確認ダイアログ表示
						int ret = JOptionPane.showConfirmDialog(this,
								"Webブラウザを起動して、設定画面を表示します。", "確認",
								JOptionPane.YES_OPTION + JOptionPane.CANCEL_OPTION,
								JOptionPane.INFORMATION_MESSAGE);
						if (ret == JOptionPane.YES_OPTION) {
							//Webブラウザを起動
							launchWebBrowser(requestURL);
						}
					} else {
						if (webVeiwOnJFrame != null) {
							webVeiwOnJFrame.setVisible(false);
							webVeiwOnJFrame = null;
						}
						// WebViewを新規生成
						webVeiwOnJFrame = new WebVeiwOnJFrame(requestURL, hasAuthentication, this.getX(), this.getY(), this.getWidth(), this.getHeight());
						webVeiwOnJFrame.launchWebView();
					}
				}
			}
		}
	}

	private boolean checkSupportedJavaVersion(boolean showWarningMessage) {
		if (!CommonFunc.checkSupportedJavaVersion()) {
			if (showWarningMessage) {
				String mes = "Java実行環境がサポート外のバージョンとなっています（JRE1.8以上）。\n\n"
						+ "詳細設定メニューを最適な環境で行うには、Java実行環境のバージョンを更新して最新版にしてください。\n";
				JOptionPane.showMessageDialog(this, mes, "[確認]: Java実行環境がサポート外となっています", JOptionPane.INFORMATION_MESSAGE);
			}
			isSupportedJavaVersion = false;
			return false;
		}
		isSupportedJavaVersion = true;
		return true;
	}

	private boolean checkAdminAuthorization() {
		//メッセージ表示
		String mes = "管理者用パスワードを入力してください。\n";
		String title = "管理者用";
		String res = JOptionPane.showInputDialog(this, mes, title, JOptionPane.INFORMATION_MESSAGE);
		if (res != null) {
			if (res.equals(CommonParam.ADMIN_PASSWORD)) {
				return true;
			} else {
				JOptionPane.showMessageDialog(this, "入力したパスワードが間違っています。", "認証エラー", JOptionPane.WARNING_MESSAGE);
			}
		}
		return false;
	}

	/**
	 * タイトルをパネルにセットして返す
	 *
	 * @param String title タイトルの文言
	 * @param Color font_color タイトルの色
	 * @return JLabel label_title タイトルをセットしたラベル
	 */
	private JLabel setJLabelTitle(String title, Color font_color) {
		// 文言をセット
		JLabel label_title = new JLabel(title);

		// 表示するX座標、Y座標、幅、高さをセット
		if (IS_HIGH_RESOLUTION) {
			label_title.setBounds(calcDispSize(POS_COMMON_TITLE_X), calcDispSize(POS_COMMON_TITLE_Y),
					calcDispSize(POS_COMMON_TITLE_WIDTH), calcDispSize(POS_COMMON_TITLE_HEIGHT));
		} else {
			label_title.setBounds(POS_COMMON_TITLE_X, POS_COMMON_TITLE_Y,
					POS_COMMON_TITLE_WIDTH, POS_COMMON_TITLE_HEIGHT);
		}

		// 文字の種類、太さ、サイズをセット
		if (IS_HIGH_RESOLUTION) {
			label_title.setFont(new Font(FONT_STYLE_COMMON_TITLE, calcDispSize(FONT_WEIGHT_COMMON_TITLE), calcDispSize(FONT_SIZE_COMMON_TITLE)));
		} else {
			label_title.setFont(new Font(FONT_STYLE_COMMON_TITLE, FONT_WEIGHT_COMMON_TITLE, FONT_SIZE_COMMON_TITLE));
		}

		// タイトルの文字の色をセット
		label_title.setForeground(font_color);

		return label_title;
	}

	/**
	 * サブタイトルをパネルにセットして返す
	 *
	 * @param String sub_title サブタイトルの文言
	 * @param Color font_color サブタイトルの色
	 * @return JLabel label_subtitle サブタイトルをセットしたラベル
	 */
	private JLabel setJLabelSubTitle(String sub_title, Color font_color) {
		// 文言をセット
		JLabel label_subtitle = new JLabel(sub_title);

		// X座標、Y座標、幅、高さをセット
		if (IS_HIGH_RESOLUTION) {
			label_subtitle.setBounds(calcDispSize(POS_COMMON_SUBTITLE_X), calcDispSize(POS_COMMON_SUBTITLE_Y),
					calcDispSize(POS_COMMON_SUBTITLE_WIDTH), calcDispSize(POS_COMMON_SUBTITLE_HEIGHT));
		} else {
			label_subtitle.setBounds(POS_COMMON_SUBTITLE_X, POS_COMMON_SUBTITLE_Y,
					POS_COMMON_SUBTITLE_WIDTH, POS_COMMON_SUBTITLE_HEIGHT);
		}

		// 文字の種類、太さ、サイズをセット
		if (IS_HIGH_RESOLUTION) {
			label_subtitle.setFont(new Font(FONT_STYLE_COMMON_SUBTITLE, calcDispSize(FONT_WEIGHT_COMMON_SUBTITLE), calcDispSize(FONT_SIZE_COMMON_SUBTITLE)));		
		} else {
			label_subtitle.setFont(new Font(FONT_STYLE_COMMON_SUBTITLE, FONT_WEIGHT_COMMON_SUBTITLE, FONT_SIZE_COMMON_SUBTITLE));
		}

		// 文字の色をセット
		label_subtitle.setForeground(font_color);

		return label_subtitle;
	}

	/**
	 * 区切り線(上部)をパネルにセットして返す
	 *
	 * @return JSeparator separator_top 区切り線(上部)
	 */
	private JSeparator setSepalatorTop() {
		// 水平方向の線をセット
		JSeparator separator_top = new JSeparator(SwingConstants.HORIZONTAL);

		// X座標、Y座標、幅、高さをセット
		if (IS_HIGH_RESOLUTION) {
			separator_top.setBounds(calcDispSize(POS_COMMON_SEPARATOR_TOP_X), calcDispSize(POS_COMMON_SEPARATOR_TOP_Y),
					calcDispSize(POS_COMMON_SEPARATOR_TOP_WIDTH), calcDispSize(POS_COMMON_SEPARATOR_TOP_HEIGHT));			
		} else {
			separator_top.setBounds(POS_COMMON_SEPARATOR_TOP_X, POS_COMMON_SEPARATOR_TOP_Y,
					POS_COMMON_SEPARATOR_TOP_WIDTH, POS_COMMON_SEPARATOR_TOP_HEIGHT);
		}

		return separator_top;
	}

	/**
	 * 区切り線(下部)をパネルにセットして返す
	 *
	 * @return JSeparator separator_top 区切り線(下部)
	 */
	private JSeparator setSepalatorBottom() {
		// 水平方向の線をセット
		JSeparator separator_bottom = new JSeparator(SwingConstants.HORIZONTAL);

		// X座標、Y座標、幅、高さをセット
		if (IS_HIGH_RESOLUTION) {
			separator_bottom.setBounds(calcDispSize(POS_COMMON_SEPARATOR_BOTTOM_X), calcDispSize(POS_COMMON_SEPARATOR_BOTTOM_Y),
					calcDispSize(POS_COMMON_SEPARATOR_BOTTOM_WIDTH), calcDispSize(POS_COMMON_SEPARATOR_BOTTOM_HEIGHT));
		} else {
			separator_bottom.setBounds(POS_COMMON_SEPARATOR_BOTTOM_X, POS_COMMON_SEPARATOR_BOTTOM_Y,
					POS_COMMON_SEPARATOR_BOTTOM_WIDTH, POS_COMMON_SEPARATOR_BOTTOM_HEIGHT);
		}

		return separator_bottom;
	}

	/**
	 * ページ番号をパネルにセットして返す
	 *
	 * @param int now_page_no 現在のページ番号
	 * @param int max_page_no ページ番号最大値
	 * @param Color font_color ページ番号の色
	 * @return JLabel label_page_no ページ番号のラベル
	 */
	private JLabel setJabelPageNo(int now_page_no, int max_page_no, Color font_color) {
		// ページ番号の文言をフォーマット化し、ラベルにセット
		String pane_no = String.format("(%s / %s)", now_page_no, max_page_no);
		JLabel label_page_no = new JLabel(pane_no);

		// X座標、Y座標、幅、高さをセット
		if (IS_HIGH_RESOLUTION) {
			label_page_no.setBounds(calcDispSize(POS_COMMON_PAGENO_X), calcDispSize(POS_COMMON_PAGENO_Y),
					calcDispSize(POS_COMMON_PAGENO_WIDTH), calcDispSize(POS_COMMON_PAGENO_HEIGHT));
		} else {
			label_page_no.setBounds(POS_COMMON_PAGENO_X, POS_COMMON_PAGENO_Y,
					POS_COMMON_PAGENO_WIDTH, POS_COMMON_PAGENO_HEIGHT);
		}

		// 文字の種類、太さ、サイズをセット
		if (IS_HIGH_RESOLUTION) {
			label_page_no.setFont(new Font(FONT_STYLE_COMMON_PAGE_NO, FONT_WEIGHT_COMMON_PAGE_NO, calcDispSize(FONT_SIZE_COMMON_PAGENO)));
		} else {
			label_page_no.setFont(new Font(FONT_STYLE_COMMON_PAGE_NO, FONT_WEIGHT_COMMON_PAGE_NO, FONT_SIZE_COMMON_PAGENO));
		}

		// 文字の色をセット
		label_page_no.setForeground(font_color);

		// 文字の位置をセット
		label_page_no.setHorizontalAlignment(TEXT_ALIGN_PAGE_NO);

		return label_page_no;
	}

	/**
	 * アプリバージョンをフッターのパネルにセットして返す
	 *
	 * @return JLabel label_footer_version アプリのバージョンをセットしたフッターのラベル
	 */
	private JLabel setJabelFooterVersion() {
		// ------------------------------------------------------------------------
		// アプリのバージョンをセット
		// ------------------------------------------------------------------------
		// 文言をセット
		JLabel label_footer_version = new JLabel(MSG_APLI_VERSION);

		// X座標、Y座標、幅、高さをセット
		int h_margin = 0;
		if (CommonFunc.checkOpenJava()) { h_margin = -3; }
		if (IS_HIGH_RESOLUTION) {
			label_footer_version.setBounds(calcDispSize(POS_COMMON_FOOTER_VERSION_X), calcDispSize(POS_COMMON_FOOTER_VERSION_Y + h_margin),
					calcDispSize(POS_COMMON_FOOTER_VERSION_WIDTH), calcDispSize(POS_COMMON_FOOTER_VERSION_HEIGHT));
		} else {
			label_footer_version.setBounds(POS_COMMON_FOOTER_VERSION_X, POS_COMMON_FOOTER_VERSION_Y + h_margin,
					POS_COMMON_FOOTER_VERSION_WIDTH, POS_COMMON_FOOTER_VERSION_HEIGHT);
		}

		// 文字の種類、太さ、サイズをセット
		if (IS_HIGH_RESOLUTION) {
			label_footer_version.setFont(new Font(Font.SANS_SERIF, Font.BOLD, calcDispSize(FONT_SIZE_COMMON_FOOTER)));
		} else {
			label_footer_version.setFont(new Font(Font.SANS_SERIF, Font.BOLD, FONT_SIZE_COMMON_FOOTER));
		}

		// 文字の色をセット
		label_footer_version.setForeground(FONT_COLOR_TOP);

		// 文字の位置をセット
		label_footer_version.setHorizontalAlignment(JLabel.LEFT);

		return label_footer_version;
	}

	/**
	 * コピーライトをフッターのパネルにセットして返す
	 *
	 * @return JLabel label_footer_version アプリのコピーライトをセットしたフッターのラベル
	 */
	private JLabel setJabelFooterCopyright() {
		// ------------------------------------------------------------------------
		// アプリのコピーライトをセット
		// ------------------------------------------------------------------------
		// 文言をセット
		JLabel label_footer_copyright = new JLabel(MSG_APLI_COPYRIGHT);

		// X座標、Y座標、幅、高さをセット
		int w_margin = 0, h_margin = 0;
		if (CommonFunc.checkOpenJava()) {
			w_margin = -3;
			h_margin = -3;
		}
		if (IS_HIGH_RESOLUTION) {
			label_footer_copyright.setBounds(calcDispSize(POS_COMMON_FOOTER_COPYRIGHT_X + w_margin), calcDispSize(POS_COMMON_FOOTER_COPYRIGHT_Y + h_margin),
					calcDispSize(POS_COMMON_FOOTER_COPYRIGHT_WIDTH), calcDispSize(POS_COMMON_FOOTER_COPYRIGHT_HEIGHT));
		
		} else {
			label_footer_copyright.setBounds(POS_COMMON_FOOTER_COPYRIGHT_X + w_margin, POS_COMMON_FOOTER_COPYRIGHT_Y + h_margin,
					POS_COMMON_FOOTER_COPYRIGHT_WIDTH, POS_COMMON_FOOTER_COPYRIGHT_HEIGHT);
		}

		// 文字の種類、太さ、サイズをセット
		if (IS_HIGH_RESOLUTION) {
			label_footer_copyright.setFont(new Font(Font.SANS_SERIF, Font.BOLD, calcDispSize(FONT_SIZE_COMMON_FOOTER)));
		} else {
			label_footer_copyright.setFont(new Font(Font.SANS_SERIF, Font.BOLD, FONT_SIZE_COMMON_FOOTER));
		}

		// 文字の色をセット
		label_footer_copyright.setForeground(FONT_COLOR_TOP);

		// 文字の位置をセット
		label_footer_copyright.setHorizontalAlignment(JLabel.RIGHT);

		return label_footer_copyright;
	}

	/**
	 * 説明文の背景画像をラベルにセットして返す
	 *
	 * @param String img_path 説明文の背景画像のパス
	 * @return JLabel label_explanation 説明文の背景画像をセットしたラベル
	 */
	private JLabel setJLabelExplanation(String img_path) {
		// 説明文の背景画像をラベルにセット
		ImageIcon img_explanation = new ImageIcon(this.getClass().getClassLoader().getResource(img_path));
		//JLabel label_explanation = new JLabel(img_explanation);
		JLabel label_explanation = new ScaledImageLabel(img_explanation);

		// X座標、Y座標、幅、高さをセット
		if (IS_HIGH_RESOLUTION) {
			label_explanation.setBounds(calcDispSize(POS_COMMON_MSG_IMG_X), calcDispSize(POS_COMMON_MSG_IMG_Y),
					calcDispSize(POS_COMMON_MSG_IMG_WIDTH), calcDispSize(POS_COMMON_MSG_IMG_HEIGHT));
		} else {
			label_explanation.setBounds(POS_COMMON_MSG_IMG_X, POS_COMMON_MSG_IMG_Y,
					POS_COMMON_MSG_IMG_WIDTH, POS_COMMON_MSG_IMG_HEIGHT);
		}

		return label_explanation;
	}

	/**
	 * 画面左側のボタン(TOPへ、前へボタン)をボタンにセットして返す
	 *
	 * @param String img_btn_off_path ロールオーバーしていないボタン画像
	 * @param String img_btn_on_path  ロールオーバーしているボタン画像
	 * @param String eventCmd ボタンに割り当てるコマンド
	 * @return JButton btn_left 左側ボタン
	 */
	private JButton setJButtonLeftButton(String img_btn_off_path, String img_btn_on_path, String eventCmd) {
		// ロールオーバー無し、ロールオーバー有りのボタン画像を読み込み
		ImageIcon btn_left_off = new ImageIcon(this.getClass().getClassLoader().getResource(img_btn_off_path));
		ImageIcon btn_left_on = new ImageIcon(this.getClass().getClassLoader().getResource(img_btn_on_path));

		// 上記で読み込んだボタン画像をセット
		//JButton btn_left = new JButton(btn_left_off); // フォーカスが当たってないときの画像
		JButton btn_left = new ScaledImageButton(btn_left_off); // フォーカスが当たってないときの画像
		btn_left.setRolloverIcon(btn_left_on); // ロールオーバーしたときの画像
		btn_left.setPressedIcon(btn_left_on); // ボタンを押したときの画像

		// X座標、Y座標、幅、高さをセット
		if (IS_HIGH_RESOLUTION) {
			btn_left.setBounds(calcDispSize(POS_COMMON_BTN_LEFT_X), calcDispSize(POS_COMMON_BTN_LEFT_Y),
					calcDispSize(POS_COMMON_BTN_LEFT_WIDTH), calcDispSize(POS_COMMON_BTN_LEFT_HEIGHT));
		} else {
			btn_left.setBounds(POS_COMMON_BTN_LEFT_X, POS_COMMON_BTN_LEFT_Y,
					POS_COMMON_BTN_LEFT_WIDTH, POS_COMMON_BTN_LEFT_HEIGHT);
		}

		// ボタンコンポーネントの枠線、塗り潰し無し
		btn_left.setBorderPainted(false);
		btn_left.setContentAreaFilled(false);

		// イベントの登録
		btn_left.addActionListener(this);
		btn_left.setActionCommand(eventCmd);

		return btn_left;
	}

	/**
	 * 画面左側のボタン(TOPへ、前へボタン)無しの代わりに空きラベルをセットして返す
	 *
	 * @return JLabel btn_left ボタン代わりの空きラベル
	 */
	private JLabel setJLabelLeftButton() {
		JLabel btn_left = new JLabel("");

		// X座標、Y座標、幅、高さをセット
		if (IS_HIGH_RESOLUTION) {
			btn_left.setBounds(calcDispSize(POS_COMMON_BTN_LEFT_X), calcDispSize(POS_COMMON_BTN_LEFT_Y),
					calcDispSize(POS_COMMON_BTN_LEFT_WIDTH), calcDispSize(POS_COMMON_BTN_LEFT_HEIGHT));
		} else {
			btn_left.setBounds(POS_COMMON_BTN_LEFT_X, POS_COMMON_BTN_LEFT_Y,
					POS_COMMON_BTN_LEFT_WIDTH, POS_COMMON_BTN_LEFT_HEIGHT);
		}

		return btn_left;
	}

	/**
	 * 画面右側のボタン(次へボタン)をボタンにセットして返す
	 **
	 * @param String img_btn_off_path ロールオーバーしていないボタン画像
	 * @param String img_btn_on_path  ロールオーバーしているボタン画像
	 * @param String eventCmd ボタンに割り当てるコマンド
	 * @return JButton btn_left 右側ボタン
	 */
	private JButton setJButtonRightButton(String img_btn_off_path, String img_btn_on_path, String eventCmd) {
		// ロールオーバー無し、ロールオーバー有りのボタン画像を読み込み
		ImageIcon btn_left_off = new ImageIcon(this.getClass().getClassLoader().getResource(img_btn_off_path));
		ImageIcon btn_left_on = new ImageIcon(this.getClass().getClassLoader().getResource(img_btn_on_path));

		// 上記で読み込んだボタン画像をセット
		//JButton btn_right = new JButton(btn_left_off); // フォーカスが当たってないときの画像
		JButton btn_right = new ScaledImageButton(btn_left_off); // フォーカスが当たってないときの画像
		btn_right.setRolloverIcon(btn_left_on); // ロールオーバーしたときの画像
		btn_right.setPressedIcon(btn_left_on); // ボタンを押したときの画像

		// X座標、Y座標、幅、高さをセット
		if (IS_HIGH_RESOLUTION) {
			btn_right.setBounds(calcDispSize(POS_COMMON_BTN_RIGHT_X), calcDispSize(POS_COMMON_BTN_RIGHT_Y),
					calcDispSize(POS_COMMON_BTN_RIGHT_WIDTH), calcDispSize(POS_COMMON_BTN_RIGHT_HEIGHT));
		} else {
			btn_right.setBounds(POS_COMMON_BTN_RIGHT_X, POS_COMMON_BTN_RIGHT_Y,
					POS_COMMON_BTN_RIGHT_WIDTH, POS_COMMON_BTN_RIGHT_HEIGHT);
		}

		// ボタンコンポーネントの枠線、塗り潰し無し
		btn_right.setBorderPainted(false);
		btn_right.setContentAreaFilled(false);

		// イベントの登録
		btn_right.addActionListener(this);
		btn_right.setActionCommand(eventCmd);

		return btn_right;
	}

	/**
	 * 画面右側のボタン(次へボタン)無しの代わりに空きラベルをセットして返す
	 *
	 * @return JLabel btn_right ボタン代わりの空きラベル
	 */
	private JLabel setJLabelRightButton() {
		JLabel btn_right = new JLabel("");

		// X座標、Y座標、幅、高さをセット
		if (IS_HIGH_RESOLUTION) {
			btn_right.setBounds(calcDispSize(POS_COMMON_BTN_RIGHT_X), calcDispSize(POS_COMMON_BTN_RIGHT_Y),
					calcDispSize(POS_COMMON_BTN_RIGHT_WIDTH), calcDispSize(POS_COMMON_BTN_RIGHT_HEIGHT));
		} else {
			btn_right.setBounds(POS_COMMON_BTN_RIGHT_X, POS_COMMON_BTN_RIGHT_Y,
					POS_COMMON_BTN_RIGHT_WIDTH, POS_COMMON_BTN_RIGHT_HEIGHT);
		}

		return btn_right;
	}

	/**
	 * スマートゲートウェイ情報をフッターのパネルにセットして返す
	 *
	 * @return JLabel label_footer_sgw_info スマートゲートウェイ情報をセットしたフッターのラベル
	 */
	private JLabel setJabelFooterSmartGatewayInfo() {
		// ------------------------------------------------------------------------
		// スマートゲートウェイ情報をセット
		// ------------------------------------------------------------------------
		// 文言をセット
		JLabel label_footer_sgw_info = new JLabel(SMART_GATEWAY_INFO_LBL + smartGatewayInfo);

		if (IS_HIGH_RESOLUTION) {
			label_footer_sgw_info.setBounds(calcDispSize(40), calcDispSize(495), calcDispSize(800), calcDispSize(POS_COMMON_FOOTER_VERSION_HEIGHT)); //【＠Ver.2.04】；サイズ変更
		} else {
			label_footer_sgw_info.setBounds(40, 495, 800, POS_COMMON_FOOTER_VERSION_HEIGHT); //【＠Ver.2.04】；サイズ変更
		}

		// 文字の種類、太さ、サイズをセット
		if (IS_HIGH_RESOLUTION) {
			label_footer_sgw_info.setFont(new Font(Font.SANS_SERIF, Font.BOLD, calcDispSize(FONT_SIZE_COMMON_FOOTER)));
		} else {
			label_footer_sgw_info.setFont(new Font(Font.SANS_SERIF, Font.BOLD, FONT_SIZE_COMMON_FOOTER));
		}

		// 文字の色をセット
		label_footer_sgw_info.setForeground(FONT_COLOR_TOP);

		// 文字の位置をセット
		//label_footer_sgw_info.setHorizontalAlignment(JLabel.RIGHT);
		label_footer_sgw_info.setHorizontalAlignment(JLabel.LEFT);

		return label_footer_sgw_info;
	}

	/**
	 * スマートゲートウェイ情報をファイルに保存する
	 *
	 * @return なし
	 */
	public void updateSgwInfo() {
		try {
			String sgwIP = CommonParam.smartGatewayIp;
			String sgwID = CommonParam.smartGatewaySerialNo;
			String checkID = CommonParam.checkedSerialNo;
			String status = BLANK_STATUS_LBL; //【＠Ver.2.04】；追加
			if (sgwIP != null && !smartGatewayInfo.equals(MSG_NO_IP_ADDRESS)
					&& sgwID != null && checkID != null && checkID.length() == 8
			/* && !sgwID.equals(checkID) */) {
				if (CommonParam.smartGatewayStatus != null
						&& CommonParam.smartGatewayStatus.length() > 0) {
					status = CommonParam.smartGatewayStatus;
				}
				String zenkaku_space = "　";
				String hankaku_space = "        ";
				//【＠Ver.2.04】：SGW情報に加えて、登録状況も表示させる
				String updateSgwInfo = CommonParam.IP_ADDRESS_LBL + "[" + sgwIP + "]" + hankaku_space
						+ CommonParam.SERIAL_NUMBER_LBL + "[" + checkID + "]" + hankaku_space
						+ CommonParam.REGIST_STATUS_LBL + "[" + status + "]" + zenkaku_space;
				//CommonFunc.writeFile(FILE_SEARCH_SGW_PATH, updateSgwInfo);
				//CommonFunc.writeFile(FILE_SEARCH_SGW_PATH, updateSgwInfo + "," + CommonParam.smartGatewayEncode);

				String saveString = updateSgwInfo + "," + CommonParam.smartGatewayEncode;
				
				// 検索結果も保存する
				Iterator<Entry<String, String>> entries = SearchSgwIpAddress.smartGatewayInfoMap.entrySet().iterator();
				while (entries.hasNext()) {
					Map.Entry<String, String> entry = (Map.Entry<String, String>) entries.next();
					String tmpSgwIP = (String) entry.getKey();
					String tmpSgwID = (String) entry.getValue();
					String tmpSgwEncode = SearchSgwIpAddress.smartGatewayEncodeMap.get(tmpSgwIP);
					String tmpSgwType = SearchSgwIpAddress.smartGatewayTypeMap.get(tmpSgwIP);
					String tmpRemoteSetting = Integer.toString(ServerHostSettingDialog.remote_control_setting_flag);

					//saveString = saveString + com.SgwMiniSetup.common.CommonParam.FILE_DELIMITER
					//		+ tmpSgwIP + "," + tmpSgwID + "," + tmpSgwEncode;
					saveString = saveString + com.SgwMiniSetup.common.CommonParam.FILE_DELIMITER
							+ tmpSgwIP + "," + tmpSgwID + "," + tmpSgwEncode + "," + tmpSgwType + "," + tmpRemoteSetting;

				}

				CommonFunc.writeFile(FILE_SEARCH_SGW_PATH, saveString);

				smartGatewayInfo = updateSgwInfo;

				// 表示も更新
				if (label_footer_sgw_info != null) {
					label_footer_sgw_info.setText(SMART_GATEWAY_INFO_LBL + smartGatewayInfo);
				}
				// ボタン表示も更新
				setButtonVisiblity(true);
			}
		} catch (Exception e) {
		}
	}

	/**
	 * ファイル保存されているスマートゲートウェイ情報を読み込む
	 *
	 * @return なし
	 */
	private void readSavedSgwIp() {
		try {
			/*次回起動時に登録処理のみする場合を考慮*/
			String readText = CommonFunc.readFile(FILE_SEARCH_SGW_PATH);
			if (readText == null || readText.length() < 8) {
				smartGatewayInfo = MSG_NO_IP_ADDRESS;
			} else {
				String[] lstReadStr = readText.split(com.SgwMiniSetup.common.CommonParam.FILE_DELIMITER);
				if (lstReadStr.length > 0) {
					//【＠Ver.2.04】：SGW情報に加えて、エンコード情報も読み込む（※カンマ「,」区切り）
					String[] readStr_0 = lstReadStr[0].split(",");

					if (readStr_0.length == 2) {
						smartGatewayInfo = readStr_0[0];
						CommonParam.smartGatewayEncode = readStr_0[1];
					} else {
						smartGatewayInfo = lstReadStr[0];
					}

					/*不要情報を削除しIP部分のみを保持*/
					String tempReadSgwIp = smartGatewayInfo.replaceAll(CommonParam.IP_ADDRESS_LBL + "\\[", "");
					int index = tempReadSgwIp.indexOf("]");
					String savedSgwIp = tempReadSgwIp.substring(0, index);

					/*IPアドレス部分を保持*/
					CommonParam.smartGatewayIp = savedSgwIp;

					tempReadSgwIp = tempReadSgwIp.substring(index + 1, tempReadSgwIp.length());
					int index_start = tempReadSgwIp.indexOf("[");
					int index_end = tempReadSgwIp.indexOf("]");
					String savedSerialNo = tempReadSgwIp.substring(index_start + 1, index_end);

					/*シリアルNo部分を保持*/
					CommonParam.smartGatewaySerialNo = savedSerialNo;
				}
				// 残りはハッシュマップに反映させる
				if (lstReadStr.length > 1) {
					// 一旦、クリアする
					SearchSgwIpAddress.smartGatewayInfoMap.clear();
					SearchSgwIpAddress.smartGatewayEncodeMap.clear();
					SearchSgwIpAddress.smartGatewayTypeMap.clear();
					String remoteControlSetting = null;
					
					for (int i = 1; i < lstReadStr.length; i++) {
						String[] readStr_i = lstReadStr[i].split(",");
						if (readStr_i.length > 3) {
							String sgwIp = readStr_i[0];
							String sgwNo = readStr_i[1];
							String sgwEncode = readStr_i[2];
							String sgwType = "-1";
							if (readStr_i.length >= 4) {	// エラー対策
								sgwType = readStr_i[3];
							}

							if (sgwIp != null && sgwIp.length() > 0) {
								SearchSgwIpAddress.smartGatewayInfoMap.put(sgwIp, sgwNo);
								SearchSgwIpAddress.smartGatewayEncodeMap.put(sgwIp, sgwEncode);
								SearchSgwIpAddress.smartGatewayTypeMap.put(sgwIp, sgwType);
							}
							
							// 宅外操作設定を指定する
							if (readStr_i.length >= 5) {
								remoteControlSetting = readStr_i[4];
							}
						}
					}
					
					// SGWのタイプを指定する
					String curSgwType = SearchSgwIpAddress.smartGatewayTypeMap.get(CommonParam.smartGatewayIp);
					if (curSgwType != null && curSgwType.length() > 0) {
						CommonParam.smartGatewayType = Integer.parseInt(curSgwType);
					}
					
					// 宅外操作設定を指定する
					if (remoteControlSetting != null && remoteControlSetting.length() > 0) {
						int curRemoteSettingFlag = ServerHostSettingDialog.REMOTE_CONTROL_DISABLED;
						try {
							curRemoteSettingFlag = Integer.parseInt(remoteControlSetting);
						} catch (Exception e) {	}
						ServerHostSettingDialog.remote_control_setting_flag = curRemoteSettingFlag;
					}
				}
			}
		} catch (URISyntaxException ue) {
			ue.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Webブラウザ起動
	 *
	 *　@param url
	 * @return なし
	 */
	public static void launchWebBrowser(String url) {
		try {
			String osname = System.getProperty("os.name");
			// Windowsであったときの処理
			if (osname.indexOf("Windows") >= 0) {
				Runtime.getRuntime().exec("rundll32 url.dll, FileProtocolHandler " + url);
			}
			// Macであったときの処理
			else if (osname.indexOf("Mac") >= 0) {
//				String[] args = { "osascript", "-e", "open location \"" + url + "\"" };
//				Runtime.getRuntime().exec(args);		
				
				//java.awt.Desktop を使ってデフォールトのWebブラウザを起動する。
				launchWebBrowserWithDesktop(url);
			} 
			else {
				Runtime.getRuntime().exec("xdg-open " + url);
			}
//		} catch (IOException e1) {
//			e1.printStackTrace();
		} catch (Exception e1) {
//			e1.printStackTrace();	
			
			//java.awt.Desktop を使ってデフォールトのWebブラウザを起動する。
			launchWebBrowserWithDesktop(url);
		}
	}
	
	
	/**
	 * java.awt.Desktop を使ってデフォールトのWebブラウザを起動する。
	 *
	 *　@param url
	 * @return なし
	 */
	private static void launchWebBrowserWithDesktop(String url) {
		Desktop desktop = Desktop.getDesktop();
		try {
			URI uri = new URI(url);
			desktop.browse(uri);
		} catch (URISyntaxException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * 宅外操作可否設定の確認ダイアログを表示し、スマートゲートウェイに変更要求を送信する
	 *
	 * @return なし
	 */
	private void setRemoteControlSetting() {
		String loginURL = this.rootURL + "/login.cgi";
		String requestURL = this.rootURL + "/admin_set.cgi";
		String responseText = getResponseWithLogin(loginURL, "root", "root", requestURL);
		String startTag = "<input type=\"radio\" name=\"ENL_REMOTE\"";
		String endTag = "</label>";
		int positon = 0;
		String remoteEnabled = HTMLAnalyzer.getRadioTagOptionValue(responseText, positon, startTag, endTag);
		System.out.println(remoteEnabled);

		RemoteControlSettingDialog dialog = new RemoteControlSettingDialog(this, remoteEnabled);
		dialog.setVisible(true);

		int res = dialog.getRemoteControlSetting();

		//  "許可しない" or "許可する"
		if (res == 0 || res == 1) {
			String[] items = { "許可しない", "許可する" };
			// 宅外からの操作可否設定の変更要求を送信
			boolean isSucceeded = requestRemoteCotrolSetting(res);
			String chkTitle = "送信成功";
			String chkMessage = "宅外からの操作可否設定を変更しました。\n\n    ※設定変更要求:　[　" + items[res] + "　]\n\n";
			int icon = JOptionPane.INFORMATION_MESSAGE;
			if (!isSucceeded) {
				chkTitle = "送信失敗";
				chkMessage = "宅外からの操作可否設定が変更できませんでした。\n\n    ※設定変更要求:　[　" + items[res] + "　]\n\n";
				icon = JOptionPane.WARNING_MESSAGE;
			}
			JOptionPane.showMessageDialog(this, chkMessage, chkTitle, icon);
		}

	}

	/**
	 * 宅外操作可否設定情報をスマートゲートウェイに送信する
	 *
	 *　@param index
	 * @return なし
	 */
	private boolean requestRemoteCotrolSetting(int index) {
		String requestDeviceControlURL = this.rootURL + "/remote_setting_result.cgi";

		if (CommonParam.useOkHttpClient) {
			/* クライアントの生成 */
			OkHttpClient okhttpClient;
			if ((IS_SGW_PLUS_V2 || IS_SGW_PLUS_V3 || IS_SGW_PLUS_V4) 
					&& loginedOkHttpClient != null) {
				okhttpClient = loginedOkHttpClient;
			} else {
				//okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
				okhttpClient = SgwHttpClient.createOkHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
			
			try {
				/* 認証用アドレス・パラメータ */
				RequestBody formBody = new FormBody.Builder()
		                .add("ENL_REMOTE", URLEncoder.encode(Integer.toString(index), "UTF-8"))
		                .build();
		 
				/* リクエスト処理 */
				Request request = new Request.Builder()
		                .url(requestDeviceControlURL)
		                .post(formBody)
		                .build();
	
				// 同期処理
				Response response = okhttpClient.newCall(request).execute();
				if (response.isSuccessful()) {
					return true;
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		} else {
			// クライアントの生成
			DefaultHttpClient client;
			if ((IS_SGW_PLUS_V2 || IS_SGW_PLUS_V3 || IS_SGW_PLUS_V4) 
					&& loginedClient != null) {
				client = loginedClient;
			} else {
				//client = SgwHttpClient.createHttpClientWithProxy();
				client = SgwHttpClient.createHttpClientWithProxy(CommonParam.HTTP_CONNECTION_TIMEOUT);
			}
	
			try {
				// フォームパラメータの作成
				List<NameValuePair> formparams = new ArrayList<NameValuePair>();
				formparams.add(new BasicNameValuePair("ENL_REMOTE", Integer.toString(index)));
				//formparams.add(new BasicNameValuePair("CHANGE_BTN", "変更"));
				UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
	
				// HttpPostの生成
				HttpPost httppost = new HttpPost(requestDeviceControlURL);
	
				// HttpPostにパラメータをセットする。
				httppost.setEntity(entity);
	
				// HttpPOST実行
				HttpResponse res = client.execute(httppost);
	
				if (res.getEntity() != null
						&& res.getStatusLine().getStatusCode() == 200) {
					return true;
				}
	
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				// コネクションを切断する
				client.getConnectionManager().shutdown();
				loginedClient = null;
			}
		}

		return false;
	}
	
	private void checkSmartGatewayInfo(boolean doCheck) {
		try {
			if (doCheck) {
				// 通信＆認証チェック中でない
				if (CommonParam.checkingCommTest == false
						&& CommonParam.checkingAuthorization == false) {
					/* SGW情報を再設定 */
					updateDisplay(false);
				}
			} else {
				updateDisplay(false);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Cookieの取得とログイン
	 *
	 * @param loginURL
	 * @param loginUser
	 * @param loginPass
	 * @param requestURL
	 * @return
	 */
	//	private String getResponseWithLogin(String loginURL, String loginUser, String loginPass, String requestURL) {
	public static String getResponseWithLogin(String loginURL, String loginUser, String loginPass, String requestURL) {
		
		if (CommonParam.useOkHttpClient) {
			/* OkHttpClientの準備 */
			//OkHttpClient okHttpClient = SgwHttpClient.createOkHttpClientWithProxy(5000);
			OkHttpClient okHttpClient = SgwHttpClient.createOkHttpClientWithProxy(com.SgwSetting.common.CommonParam.HTTP_CONNECTION_TIMEOUT);
			
			loginedOkHttpClient = null;
			
			/* 認証用アドレス・パラメータ */
			RequestBody formBody = new FormBody.Builder()
	                .add("USER", loginUser)
	                .add("PASSWORD", loginPass)
	                .build();
	 
			/* ログイン処理 */
			Request request = new Request.Builder()
	                .url(loginURL)
	                .post(formBody)
	                .build();

			// 同期処理
			Response response;
			try {
				response = okHttpClient.newCall(request).execute();
				// ステータスコードの取得・・・「200」
				System.out.println(requestURL + " --> [status]:" + response.code());
	
				if (!response.isSuccessful()) {
					return null;
				}
				
				// 通信設定ページにアクセス
				request = new Request.Builder()
	                .url(requestURL)
	                .get()
	                .build();
				response = okHttpClient.newCall(request).execute();
				
				String commnSetBody = "";
				if (response.isSuccessful()) {
					// ボディの取得
					if (SgwMiniSetup.IS_SGW_PLUS || SgwMiniSetup.isUtf8Encode()) {
						commnSetBody = CommonFunc.convertInputStreamToString(response.body().byteStream(), "UTF-8");
					} else {
						commnSetBody = CommonFunc.convertInputStreamToString(response.body().byteStream(), "SJIS");
					}
					
					// ログインしたOkHttpClientを保持する
					if (IS_SGW_PLUS_V2 || IS_SGW_PLUS_V3 || IS_SGW_PLUS_V4) {
						loginedOkHttpClient = okHttpClient;
					}
		
					return commnSetBody;
		        }
				
			} catch (IOException e) {
				e.printStackTrace();
			}
			
		} else {
			// クライアントの生成
			//DefaultHttpClient client = SgwHttpClient.createHttpClientWithProxy(); //【＠Ver.2.04】：変更
			DefaultHttpClient client = SgwHttpClient.createHttpClientWithProxy(com.SgwSetting.common.CommonParam.HTTP_CONNECTION_TIMEOUT);
	
			loginedClient = null;
	
			try {
				/*認証ページを通過し、ログインページにアクセス*/
				// フォームパラメータの作成
				List<NameValuePair> formparams = new ArrayList<NameValuePair>();
				formparams.add(new BasicNameValuePair("USER", loginUser));
				formparams.add(new BasicNameValuePair("PASSWORD", loginPass));
				UrlEncodedFormEntity entity = new UrlEncodedFormEntity(formparams, "UTF-8");
	
				// HttpPostの生成
				HttpPost httppost = new HttpPost(loginURL);
	
				// HttpPostにパラメータをセットする。
				httppost.setEntity(entity);
	
				// HttpPOST実行
				HttpResponse res = client.execute(httppost);
	
				if (res.getEntity() != null) {
					// ボディの取得
					//System.out.println(EntityUtils.toString(res.getEntity(),"UTF-8"));
				} else {
					return null;
				}
	
				// エンティティの後処理（エンティティ内のInputStreamのクローズ処理）
				EntityUtils.consume(res.getEntity());
	
				// 通信設定ページにアクセス
				HttpGet httpget = new HttpGet(requestURL);
				HttpResponse res2 = null;
				res2 = client.execute(httpget);
	
				// ステータスコードの取得・・・「200」
				System.out.println(requestURL + " --> [status]:" + res2.getStatusLine().getStatusCode());
	
				// ヘッダの取得
				Header[] headers = res2.getAllHeaders();
				for (Header header : headers) {
					//System.out.println(header.getName() + ": " + header.getValue());
				}
	
				String commnSetBody = "";
				if (res2.getEntity() != null) {
					// ボディの取得
					//【＠Ver.2.04】：SGW-Plusか、エンコード指定がUTF-8の場合のみ、UTF-8でエンコード
					//          それ以外は、デフォールトのShift_JISでエンコード処理する
					if (SgwMiniSetup.IS_SGW_PLUS || SgwMiniSetup.isUtf8Encode()) {
						commnSetBody = EntityUtils.toString(res2.getEntity(), "UTF-8");
					} else {
						commnSetBody = EntityUtils.toString(res2.getEntity(), "SJIS");
					}
				}
				// エンティティの後処理（エンティティ内のInputStreamのクローズ処理)
				EntityUtils.consume(res2.getEntity());
	
				// ログインしたHttpClientを保持する
				if (IS_SGW_PLUS_V2 || IS_SGW_PLUS_V3 || IS_SGW_PLUS_V4) {
					loginedClient = client;
				}
	
				return commnSetBody;
	
			} catch (Exception e) {
				e.printStackTrace();
			} finally {
				if (loginedClient == null) {
					// コネクションを確実に終了させる
					client.getConnectionManager().shutdown();
				}
			}
		}
		
		return null;
	}

	/**
	 * スマートゲートウェイのタイプに設定する
	 *
	 * @param type
	 * @return なし
	 */
	public static void setSmartGatewayType(int type) {
		//CURRENT_SGW_TYPE = type;
		CommonParam.smartGatewayType = type;
		if (type == TYPE_SGW) {
			IS_SGW = true;
			IS_SGW_MINI = false;
			IS_SGW_PLUS = false;
			IS_SGW_PLUS_V2 = false;
			IS_SGW_PLUS_V3 = false;
			IS_SGW_PLUS_MC = false;
			IS_SGW_PLUS_V4 = false;
		} else if (type == TYPE_SGW_PLUS_V2) {
			IS_SGW = false;
			IS_SGW_MINI = false;
			IS_SGW_PLUS = true;
			IS_SGW_PLUS_V2 = true;
			IS_SGW_PLUS_V3 = false;
			IS_SGW_PLUS_MC = false;
			IS_SGW_PLUS_V4 = false;
		} else if (type == TYPE_SGW_PLUS_V3) {
			IS_SGW = false;
			IS_SGW_MINI = false;
			IS_SGW_PLUS = true;
			IS_SGW_PLUS_V2 = true;
			IS_SGW_PLUS_V3 = true;
			IS_SGW_PLUS_MC = false;
			IS_SGW_PLUS_V4 = false;
		} else if (type == TYPE_SGW_PLUS_MC) {
			IS_SGW = false;
			IS_SGW_MINI = false;
			IS_SGW_PLUS = true;
			IS_SGW_PLUS_V2 = true;
			IS_SGW_PLUS_V3 = true;
			IS_SGW_PLUS_MC = true;
			IS_SGW_PLUS_V4 = false;
		} else if (type == TYPE_SGW_PLUS_V4) {
			IS_SGW = false;
			IS_SGW_MINI = false;
			IS_SGW_PLUS = true;
			IS_SGW_PLUS_V2 = true;
			IS_SGW_PLUS_V3 = true;
			IS_SGW_PLUS_MC = false;
			IS_SGW_PLUS_V4 = true;
		} else if (type == TYPE_SGW_PLUS) {
			IS_SGW = false;
			IS_SGW_MINI = false;
			IS_SGW_PLUS = true;
			IS_SGW_PLUS_V2 = false;
			IS_SGW_PLUS_V3 = false;
			IS_SGW_PLUS_MC = false;
			IS_SGW_PLUS_V4 = false;
		} else if (type == TYPE_SGW_MINI) {
			IS_SGW = false;
			IS_SGW_MINI = true;
			IS_SGW_PLUS = false;
			IS_SGW_PLUS_V2 = false;
			IS_SGW_PLUS_V3 = false;
			IS_SGW_PLUS_MC = false;
			IS_SGW_PLUS_V4 = false;
		} else {
			IS_SGW = false;
			IS_SGW_MINI = false;
			IS_SGW_PLUS = false;
			IS_SGW_PLUS_V2 = false;
			IS_SGW_PLUS_V3 = false;
			IS_SGW_PLUS_MC = false;
			IS_SGW_PLUS_V4 = false;
		}
	}

	/**
	 * スマートゲートウェイの登録状況を設定する	【＠Ver.2.04】
	 *
	 * @param status
	 */
	public static void setSmartGatewayStatus(String status) {
		CommonParam.smartGatewayStatus = status;
	}

	/**
	 * スマートゲートウェイのエンコードがUTF-8かどうかを取得する	【＠Ver.2.04】
	 *
	 * @return スマートゲートウェイのエンコードがUTF-8かどうかを戻します。
	 */
	public static boolean isUtf8Encode() {
		return CommonParam.smartGatewayEncode.equals("UTF-8");
	}

}
